﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.Security;
using HP.ETL.Data;

namespace HP.ETL.Rules
{
	public partial class CreateJobBusinessRules : HP.ETL.Rules.SharedBusinessRules
    {
        
        /// <summary>
        /// This method will execute in any view before an action
        /// with a command name that matches "Select".
        /// </summary>
        [Rule("GetData")]
        public void GetDataImplementation(int? jobMasterID, string jobName, int? jobOrder, int? connectionMasterID, int? scheduleMasterID, int? TableTypeID,  int? flightMasterID, string vISNDatabaseVersion, string scheduleMasterName, string flightName)
        {
            ResultSet = CreateCreateJobDataTable();
        }
        
        private DataTable CreateCreateJobDataTable()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("JobMasterID", typeof(Int32));
            dt.Columns.Add("JobName", typeof(String));
            dt.Columns.Add("JobOrder", typeof(Int32));
            dt.Columns.Add("ConnectionMasterID", typeof(Int32));
            dt.Columns.Add("ScheduleMasterID", typeof(Int32));
            dt.Columns.Add("TableTypeID", typeof(Int32));
            dt.Columns.Add("FlightMasterID", typeof(Int32));
            dt.Columns.Add("VISNDatabaseVersion", typeof(String));
            dt.Columns.Add("ScheduleMasterName", typeof(String));
            dt.Columns.Add("FlightName", typeof(String));
            // 
            // Populate rows of table "dt" with data from any source (web service, file system, database, etc.)
            //
            dt.Rows.Add(-1, null, 1, null, null, null, null, null, null,null);

            return dt;
        }
    }
}
