﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.Security;
using HP.ETL.Data;

namespace HP.ETL.Rules
{
	public partial class FlightPackageMasterBusinessRules : HP.ETL.Rules.SharedBusinessRules
    {
        
        [ControllerAction("FlightPackageMaster", "Calculate", "UpdateDate")]
        public void CalculateFlightPackageMaster(
                    int? flightPackageMasterID, 
                    int? flightMasterID, 
                    string flightMasterFlightName, 
                    int? packageMasterID, 
                    string packageMasterPackageName, 
                    string packageMasterPackageSourceConnectionTypeConnectionTypeName, 
                    string packageMasterPackageDestinationConnectionTypeConnectionTypeName, 
                    int? flightExecutionOrder, 
                    int? sourceConnectionMasterID, 
                    string sourceConnectionMasterServerName, 
                    string sourceConnectionMasterConnectionTypeConnectionTypeName, 
                    string sourceConnectionMasterFacilityMasterVISNMasterVISNName, 
                    string sourceConnectionMasterSystemMasterSystemName, 
                    string sourceConnectionMasterSystemMasterVendorMasterVendorName, 
                    string sourceConnectionMasterSystemMasterSoftwareVersion, 
                    string sourceConnectionMasterVISNMasterVISNName, 
                    string sourceConnectionMasterConnectionStatusConnectionStatus, 
                    int? destinationConnectionMasterID, 
                    string destinationConnectionMasterServerName, 
                    string destinationConnectionMasterConnectionTypeConnectionTypeName, 
                    string destinationConnectionMasterFacilityMasterVISNMasterVISNName, 
                    string destinationConnectionMasterSystemMasterSystemName, 
                    string destinationConnectionMasterSystemMasterVendorMasterVendorName, 
                    string destinationConnectionMasterSystemMasterSoftwareVersion, 
                    string destinationConnectionMasterVISNMasterVISNName, 
                    string destinationConnectionMasterConnectionStatusConnectionStatus, 
                    byte? isEnabled, 
                    DateTime? createDate, 
                    DateTime? updateDate)
        {
            UpdateFieldValue("UpdateDate", DateTime.Now);
        }
        
        [RowBuilder("FlightPackageMaster", RowKind.New)]
        public void BuildNewFlightPackageMaster()
        {
            UpdateFieldValue("IsEnabled", 1);
        }
    }
}
