﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.ComponentModel;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;

namespace HP.ETL.Web
{
	public class AppPage
    {
        
        [System.Diagnostics.   uggerBrowsable(System.Diagnostics.   uggerBrowsableState.Never)]
        private string _name;
        
        [System.Diagnostics.   uggerBrowsable(System.Diagnostics.   uggerBrowsableState.Never)]
        private string _path;
        
        [System.Diagnostics.   uggerBrowsable(System.Diagnostics.   uggerBrowsableState.Never)]
        private string _description;
        
        public static AppPage[] Pages = new AppPage[] {
                new AppPage("Home", "^HomePath^Home^HomePath^", "^HomeDesc^Application home page^HomeDesc^"),
                new AppPage("FlightMaster", "Flight", "View Flight"),
                new AppPage("TableMaster", "Table", "View Table"),
                new AppPage("ConnectionMaster", "Connection", "View Connection"),
                new AppPage("ColumnMaster", "Column", "View Column"),
                new AppPage("RunMaster", "Run", "View Run"),
                new AppPage("JobMaster", "Job", "View Job"),
                new AppPage("FlightPackageMaster", "Flight Package", "View Flight Package"),
                new AppPage("PackageMaster", "Package", "View Package"),
                new AppPage("SystemMaster", "System", "View System"),
                new AppPage("VISNMaster", "VISN", "View VISN"),
                new AppPage("FacilityMaster", "Facility", "View Facility"),
                new AppPage("ConnectionType", "Connection Type", "View Connection Type"),
                new AppPage("ScheduleMaster", "Schedule", "View Schedule"),
                new AppPage("VendorMaster", "Vendor", "View Vendor"),
                new AppPage("ExceptionLogging", "Exception Logging", "View Exception Logging"),
                new AppPage("ExecutionCode", "Execution Code", "View Execution Code"),
                new AppPage("ExecutionLog", "Execution Log", "View Execution Log"),
                new AppPage("RunStatus", "Run Status", "View Run Status"),
                new AppPage("TaskFailureAction", "Task Failure Action", "View Task Failure Action"),
                new AppPage("TaskStatus", "Task Status", "View Task Status"),
                new AppPage("TaskMaster", "Task", "View Task"),
                new AppPage("TableType", "Table Type", "View Table Type"),
                new AppPage("ExecutionJobLog", "Execution Job Log", "View Execution Job Log"),
                new AppPage("ConnectionStatus", "Connection Status", "View Connection Status"),
                new AppPage("DetectedVendorVersionVW", "Detected Vendor Version VW", "View Detected Vendor Version VW"),
                new AppPage("DetectedVendorVersionColumnsVW", "Detected Vendor Version Columns VW", "View Detected Vendor Version Columns VW"),
                new AppPage("SQLUser", "SQL User", ""),
                new AppPage("CreateJob", "Create Job", ""),
                new AppPage("ViewJobExecution", "View Job Execution", ""),
                new AppPage("AddNewVersion", "Add New Version", "New a vendor changes tables or columns in there database a new version is created" +
                        ".  This is where that new version is approved or rejected.")};
        
        public AppPage(string name, string path, string description)
        {
            this.Name = name;
            this.Path = Regex.Replace(path, "\\^\\w+\\^", String.Empty);
            this.Description = description;
        }
        
        public string Name
        {
            get
            {
                return this._name;
            }
            set
            {
                this._name = value;
            }
        }
        
        public string Path
        {
            get
            {
                return this._path;
            }
            set
            {
                this._path = value;
            }
        }
        
        public string Description
        {
            get
            {
                return this._description;
            }
            set
            {
                this._description = value;
            }
        }
        
        public static AppPage Find(string name)
        {
            foreach (AppPage p in Pages)
            	if (p.Name == name)
                	return p;
            return null;
        }
    }
    
    [ToolboxItemAttribute(false)]
    public class AppSelector : System.Web.UI.Control
    {
        
        private HiddenField _hidden;
        
        public string ApplicationPage
        {
            get
            {
                return _hidden.Value;
            }
            set
            {
                _hidden.Value = value;
            }
        }
        
        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            _hidden = new HiddenField();
            _hidden.Value = ApplicationPage;
            _hidden.ID = "ApplicationPage";
            Controls.Add(_hidden);
        }
        
        protected override void CreateChildControls()
        {
            base.CreateChildControls();
            // render a list of available logical pages
            StringBuilder sb = new StringBuilder();
            HtmlTextWriter writer = new HtmlTextWriter(new StringWriter(sb));
            writer.AddAttribute(HtmlTextWriterAttribute.Type, "text/css");
            writer.RenderBeginTag(HtmlTextWriterTag.Style);
            writer.Write(@"
                        
.SPF_WebParts_AppEditorPart {margin-bottom:8px;}
.SPF_WebParts_AppEditorPart .Text {color:#000;}
.SPF_WebParts_AppEditorPart .PageList {height:250px;overflow:auto;border:solid 1px silver;background-color:#fff;padding:4px;margin-top:4px;}
.SPF_WebParts_AppEditorPart .PageList ul  {padding:0px;margin:0px;}
.SPF_WebParts_AppEditorPart .PageList ul li {list-style-type: none;padding:4px;border:solid 1px #fff;cursor:pointer;color:#000}
.SPF_WebParts_AppEditorPart .PageList ul li.Selected {background-color:#D1E6FF;border:solid 1px #84ACDD;}
.SPF_WebParts_AppEditorPart .PageList ul li:hover {background-color:#FFECB5;border:solid 1px #E5C365;}
.SPF_WebParts_AppEditorPart .Info {color:#000;margin-top:4px;border:solid 1px #000;background-color:#FFFFE1;padding:8px;min-height:30px;}
"");

                      ");
            writer.RenderEndTag();
            Page.ClientScript.RegisterClientScriptBlock(GetType(), "SPF_WebParts_AppEditorPart", @"
                        
function SPF_WebParts_AppEditorPart_Toggle(itemElem,propElem) {
    var list = itemElem.parentNode.childNodes;
    var v = document.getElementById(propElem).value = itemElem.getAttribute('value');
    var infoBox = itemElem.parentNode.parentNode.nextSibling;
    infoBox.innerHTML = itemElem.getAttribute('description');
    infoBox.style.display = '';
    for (var i = 0; i < list.length; i++)  {
        var peer = list[i];
        if (peer.className != null)
            peer.className = peer.getAttribute('value') == v ? 'Selected' : '';
    }
};

                      ", true);
            writer.AddAttribute(HtmlTextWriterAttribute.Type, "text/javascript");
            writer.RenderBeginTag(HtmlTextWriterTag.Script);
            writer.RenderEndTag();
            writer.AddAttribute(HtmlTextWriterAttribute.Class, "SPF_WebParts_AppEditorPart");
            writer.RenderBeginTag(HtmlTextWriterTag.Div);
            if (AppPage.Pages.Length == 0)
            	writer.Write("Application pages were not found.");
            else
            {
                AppPage selectedPage = AppPage.Find(ApplicationPage);
                if (selectedPage != null)
                {
                    writer.AddAttribute(HtmlTextWriterAttribute.Class, "Text");
                    writer.RenderBeginTag(HtmlTextWriterTag.Div);
                    writer.Write("Logical page <b>");
                    writer.WriteEncodedText(selectedPage.Path);
                    writer.Write("</b> is selected. ");
                    writer.WriteEncodedText(selectedPage.Description);
                    writer.Write(" <a href=\"javascript:\" onclick=\"this.parentNode.nextSibling.style.display=\'\';this" +
                            ".parentNode.style.display=\'none\';return false;\">Click here to change the page.</" +
                            "a>");
                    writer.RenderEndTag();
                }
                if (selectedPage != null)
                	writer.AddStyleAttribute("display", "none");
                writer.RenderBeginTag(HtmlTextWriterTag.Div);
                writer.Write("Please select a logical page.");
                writer.AddAttribute(HtmlTextWriterAttribute.Class, "PageList");
                writer.RenderBeginTag(HtmlTextWriterTag.Div);
                writer.RenderBeginTag(HtmlTextWriterTag.Ul);
                foreach (AppPage page in AppPage.Pages)
                {
                    if (page == selectedPage)
                    	writer.AddAttribute(HtmlTextWriterAttribute.Class, "Selected");
                    writer.AddAttribute(HtmlTextWriterAttribute.Onclick, String.Format("SPF_WebParts_AppEditorPart_Toggle(this, \'{0}\')", _hidden.ClientID, page.Name));
                    writer.AddAttribute("value", page.Name);
                    writer.AddAttribute("description", page.Description);
                    writer.RenderBeginTag(HtmlTextWriterTag.Li);
                    writer.WriteEncodedText(page.Path);
                    writer.RenderEndTag();
                }
                writer.RenderEndTag();
                writer.AddStyleAttribute(HtmlTextWriterStyle.Height, "4px");
                writer.RenderBeginTag(HtmlTextWriterTag.Div);
                writer.RenderEndTag();
                writer.RenderEndTag();
                if (selectedPage == null)
                	writer.AddStyleAttribute(HtmlTextWriterStyle.Display, "none");
                writer.AddAttribute(HtmlTextWriterAttribute.Class, "Info");
                writer.RenderBeginTag(HtmlTextWriterTag.Div);
                if (selectedPage != null)
                	writer.WriteEncodedText(selectedPage.Description);
                writer.RenderEndTag();
                writer.RenderEndTag();
            }
            writer.Close();
            Controls.Add(new LiteralControl(sb.ToString()));
        }
    }
}
