﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace HP.ETL.WebApp
{
	public partial class Host : System.Web.UI.MasterPage
    {
        
        [System.Diagnostics.   uggerBrowsable(System.Diagnostics.   uggerBrowsableState.Never)]
        private bool _settingsMode;
        
        private string _currentPage;
        
        private Web.AppSelector _selector;
        
        public bool SettingsMode
        {
            get
            {
                return this._settingsMode;
            }
            set
            {
                this._settingsMode = value;
            }
        }
        
        public string CurrentPage
        {
            get
            {
                if (_currentPage == null)
                {
                    _currentPage = Request.Params["_vpage"];
                    if (String.IsNullOrEmpty(_currentPage))
                    {
                        HttpCookie c = Request.Cookies["SharePointFactory_CurrentPage"];
                        if (c == null)
                        	_currentPage = String.Empty;
                        else
                        	_currentPage = c.Value;
                    }
                }
                return _currentPage;
            }
            set
            {
                _currentPage = value;
                HttpCookie c = new HttpCookie("SharePointFactory_CurrentPage", value);
                c.Expires = DateTime.Now.AddDays(7);
                Response.Cookies.Add(c);
            }
        }
        
        protected void Page_Init(object sender, EventArgs e)
        {
            _selector = new Web.AppSelector();
            SettingsPanel.Controls.AddAt(0, _selector);
        }
        
        private void HideSettingsPanel()
        {
            ContentPlaceHolder1.Visible = true;
            SettingsPanel.Visible = false;
            SettingsButton.Visible = true;
            PageTitle.InnerText = "Preview";
        }
        
        private void ShowSettingsPanel()
        {
            ContentPlaceHolder1.Visible = false;
            SettingsPanel.Visible = true;
            SettingsButton.Visible = false;
            PageTitle.InnerText = "Settings";
        }
        
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!(IsPostBack))
            	_selector.ApplicationPage = CurrentPage;
            if (SettingsMode)
            	ShowSettingsPanel();
        }
        
        protected virtual void SettingsButton_Click(object sender, EventArgs e)
        {
            ShowSettingsPanel();
        }
        
        protected virtual void CancelButton_Click(object sender, EventArgs e)
        {
            HideSettingsPanel();
        }
        
        protected virtual void UpdateButton_Click(object sender, EventArgs e)
        {
            CurrentPage = _selector.ApplicationPage;
            HideSettingsPanel();
            Page.ClientScript.RegisterClientScriptBlock(GetType(), "ReloadPage", "location.replace(location.href);", true);
        }
    }
}
