﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;

namespace HP.ETL.WebParts
{
	public partial class AppFeatureReceiver : AppFeatureReceiverBase
    {
    }
    
    public class AppFeatureReceiverBase : SPFeatureReceiver
    {
        
        public string AppConnectionStringModificationName = "add[@name=\"HP.ETL\"][@connectionString=\"Data Source=coffellr2;Initial Catalog=ETL;" +
            "Integrated Security=True;\"][@providerName=\"System.Data.SqlClient\"]";
        
        public string AppConnectionString = "<add name=\"HP.ETL\" connectionString=\"Data Source=coffellr2;Initial Catalog=ETL;In" +
            "tegrated Security=True;\" providerName=\"System.Data.SqlClient\" />";
        
        public virtual string ModificationOwnerName
        {
            get
            {
                return "HP.ETL Web App";
            }
        }
        
        public override void FeatureActivated(SPFeatureReceiverProperties properties)
        {
            SPWebService service = SPWebService.ContentService;
            // make sure that "connectionStrings" node exists in configuration
            SPWebConfigModification modification = new SPWebConfigModification();
            modification.Path = "configuration";
            modification.Name = "connectionStrings";
            modification.Sequence = 0;
            modification.Owner = ModificationOwnerName;
            modification.Type = SPWebConfigModification.SPWebConfigModificationType.EnsureChildNode;
            modification.Value = "<connectionStrings/>";
            if (!(service.WebConfigModifications.Contains(modification)))
            {
                service.WebConfigModifications.Add(modification);
                service.Update();
                service.ApplyWebConfigModifications();
            }
            // add application connection string to web.config
            modification = new SPWebConfigModification();
            modification.Path = "configuration/connectionStrings";
            modification.Name = AppConnectionStringModificationName;
            modification.Sequence = 0;
            modification.Owner = ModificationOwnerName;
            modification.Type = SPWebConfigModification.SPWebConfigModificationType.EnsureChildNode;
            modification.Value = AppConnectionString;
            if (!(service.WebConfigModifications.Contains(modification)))
            {
                service.WebConfigModifications.Add(modification);
                service.Update();
                service.ApplyWebConfigModifications();
            }
        }
        
        public override void FeatureDeactivating(SPFeatureReceiverProperties properties)
        {
            SPWebService service = SPWebService.ContentService;
            foreach (SPWebConfigModification modification in service.WebConfigModifications)
            	if ((modification.Name == AppConnectionStringModificationName) && (modification.Owner == ModificationOwnerName))
                {
                    try
                    {
                        service.WebConfigModifications.Remove(modification);
                        service.Update();
                        service.ApplyWebConfigModifications();
                    }
                    catch (Exception )
                    {
                    }
                    break;
                }
            using (SPSite site = ((SPSite)(properties.Feature.Parent)))
            	using (SPWeb web = site.RootWeb)
                {
                    SPList list = web.Lists["Web Part Gallery"];
                    foreach (SPListItem part in list.Items)
                    	if (part.Name.Equals("HP.ETL_AppWebPart.webpart", StringComparison.CurrentCultureIgnoreCase))
                        {
                            part.Delete();
                            break;
                        }
                }
        }
    }
}
