﻿

CREATE PROCEDURE [RTLS_NDRDW].[AddNewVersion] 
	@NewSystemMaster INT, 
	@OldSystemMaster INT,
	@ConnectionMaster INT
	AS
Begin
	If @OldSystemMaster = 0  --No old version to base things off of. 
	Begin 
		Begin Try
		Begin Transaction 	
		----Copy to TableMaster from GetCurrentMetaData
		Insert Into RTLS_NDRDW.TableMaster 
		  (	   [ConnectionMasterID]
			  ,[SystemMasterID]
			  ,[FlightMasterID]
			  ,[TableTypeID]
			  ,[TableName]
			  ,[TableOrderSeq]
			  ,[LastProcessDate]
			  ,[IsEnabled]
			  ,[FilterColumns]
			  ,[FilterValues]
			  ,[CreateDate]
			  ,[UpdateDate] 
		  )
		Select  
		   ConnectionMasterID
		  ,SystemMasterID
		  ,FlightMasterID
		  ,TableTypeID 
		  ,TableName
		  ,row_number() over (order by (select NULL)) TableOrderSeq
		  ,LastProcessedDate
		  ,IsEnabled
		  ,FilterColumns
		  ,FilterValues 
		  ,CreateDate
		  ,UpdateDate
		  From ( 
		SELECT DISTINCT 
		   RTLS_NDRDW.ConnectionMaster.ConnectionMasterID
		  ,RTLS_NDRDW.CurrentMetadataExtract.SystemMasterID
		  , -1 FlightMasterID
		  , -1 TableTypeID 
		  ,RTLS_NDRDW.CurrentMetadataExtract.TableName
		  --,row_number() over (order by (select NULL)) --TableOrderSeq
		  ,Null LastProcessedDate
		  ,1 IsEnabled
		  ,Null FilterColumns
		  ,Null FilterValues 
		  ,getdate() CreateDate
		  ,getdate() UpdateDate
		FROM RTLS_NDRDW.ConnectionMaster 
			 INNER JOIN RTLS_NDRDW.CurrentMetadataExtract ON RTLS_NDRDW.ConnectionMaster.SystemMasterID = RTLS_NDRDW.CurrentMetadataExtract.SystemMasterID 
		--	 INNER JOIN RTLS_NDRDW.ETLMetadataIncrementalChanges ON RTLS_NDRDW.ETLMetadataIncrementalChanges.CurrentMetadataExtractID = RTLS_NDRDW.CurrentMetadataExtract.CurrentMetadataExtractID
		where RTLS_NDRDW.ConnectionMaster.ConnectionMasterID = @ConnectionMaster
		 -- and RTLS_NDRDW.ConnectionMaster.SystemMasterID= @NewSystemMaster
 		  and RTLS_NDRDW.CurrentMetadataExtract.SystemMasterID = @NewSystemMaster
		--  and RTLS_NDRDW.ETLMetadataIncrementalChanges.ConnectionMasterID = @ConnectionMaster 
		  and RTLS_NDRDW.CurrentMetadataExtract.TableName Is Not Null ) tmp
		 Order by TableName
         Select @@RowCount 
		
		--Copy to ColumnMaster from GetCurrentMetaData
		Insert Into RTLS_NDRDW.ColumnMaster
	    (
		   [TableMasterID]
		  ,[ColumnName]
		  ,[ColumnType]
		  ,[ColumnOrder]
		  ,[KeyType]
		  ,[IsEnabled]
		  ,[IsPHI]
		  ,[IsPII]
		  ,[CreateDate]
		  ,[UpdateDate]
	    )
		SELECT 
			RTLS_NDRDW.TableMaster.TableMasterID
		   ,RTLS_NDRDW.CurrentMetadataExtract.ColumnName
		   ,RTLS_NDRDW.CurrentMetadataExtract.DataType
		   ,RTLS_NDRDW.CurrentMetadataExtract.ColumnOrder
		   ,null --KeyType Need to define where this comes from. 
		   ,1 as IsEnabled
		   ,0 as IsPHI
		   ,0 as IsPII
		   ,getdate() as CreateDate
		   ,getdate() as UpdateDate
		FROM RTLS_NDRDW.CurrentMetadataExtract 
			INNER JOIN RTLS_NDRDW.TableMaster 
			   ON RTLS_NDRDW.CurrentMetadataExtract.SystemMasterID = RTLS_NDRDW.TableMaster.SystemMasterID 
				AND RTLS_NDRDW.CurrentMetadataExtract.TableName = RTLS_NDRDW.TableMaster.TableName
		--    INNER JOIN RTLS_NDRDW.ETLMetadataIncrementalChanges ON RTLS_NDRDW.ETLMetadataIncrementalChanges.CurrentMetadataExtractID = RTLS_NDRDW.CurrentMetadataExtract.CurrentMetadataExtractID
	
		Where RTLS_NDRDW.CurrentMetadataExtract.SystemMasterID  = @NewSystemMaster
			--AND RTLS_NDRDW.ETLMetadataIncrementalChanges.ConnectionMasterID = @ConnectionMaster 
			AND RTLS_NDRDW.CurrentMetadataExtract.TableName Is Not Null 
		Order by RTLS_NDRDW.CurrentMetadataExtract.TableName
		Select @@RowCount 
	    COMMIT TRANSACTION;	
	 End Try 
     BEGIN CATCH
		PRINT ERROR_MESSAGE()
	    --	EXEC [RTLS_NDRDW].[ExecutionLogError] @ExecutionLogID=@ExecutionLogID
		IF @@TRANCOUNT > 0
			ROLLBACK TRANSACTION;
	  END CATCH
	END 
	ELse
	Begin 
		-- OldSystemMasterID !=0 so we create the new records using the old data when possible. 
		Begin Try
		Begin Transaction 	
		
			--Inserting Matching records for Tables from Previous SystemMasterID. Deleted Tables do not exist in CurrentMDD are not inserted. 
			Insert Into RTLS_NDRDW.TableMaster 
					  (	   [ConnectionMasterID]
						  ,[SystemMasterID]
						  ,[FlightMasterID]
						  ,[TableTypeID]
						  ,[TableName]
						  ,[TableOrderSeq]
						  ,[LastProcessDate]
						  ,[IsEnabled]
						  ,[FilterColumns]
						  ,[FilterValues]
						  ,[CreateDate]
						  ,[UpdateDate] 
					  )
					 SELECT DISTINCT 
					   RTLS_NDRDW.ConnectionMaster.ConnectionMasterID
					  ,@NewSystemMaster
					  ,RTLS_NDRDW.TableMaster.FlightMasterID
					  ,RTLS_NDRDW.TableMaster.TableTypeID 
					  ,RTLS_NDRDW.CurrentMetadataExtract.TableName
					  ,RTLS_NDRDW.TableMaster.TableOrderSeq
					  ,RTLS_NDRDW.TableMaster.LastProcessDate
					  ,RTLS_NDRDW.TableMaster.IsEnabled
					  ,RTLS_NDRDW.TableMaster.FilterColumns
					  ,RTLS_NDRDW.TableMaster.FilterValues 
					  ,RTLS_NDRDW.TableMaster.CreateDate
					  ,getdate() UpdateDate
					FROM RTLS_NDRDW.ConnectionMaster 
						 INNER JOIN RTLS_NDRDW.CurrentMetadataExtract ON RTLS_NDRDW.ConnectionMaster.SystemMasterID = RTLS_NDRDW.CurrentMetadataExtract.SystemMasterID and RTLS_NDRDW.CurrentMetadataExtract.SystemMasterID = @NewSystemMaster --and RTLS_NDRDW.CurrentMetadataExtract.ConnectionMasterID = @ConnectionMaster 
						 INNER JOIN RTLS_NDRDW.TableMaster ON RTLS_NDRDW.TableMaster.SystemMasterID = @OldSystemMaster and RTLS_NDRDW.TableMaster.SystemMasterID = @OldSystemMaster and RTLS_NDRDW.TableMaster.ConnectionMasterID = @ConnectionMaster and RTLS_NDRDW.CurrentMetadataExtract.TableName = RTLS_NDRDW.TableMaster.TableName
					where RTLS_NDRDW.ConnectionMaster.ConnectionMasterID = @ConnectionMaster
					  and RTLS_NDRDW.ConnectionMaster.SystemMasterID= @OldSystemMaster
 					  and RTLS_NDRDW.CurrentMetadataExtract.TableName Is Not Null  
				    Order by RTLS_NDRDW.CurrentMetadataExtract.TableName

			--Inserting Non-Matching records for Tables that are new.
			Insert Into RTLS_NDRDW.TableMaster 
					  (	   [ConnectionMasterID]
						  ,[SystemMasterID]
						  ,[FlightMasterID]
						  ,[TableTypeID]
						  ,[TableName]
						  ,[TableOrderSeq]
						  ,[LastProcessDate]
						  ,[IsEnabled]
						  ,[FilterColumns]
						  ,[FilterValues]
						  ,[CreateDate]
						  ,[UpdateDate] 
					  )
					  Select  
					   ConnectionMasterID
					  ,SystemMasterID
					  ,FlightMasterID
					  ,TableTypeID 
					  ,TableName
					  ,coalesce((select max(TableOrderSeq) from RTLS_NDRDW.TableMaster where ConnectionMasterID = @ConnectionMaster and SystemMasterID = @NewSystemMaster ) , 0) +row_number() over (order by (select NULL)) TableOrderSeq
 					  ,LastProcessedDate
					  ,IsEnabled
					  ,FilterColumns
					  ,FilterValues 
					  ,CreateDate
					  ,UpdateDate
					From ( 
					SELECT DISTINCT 
					  RTLS_NDRDW.ConnectionMaster.ConnectionMasterID
					  ,RTLS_NDRDW.CurrentMetadataExtract.SystemMasterID
					  , -1 FlightMasterID
					  , -1 TableTypeID 
					  ,RTLS_NDRDW.CurrentMetadataExtract.TableName
--					  ,coalesce((select max(TableOrderSeq) from RTLS_NDRDW.TableMaster where ConnectionMasterID = @ConnectionMaster and SystemMasterID = @NewSystemMaster ) , 0) +row_number() over (order by (select NULL)) --TableOrderSeq
					  ,Null LastProcessedDate
					  ,1 IsEnabled
					  ,Null FilterColumns
					  ,Null FilterValues 
					  ,getdate() CreateDate
					  ,getdate() UpdateDate
					FROM RTLS_NDRDW.ConnectionMaster 
						 INNER JOIN RTLS_NDRDW.CurrentMetadataExtract ON RTLS_NDRDW.ConnectionMaster.SystemMasterID = RTLS_NDRDW.CurrentMetadataExtract.SystemMasterID
					where RTLS_NDRDW.ConnectionMaster.ConnectionMasterID = @ConnectionMaster
					  and RTLS_NDRDW.ConnectionMaster.SystemMasterID= @NewSystemMaster
 					  and RTLS_NDRDW.CurrentMetadataExtract.SystemMasterID = @NewSystemMaster
					  --and RTLS_NDRDW.CurrentMetadataExtract.ConnectionMasterID = @ConnectionMaster 
					  and RTLS_NDRDW.CurrentMetadataExtract.TableName Is Not Null 
					  and not Exists ( select 'x' from RTLS_NDRDW.TableMaster Where RTLS_NDRDW.TableMaster.SystemMasterID = @OldSystemMaster and RTLS_NDRDW.TableMaster.ConnectionMasterID = @ConnectionMaster and RTLS_NDRDW.CurrentMetadataExtract.TableName = RTLS_NDRDW.TableMaster.TableName )
					  ) tmp
					 Order by TableName
 
			 --Insert matching columns from MDD to columnMaster with new SystemMasterID 
			 Insert Into RTLS_NDRDW.ColumnMaster
			(
			   [TableMasterID]
			  ,[ColumnName]
			  ,[ColumnType]
			  ,[ColumnOrder]
			  ,[KeyType]
			  ,[IsEnabled]
			  ,[IsPHI]
			  ,[IsPII]
			  ,[CreateDate]
			  ,[UpdateDate]
			)
			SELECT 
				RTLS_NDRDW.TableMaster.TableMasterID
			   ,RTLS_NDRDW.CurrentMetadataExtract.ColumnName
			   ,RTLS_NDRDW.CurrentMetadataExtract.DataType
			   ,RTLS_NDRDW.CurrentMetadataExtract.ColumnOrder
			   ,RTLS_NDRDW.ColumnMaster.KeyType  
			   ,RTLS_NDRDW.ColumnMaster.IsEnabled
			   ,RTLS_NDRDW.ColumnMaster.IsPHI
			   ,RTLS_NDRDW.ColumnMaster.IsPII
			   ,RTLS_NDRDW.ColumnMaster.CreateDate
			   ,getdate() as UpdateDate
			   FROM RTLS_NDRDW.CurrentMetadataExtract 
				INNER JOIN RTLS_NDRDW.TableMaster 
				   ON RTLS_NDRDW.CurrentMetadataExtract.SystemMasterID = RTLS_NDRDW.TableMaster.SystemMasterID 
					AND RTLS_NDRDW.CurrentMetadataExtract.TableName = RTLS_NDRDW.TableMaster.TableName
				INNER JOIN RTLS_NDRDW.ColumnMaster 
				   ON RTLS_NDRDW.ColumnMaster.ColumnName = RTLS_NDRDW.CurrentMetadataExtract.ColumnName 
					AND RTLS_NDRDW.ColumnMaster.TableMasterID = RTLS_NDRDW.TableMaster.TableMasterID
			Where RTLS_NDRDW.CurrentMetadataExtract.SystemMasterID  = @NewSystemMaster
				--AND RTLS_NDRDW.CurrentMetadataExtract.ConnectionMasterID = @ConnectionMaster
				AND RTLS_NDRDW.CurrentMetadataExtract.TableName Is Not Null 
			Order by RTLS_NDRDW.CurrentMetadataExtract.TableName

			--Insert Non-matching columns into ColumnMaster from the MDD.
			Insert Into RTLS_NDRDW.ColumnMaster
			(
			   [TableMasterID]
			  ,[ColumnName]
			  ,[ColumnType]
			  ,[ColumnOrder]
			  ,[KeyType]
			  ,[IsEnabled]
			  ,[IsPHI]
			  ,[IsPII]
			  ,[CreateDate]
			  ,[UpdateDate]
			)
			SELECT 
				RTLS_NDRDW.TableMaster.TableMasterID
			   ,RTLS_NDRDW.CurrentMetadataExtract.ColumnName
			   ,RTLS_NDRDW.CurrentMetadataExtract.DataType
			   ,RTLS_NDRDW.CurrentMetadataExtract.ColumnOrder
			   ,null --KeyType Need to define where this comes from. 
			   ,1 as IsEnabled
			   ,0 as IsPHI
			   ,0 as IsPII
			   ,getdate() as CreateDate
			   ,getdate() as UpdateDate
			FROM RTLS_NDRDW.CurrentMetadataExtract 
				INNER JOIN RTLS_NDRDW.TableMaster 
				   ON RTLS_NDRDW.CurrentMetadataExtract.SystemMasterID = RTLS_NDRDW.TableMaster.SystemMasterID 
					AND RTLS_NDRDW.CurrentMetadataExtract.TableName = RTLS_NDRDW.TableMaster.TableName
			Where RTLS_NDRDW.CurrentMetadataExtract.SystemMasterID  = @NewSystemMaster
				--AND RTLS_NDRDW.CurrentMetadataExtract.ConnectionMasterID = @ConnectionMaster 
				AND RTLS_NDRDW.CurrentMetadataExtract.TableName Is Not Null 
				and not exists ( Select 'x' 
									from RTLS_NDRDW.ColumnMaster 
									Where RTLS_NDRDW.ColumnMaster.ColumnName = RTLS_NDRDW.CurrentMetadataExtract.ColumnName 
									AND RTLS_NDRDW.ColumnMaster.TableMasterID = RTLS_NDRDW.TableMaster.TableMasterID )
			Order by RTLS_NDRDW.CurrentMetadataExtract.TableName		 
		 COMMIT TRANSACTION;	
		 END TRY
		 BEGIN CATCH
			PRINT ERROR_MESSAGE()
			--	EXEC [RTLS_NDRDW].[ExecutionLogError] @ExecutionLogID=@ExecutionLogID
			IF @@TRANCOUNT > 0
				ROLLBACK TRANSACTION;
		  END CATCH
	END 
  
END


