﻿
--
-- hardcoded for [NDRDW].[Framework]
--
CREATE PROCEDURE [RTLS_NDRDW].[ExecutionLogCreate] 
	@VISNMasterID INT
	, @JobMasterID INT
	, @ExecutionJobLogID INT
AS
BEGIN
DECLARE @dt DATETIME
SET @dt = GETDATE()

	INSERT INTO [RTLS_NDRDW].[ExecutionLog]
           (
[VISNMasterID]
, [JobMasterID]
, [RunMasterID]
, [FlightMasterID]
, [SystemMasterID]
, [TableMasterID]
, [TaskMasterID]
, [PackageMasterID]
, [PrecedentTask]
, [ExecutionOrder]
, [ExecutionJobLogID]

		   ----[TaskMasterID]
     ----      ,[VISNMasterID]
     ----      ,[SystemMasterID]
     ----      ,[JobMasterID]
     ----      ,[RunMasterID]
     ----      ,[FlightMasterID]
     ----      ,[TableMasterID]
     ----      ,[PackageMasterID]
     ----      ,[PrecedentTask]
     ----      ,[ExecutionOrder]
     ----      ,[ExecutionJobLogID]
           --,[execution_id]
           --,[ExecutionLogStart]
           --,[ExecutionLogStop]
           --,[ExecutionLogStatusID]
           --,[ExecutionLogRowsProcessed]
           --,[ExecutionLogBytesTransferred]
		   )


SELECT
	[a].[VISNMasterID]
	, [b].[JobMasterID]
	, [c].[RunMasterID]
	, [d].[FlightMasterID]
	, [e].[SystemMasterID]
	, [e].[TableMasterID]
	, [f].[TaskMasterID]
	, [g].[PackageMasterID]
	, [f].[PrecedentTask]
	, [f].[ExecutionOrder]
	, @ExecutionJobLogID

FROM [RTLS_NDRDW].[VISNMaster] [a]
JOIN [RTLS_NDRDW].[JobMaster] [b] ON [b].[JobMasterID] = @JobMasterID
JOIN [RTLS_NDRDW].[RunMaster] [c] ON [b].[JobMasterID] = [c].[JobMasterID]
JOIN [RTLS_NDRDW].[FlightMaster] [d] ON [d].[FlightMasterID] = [c].[FlightMasterID]
JOIN [RTLS_NDRDW].[TableMaster] [e] ON [e].[TableMasterID] = [c].[TableMasterID]
JOIN [RTLS_NDRDW].[TaskMaster] [f] ON [f].[RunMasterID] = [c].[RunMasterID]
JOIN [RTLS_NDRDW].[PackageMaster] [g] ON [g].[PackageMasterID] = [f].[PackageMasterID]
WHERE [a].[VISNMasterID] = @VISNMasterID



	--SELECT 
	--[a].[TaskMasterID]
	--, @VISNMasterID -- [b].[VISNMasterID]
	--,[c].[SystemMasterID]
	--,[d].[JobMasterID]
	--,[e].[RunMasterID]
	--,[f].[FlightMasterID]
	--,[g].[TableMasterID]
	--,[h].[PackageMasterID]
	--,[a].[PrecedentTask]
	--,[a].[ExecutionOrder]
	--, @ExecutionJobLogID


	--FROM [RTLS_NDRDW].[TaskMaster] [a]
	--JOIN [RTLS_NDRDW].[VISNMaster] [b] ON [a].[VISNMasterID] = [b].[VISNMasterID]
	--JOIN [RTLS_NDRDW].[SystemMaster] [c] ON [a].[SystemMasterID] = [c].[SystemMasterID]
	--JOIN [RTLS_NDRDW].[JobMaster] [d] ON [a].[JobMasterID] = [d].[JobMasterID]
	--JOIN [RTLS_NDRDW].[RunMaster] [e] ON [a].[RunMasterID] = [e].[RunMasterID]
	--JOIN [RTLS_NDRDW].[FlightMaster] [f] ON [a].[FlightMasterID] = [f].[FlightMasterID]
	--JOIN [RTLS_NDRDW].[TableMaster] [g] ON [a].[TableMasterID] = [g].[TableMasterID]
	--JOIN [RTLS_NDRDW].[PackageMaster] [h] ON [a].[PackageMasterID] = [h].[PackageMasterID]
	---- source
	--JOIN [RTLS_NDRDW].[ConnectionType] [i] ON [a].[PackageSourceConnectionTypeID] = [i].[ConnectionTypeID]
	--JOIN [RTLS_NDRDW].[ConnectionMaster] [j] ON [a].[PackageSourceConnectionTypeID] = [j].[ConnectionTypeID]
	--	AND [a].[VISNMasterID] = [j].[VISNMasterID]
	--	AND [a].[SystemMasterID] = [j].[SystemMasterID] -- will fail for ConnectionTypeID other than 5
	---- destination
	--JOIN [RTLS_NDRDW].[ConnectionType] [k] ON [a].[PackageDestinationConnectionTypeID] = [k].[ConnectionTypeID]
	--JOIN [RTLS_NDRDW].[ConnectionMaster] [l] ON [a].[PackageDestinationConnectionTypeID] = [l].[ConnectionTypeID]
	--	AND [a].[VISNMasterID] = [l].[VISNMasterID]
	--	-- AND [a].[SystemMasterID] = [l].[SystemMasterID] -- probably need case stmt


	--WHERE [a].[JobMasterID] = @JobMasterID

	--ORDER BY [a].[JobMasterID], [a].[ExecutionOrder]
  

  
END
