﻿
Create PROCEDURE [RTLS_NDRDW].[VersionAcceptReject] 
       @VersionID INT, 
       @ConnectionMasterID INT,
       @AcceptOrReject char(1) 
       AS
Begin
       If @AcceptOrReject = 'A' --Accept Changes 
       Begin 
             Begin Try
             Begin Transaction

               Update [RTLS_NDRDW].[ETLMetadataIncrementalChanges]  SET  [IsPulledByMetaTool] = 1 Where SystemMasterID = @VersionID and ConnectionMasterID = @ConnectionMasterID

               Declare @OldSystemMasterID int 
               SET @OldSystemMasterID = ( Select SystemMasterID from  [RTLS_NDRDW].[ConnectionMaster] where ConnectionMasterID = @ConnectionMasterID ) 
               EXEC  [RTLS_NDRDW].[AddNewVersion]   @VersionID,  @OldSystemMasterID,  @ConnectionMasterID
               Update [RTLS_NDRDW].[ConnectionMaster] Set SystemMasterID = @VersionID  where ConnectionMasterID = @ConnectionMasterID  
               Commit Transaction;
             End Try 
             BEGIN CATCH
                    --set @Result_Focus = ERROR_MESSAGE()
                    IF @@TRANCOUNT > 0
                    ROLLBACK TRANSACTION;
             END CATCH 

       END 
       
       If @AcceptOrReject = 'R' --Accept Changes 
       Begin 
             Begin Try
             Begin Transaction

               Update [RTLS_NDRDW].[ETLMetadataIncrementalChanges]  SET  [IsPulledByMetaTool] = 1 Where SystemMasterID = @VersionID and ConnectionMasterID = @ConnectionMasterID
              Commit Transaction;
             End Try 
             BEGIN CATCH
                    --set @Result_Focus = ERROR_MESSAGE()
                    IF @@TRANCOUNT > 0
                    ROLLBACK TRANSACTION;
             END CATCH 

       END   
END


