﻿-- =============================================
-- Author:		Michael D. Hanson
--				HPES
--				michael.d.hanson@hp.com
-- Create date: 01/15/2015
-- Description:	creates an aggregate on Historical
--				disk space usage
-- =============================================
CREATE PROCEDURE [RTLS_NDRDW].[rptAggregeteDiskSpaceHistory] --'04/17/2015', '04/18/2015'
	@StartDate datetime = NULL,
	@EndDate datetime = NULL
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;
	IF @StartDate is NULL
	BEGIN
		SET @StartDate = GetDate() - 30
	END
	IF @EndDate is NULL
	BEGIN
		SET @EndDate = GetDate()
	END
	select	cast(pulldate as smalldatetime) as DatePulled
			, count(dbname) as NumberDatabases
			, Sum(space_used_mb)/1024 as DiskSpaceUsedGB
			, Sum(PercDiskUsed) as PercentDiskSpaceUsed
			, Avg(TotalDiskSpaceMB)/1024 as TotalDiskSpaceGB
			, Min(AvailDiskSpaceMB)/1024 as AvailDiskSpaceGB
	from [RTLS_NDRDW].[rptDatabaseDiskSpaceHistory]
	where pulldate between @StartDate and @EndDate
	group by PullDate
END

