﻿
CREATE procedure [RTLS_NDRDW].[rptCaptureCPU_UtilData] as 
BEGIN

DECLARE @ts_now bigint = (SELECT cpu_ticks/(cpu_ticks/ms_ticks)FROM sys.dm_os_sys_info); 
with CPUData as
(

SELECT TOP(256) SQLProcessUtilization AS [SQLCPUUtilization]
				,SystemIdle AS [SystemIdleProcess]
				,100 - SystemIdle - SQLProcessUtilization AS [SystemCPUUtilization]
				,100 - SystemIdle AS [TotalCPUUtilization]
				,DATEADD(ms, -1 * (@ts_now - [timestamp]), GETDATE()) AS [EventTime] 
FROM ( 
	  SELECT record.value('(./Record/@id)[1]', 'int') AS record_id, 
			record.value('(./Record/SchedulerMonitorEvent/SystemHealth/SystemIdle)[1]', 'int') 
			AS [SystemIdle], 
			record.value('(./Record/SchedulerMonitorEvent/SystemHealth/ProcessUtilization)[1]', 'int') 
			AS [SQLProcessUtilization], [timestamp] 
	  FROM ( 
			SELECT [timestamp], CONVERT(xml, record) AS [record] 
			FROM sys.dm_os_ring_buffers WITH (NOLOCK)
			WHERE ring_buffer_type = N'RING_BUFFER_SCHEDULER_MONITOR' 
			AND record LIKE N'%<SystemHealth>%') AS x 
	  ) AS y )
INSERT INTO [RTLS_NDRDW].[rptCPUUtilizationHistory]
select CAST(CONVERT(CHAR(17), EventTime, 113) AS datetime) as EventTime
	,SystemCPUUtilization
	,SQLCPUUtilization
	,SystemIdleProcess
	,TotalCPUUtilization
--INTO ssisdb.dbo.CPUUtilization
from CPUData c
where CAST(CONVERT(CHAR(17), EventTime, 113) AS datetime) > 
   (select isnull(max(EventTime),getdate()-1) from [RTLS_NDRDW].[rptCPUUtilizationHistory])
order by EventTime DESC
END


