﻿
-- =============================================
-- Author:		Michael D. Hanson
-- Create date: 01/08/2015
-- Description:	get KPI data for report
-- =============================================
CREATE PROCEDURE [RTLS_NDRDW].[rptETLKPIData] --'09/01/2014', '04/15/2015'
@StartDate as datetime,
@EndDate as datetime
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	select 'Average Run Time (minutes)' as Indicator
			,avg(datediff(mi, start_time, end_time)) as stat
			,2 as KPI
	from  [SSISDB].[internal].[execution_info] 
	Where start_time >= @StartDate and end_time <= @EndDate 
		AND folder_name like 'RLTS%'
	UNION
	select 'Max Run Time (minutes)' as Indicator
			,max(datediff(mi, start_time, end_time)) as stat
			,case 
				when max(datediff(mi, start_time, end_time)) >= 10 then 3
				when max(datediff(mi, start_time, end_time)) > 5 and max(datediff(mi, start_time, end_time)) < 10 then 2
				else 1
			 end as KPI

	from  [SSISDB].[internal].[execution_info] 
	Where start_time >= @StartDate and end_time <= @EndDate 
		AND folder_name like 'RLTS%'
	UNION
	select 'Number Failed Jobs' as Indicator
			,count(status) as stat
			,case
				when count(status) >= 100 then 3
				when count(status) > 20 and count(status) < 100 then 2
				else 1
			end as KPI
	from  [SSISDB].[internal].[execution_info] 
	where status = 4 and
		start_time >= @StartDate and end_time <= @EndDate 
		AND folder_name like 'RLTS%'
	UNION
	select 'Number Successful Jobs' as Indicator
			,count(status) as stat
			, 1 as KPI
	from  [SSISDB].[internal].[execution_info] 
	where status in (7, 8) and
		start_time >= @StartDate and end_time <= @EndDate 
		AND folder_name like 'RLTS%'
	UNION
	select 'Number Jobs still running' as Indicator
			,count(status) as stat
			,case 
				when count(status) > 0 then 3
				else 1
			end as KPI
	from  [SSISDB].[internal].[execution_info] 
	where status = 2
	and start_time >= @StartDate and end_time <= @EndDate 
	AND folder_name like 'RLTS%'

END

