﻿

-- =============================================
-- Author:		Michael D. Hanson
-- Create date: 04-15-2015
-- Description:	Gets SSISDB Parameter Info 
--				for ETL Dashboard Report
-- Parameters:  @ovrExecutionID: execution ID
--				for SSISDB catalog information
-- =============================================
CREATE PROCEDURE [RTLS_NDRDW].[rptExecutionMsgEnvironment] --'63198'
	-- Add the parameters for the stored procedure here
	@ExecutionID int 

AS

WITH ref AS
(
	SELECT
		[execution_id]
		,'' AS [environment_scope]
		,[reference_id]
		,[reference_type]
		,[environment_folder_name]
		,[environment_name]
	FROM
		[SSISDB].[internal].[executions]
UNION ALL
	SELECT
		v.[validation_id] AS [execution_id]
		,v.environment_scope AS [environment_scope]
		,r.[reference_id]
		,r.[reference_type]
		,r.[environment_folder_name]
		,r.[environment_name]
	FROM
		[SSISDB].[internal].[environment_references] r RIGHT JOIN [SSISDB].[internal].[validations] v ON r.[reference_id] = v.[reference_id]
)
SELECT
	CASE WHEN [environment_scope] = 'A' OR [environment_scope] = 'a' THEN 1 ELSE 0 END AS envScope,
	CASE WHEN [reference_id] IS NULL THEN '-' ELSE 
		(CASE WHEN [reference_type] = 'R' OR [reference_type] = 'r' THEN '.' ELSE [environment_folder_name] END) + '\' + [environment_name]
	END  AS env
FROM [ref]
WHERE [execution_id] = @ExecutionID
