﻿

--
--
--
CREATE PROCEDURE [RTLS_NDRDW].[rptExecutionStatusReport] --'04/01/2015', '04/16/2015'
@StartDate as DateTime,
@EndDate as DateTime

AS
BEGIN
SELECT 
	[a].[ExecutionJobLogID]
	, [c].[ExecutionJobLogStart]
	, [b].[JobMasterID]
	, [b].[JobMasterName]

	, CASE WHEN ([c].[ExecutionJobLogStop] IS NULL) THEN DATEDIFF( SECOND, [c].[ExecutionJobLogStart], GETDATE() )
		ELSE DATEDIFF( SECOND, [c].[ExecutionJobLogStart], [c].[ExecutionJobLogStop] )
	END AS [ExecutionJobDurationSeconds]

	, [c].[ExecutionJobLogStatusID]


	, COUNT( [a].[ExecutionLogID] ) AS [TotalCount]
	, SUM( CASE [a].[ExecutionLogStatusID] WHEN 0 THEN 1 ELSE 0 END ) AS [TotalNotRun]
	, SUM( CASE [a].[ExecutionLogStatusID] WHEN 1 THEN 1 ELSE 0 END ) AS [TotalRunning]
	, SUM( CASE [a].[ExecutionLogStatusID] WHEN 2 THEN 1 ELSE 0 END ) AS [TotalSuccess]
	, SUM( CASE [a].[ExecutionLogStatusID] WHEN 3 THEN 1 ELSE 0 END ) AS [TotalError]
FROM [RTLS_NDRDW].[ExecutionLog] [a] WITH (NOLOCK)
	JOIN [RTLS_NDRDW].[JobMaster] [b] ON [a].[JobMasterID] = [b].[JobMasterID]
	JOIN [RTLS_NDRDW].[ExecutionJobLog] [C] ON [a].[ExecutionJobLogID] = [C].[ExecutionJobLogID]
WHERE [c].[ExecutionJobLogStart] BETWEEN @StartDate AND @EndDate

GROUP BY
	[a].[ExecutionJobLogID]
	, [c].[ExecutionJobLogStart]
	, [b].[JobMasterID]
	, [b].[JobMasterName]
	, [c].[ExecutionJobLogStop]
	, [c].[ExecutionJobLogStatusID]

ORDER BY
	[a].[ExecutionJobLogID]
	, [c].[ExecutionJobLogStart]
	, [b].[JobMasterID]
	, [b].[JobMasterName]
	, [c].[ExecutionJobLogStatusID]

END

