﻿-- =============================================
-- Author:		Michael D. Hanson
-- Create date: 04/15/2015
-- Description:	Gets SSISDB Parameter Info 
--				from SSISDB Catalog for use in
--				ETL Dashboard Report
-- Parameters:	@ovrExecutionID: Execution ID
--				assosciated with SSISDB Catalog
-- =============================================
CREATE PROCEDURE [RTLS_NDRDW].[rptOverviewParameter] --'62520'
	-- Add the parameters for the stored procedure here
	@ovrExecutionID int 

AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	SELECT
	   [execution_parameter_id]
	  ,[execution_id]
	  ,[object_type]
	  ,[parameter_data_type]
	  ,[parameter_name] = 
	   CASE
		  WHEN [parameter_name] LIKE 'CM.%' THEN SUBSTRING([parameter_name], 4, 4000)
		  ELSE [parameter_name]
	   END
	  ,[parameter_value] =
	   CASE sensitive
		 WHEN 1 THEN '********'
		 ELSE [parameter_value]
	   END
	  ,[sensitive]
	  ,[required]
	  ,[value_set]
	  ,[runtime_override]
	FROM
	  [SSISDB].[internal].[execution_parameter_values]
	WHERE
	  [execution_id] = @ovrExecutionID AND
	  ([value_set] = 1 OR [parameter_name] NOT LIKE 'CM.%')
	ORDER BY [parameter_name]

END

