﻿

-- =============================================
-- Author:		Michael D. Hanson
-- Create date: 04/15/2015
-- Description:	Gets SSISDB Properties Info 
--				from SSISDB Catalog
--				for ETL Dashboard Report
-- Parameters:	@ovrExecutionID: Execution ID
--				associated with SSISDB Catalog
-- =============================================
CREATE PROCEDURE [RTLS_NDRDW].[rptOverviewPropertyOverride] --'62520'

	@ovrExecutionID int 

AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	SELECT
	   [property_path]
	  ,[property_value] =
	   CASE sensitive
		 WHEN 1 THEN '********'
		 ELSE [property_value]
	   END
	FROM 
	  [SSISDB].[internal].[execution_property_override_values]
	WHERE 
	  [execution_id] = @ovrExecutionID
	ORDER BY 
	  [property_path]

END

