﻿CREATE TABLE [RTLS_NDRDW].[ConnectionMaster] (
    [ConnectionMasterID] INT             IDENTITY (1, 1) NOT NULL,
    [SystemMasterID]     INT             CONSTRAINT [DF__Connectio__Syste__14270015] DEFAULT ((0)) NOT NULL,
    [VISNMasterID]       INT             CONSTRAINT [DF__Connectio__VISNM__151B244E] DEFAULT ((0)) NOT NULL,
    [FacilityMasterID]   INT             CONSTRAINT [DF__Connectio__Facil__160F4887] DEFAULT ((0)) NOT NULL,
    [ConnectionTypeID]   INT             CONSTRAINT [DF__Connectio__Conne__17036CC0] DEFAULT ((0)) NOT NULL,
    [ConnectionStatusID] INT             NOT NULL,
    [ServerName]         NVARCHAR (1024) NOT NULL,
    [DatabaseName]       NVARCHAR (1024) NOT NULL,
    [ConnectionProperty] NVARCHAR (1024) NOT NULL,
    [ConnectionString]   NVARCHAR (1024) NOT NULL,
    [CreateDate]         DATETIME        CONSTRAINT [DF__Connectio__Creat__17F790F9] DEFAULT (getdate()) NOT NULL,
    [UpdateDate]         DATETIME        CONSTRAINT [DF__Connectio__Updat__18EBB532] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT [PK_ConnectionMaster] PRIMARY KEY CLUSTERED ([ConnectionMasterID] ASC),
    CONSTRAINT [FK_ConnectionMaster_ConnectionType] FOREIGN KEY ([ConnectionTypeID]) REFERENCES [RTLS_NDRDW].[ConnectionType] ([ConnectionTypeID]),
    CONSTRAINT [FK_ConnectionMaster_FacilityMaster] FOREIGN KEY ([FacilityMasterID]) REFERENCES [RTLS_NDRDW].[FacilityMaster] ([FacilityMasterID]) ON DELETE CASCADE ON UPDATE CASCADE,
    CONSTRAINT [FK_ConnectionMaster_SystemMaster] FOREIGN KEY ([SystemMasterID]) REFERENCES [RTLS_NDRDW].[SystemMaster] ([SystemMasterID]) ON DELETE CASCADE ON UPDATE CASCADE,
    CONSTRAINT [FK_ConnectionMaster_VISNMaster] FOREIGN KEY ([VISNMasterID]) REFERENCES [RTLS_NDRDW].[VISNMaster] ([VISNMasterID]) ON DELETE CASCADE ON UPDATE CASCADE,
    CONSTRAINT [RefConnectionStatus331] FOREIGN KEY ([ConnectionStatusID]) REFERENCES [RTLS_NDRDW].[ConnectionStatus] ([ConnectionStatusID])
);

