﻿CREATE TABLE [RTLS_NDRDW].[ETLMetadataIncrementalChanges] (
    [ETLMetadataIncrementalChangesID]         INT             IDENTITY (1, 1) NOT NULL,
    [SystemMasterID]                          INT             NOT NULL,
    [DMLOperationID]                          INT             CONSTRAINT [DF__ETLMetada__DMLOp__2180FB33] DEFAULT ((4)) NOT NULL,
    [CurrentMetadataExtractID]                INT             NOT NULL,
    [ConnectionMasterID]                      INT             NOT NULL,
    [TableOwner]                              VARCHAR (128)   NULL,
    [TableName]                               VARCHAR (128)   NULL,
    [ColumnName]                              VARCHAR (128)   NULL,
    [ObjectType]                              VARCHAR (8)     NULL,
    [DataType]                                VARCHAR (128)   NOT NULL,
    [KeyType]                                 CHAR (2)        NULL,
    [ColumnLength]                            INT             NOT NULL,
    [DefaultValue]                            NVARCHAR (4000) NULL,
    [AllowsNulls]                             VARCHAR (254)   NOT NULL,
    [ObjectDescription]                       NVARCHAR (4000) NULL,
    [CreateDate]                              DATETIME        NULL,
    [IsUpdatedInCurrentMetadataConfiguration] BIT             CONSTRAINT [DF__ETLMetada__IsUpd__22751F6C] DEFAULT ((0)) NOT NULL,
    [IsPulledByMetaTool]                      BIT             CONSTRAINT [DF__ETLMetada__IsPul__236943A5] DEFAULT ((0)) NOT NULL,
    CONSTRAINT [PK_ETLMetadataIncrementalChanges] PRIMARY KEY CLUSTERED ([ETLMetadataIncrementalChangesID] ASC),
    CONSTRAINT [FK_ETLMetadataIncrementalChanges_CurrentMetadataExtract] FOREIGN KEY ([CurrentMetadataExtractID]) REFERENCES [RTLS_NDRDW].[CurrentMetadataExtract] ([CurrentMetadataExtractID]),
    CONSTRAINT [FK_ETLMetadataIncrementalChanges_DMLOperation] FOREIGN KEY ([DMLOperationID]) REFERENCES [RTLS_NDRDW].[DMLOperation] ([DMLOperationID]) ON UPDATE CASCADE,
    CONSTRAINT [FK_ETLMetadataIncrementalChanges_SystemMaster] FOREIGN KEY ([SystemMasterID]) REFERENCES [RTLS_NDRDW].[SystemMaster] ([SystemMasterID]) ON UPDATE CASCADE,
    CONSTRAINT [RefConnectionMaster361] FOREIGN KEY ([ConnectionMasterID]) REFERENCES [RTLS_NDRDW].[ConnectionMaster] ([ConnectionMasterID])
);


GO
ALTER TABLE [RTLS_NDRDW].[ETLMetadataIncrementalChanges] NOCHECK CONSTRAINT [FK_ETLMetadataIncrementalChanges_CurrentMetadataExtract];

