﻿CREATE TABLE [RTLS_NDRDW].[RunMaster] (
    [RunMasterID]          INT             IDENTITY (1, 1) NOT NULL,
    [JobMasterID]          INT             NOT NULL,
    [FlightMasterID]       INT             NOT NULL,
    [TableMasterID]        INT             NOT NULL,
    [RunMasterName]        NVARCHAR (1024) NOT NULL,
    [LoggingLevelOverride] INT             CONSTRAINT [DF__RunMaster__Loggi__70DDC3D8] DEFAULT ((1)) NOT NULL,
    [PrecedentRun]         INT             CONSTRAINT [DF__RunMaster__Prece__71D1E811] DEFAULT ((0)) NOT NULL,
    [RunOrderSeq]          INT             CONSTRAINT [DF__RunMaster__RunOr__72C60C4A] DEFAULT ((1)) NOT NULL,
    [IsEnabled]            INT             CONSTRAINT [DF__RunMaster__IsEna__73BA3083] DEFAULT ((1)) NOT NULL,
    [CreateDate]           DATETIME        CONSTRAINT [DF__RunMaster__Creat__74AE54BC] DEFAULT (getdate()) NOT NULL,
    [UpdateDate]           DATETIME        CONSTRAINT [DF__RunMaster__Updat__75A278F5] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT [PK__RunMaste__EBDE4217EDD19A46] PRIMARY KEY CLUSTERED ([RunMasterID] ASC),
    CONSTRAINT [FK_RunMaster_FlightMaster] FOREIGN KEY ([FlightMasterID]) REFERENCES [RTLS_NDRDW].[FlightMaster] ([FlightMasterID]),
    CONSTRAINT [FK_RunMaster_JobMaster] FOREIGN KEY ([JobMasterID]) REFERENCES [RTLS_NDRDW].[JobMaster] ([JobMasterID]) ON DELETE CASCADE ON UPDATE CASCADE,
    CONSTRAINT [FK_RunMaster_TableMaster] FOREIGN KEY ([TableMasterID]) REFERENCES [RTLS_NDRDW].[TableMaster] ([TableMasterID])
);

