﻿


CREATE View [RTLS_NDRDW].[DetectedVendorVersionColumnsVW] 
as WITH ColumnModification as (
			SELECT	TableName,
					ColumnName,
					CONVERT(DATE, CreateDate) as ModTime,
					SUM([DMLOperationID]) as ModSUM,
					CASE 
						WHEN SUM([DMLOperationID])%2 = 0 THEN 'INS'
						WHEN SUM([DMLOperationID])%3 = 0 THEN 'DEL'
						WHEN SUM([DMLOperationID])%5 = 0 THEN 'UPD'
						ELSE ''
					END as ModID
			FROM [RTLS_NDRDW].[ETLMetadataIncrementalChanges] WITH (NOLOCK)
			WHERE ([IsPulledByMetaTool] = 0) 
					--and CONVERT(Date, CreateDate) in (@Date, @BASE)
					and ObjectType is NULL
			GROUP BY TableName, ColumnName ,CONVERT(DATE, CreateDate)
		), TableModification as (
				SELECT	TableName,
					CONVERT(DATE, CreateDate) as ModTime,
					SUM([DMLOperationID]) as ModSUM,
					CASE 
						WHEN SUM([DMLOperationID])%2 = 0 THEN 'INS'
						WHEN SUM([DMLOperationID])%3 = 0 THEN 'DEL'
						WHEN SUM([DMLOperationID])%5 = 0 THEN 'UPD'
						ELSE ''
					END as ModID
			FROM [RTLS_NDRDW].[ETLMetadataIncrementalChanges] WITH (NOLOCK)
			WHERE ([IsPulledByMetaTool] = 0) 
					--and CONVERT(Date, CreateDate) = @Date
					and ObjectType = 'U'
			GROUP BY TableName, CONVERT(Date, CreateDate)
		)
		SELECT	
				md.ETLMetadataIncrementalChangesID
				,md.CurrentMetadataExtractID
				,sm.SystemMasterID as VersionID
				,md.ConnectionMasterID
				,sm.SystemName as DatabaseName
				,sm.Description as DatabaseDescription
				,md.TableName
				,md.TableOwner as TableSchema
				,md.ObjectDescription as TableDescription
				,CASE
					WHEN ky.ColumnName is not NULL then ky.ColumnName
					ELSE md.ColumnName
					END as ColumnName
				,md.CurrentMetadataExtractID as ColumnOrder
				, CASE
					WHEN md.DefaultValue <> '' THEN ISNULL(md.ObjectDescription + '<BR>', '') + '<font color = ''blue'' > Initial Value: ' + md.DefaultValue  + '</font>'
					ELSE ISNULL(md.ObjectDescription, '')
					END AS ColumnDescription
				, t.ModID as TModID
				, t.ModTime as TModTime
				, m.ModID as CModID
				, m.ModTime as CModTime
				, CASE 
					WHEN (m.ModID = 'UPD'AND md.DMLOperationID = 2 and (CONVERT(DATE, md.CreateDate) > cast('2012-01-01' as date)))  THEN 'NEW' 
					WHEN (m.ModID = 'UPD'AND md.DMLOperationID = 3 and (CONVERT(DATE, md.CreateDate) > cast('2012-01-01' as date))) THEN 'OLD'
					WHEN (m.ModID is null) THEN ''
					ELSE ''
				  END as DMLID
				, md.DataType
				, md.ColumnLength as [Length]
				, md.DefaultValue
				, ky.ConstraintType as [Key]
				, md.AllowsNulls as NULLSAllowed
				, ky.ConstraintName as KeyName
				, ky.ConstraintType as KeyType
		FROM	[RTLS_NDRDW].[ETLMetadataIncrementalChanges] md WITH (NOLOCK)
				JOIN [RTLS_NDRDW].[SystemMaster] sm WITH (NOLOCK) on sm.[SystemMasterID] = md.[SystemMasterID] 
				LEFT JOIN [RTLS_NDRDW].[KeyColumnUsage] ky WITH (NOLOCK) on sm.[SystemMasterID] = ky.[SystemMasterID]
					and md.[TableName] = ky.[TableName] and md.[ColumnName] = ky.[ColumnName]
				LEFT JOIN ColumnModification m WITH (NOLOCK) on md.[TableName] = m.[TableName] and md.[ColumnName] = m.[ColumnName]
				LEFT JOIN TableModification t WITH (NOLOCK) on md.[TableName] = t.[TableName]
		WHERE md.IsPulledByMetaTool = 0
				and (md.ObjectType is NULL)


