﻿


CREATE View [RTLS_NDRDW].[DetectedVendorVersionVW] as 
WITH ColumnModification as (
			SELECT	TableName,
					ColumnName,
					CONVERT(DATE, CreateDate) as ModTime,
					SUM([DMLOperationID]) as ModSUM,
					CASE 
						WHEN SUM([DMLOperationID])%2 = 0 THEN 'INS'
						WHEN SUM([DMLOperationID])%3 = 0 THEN 'DEL'
						WHEN SUM([DMLOperationID])%5 = 0 THEN 'UPD'
						ELSE ''
					END as ModID
			FROM [RTLS_NDRDW].[ETLMetadataIncrementalChanges] WITH (NOLOCK)
			WHERE ([IsPulledByMetaTool] = 0) 
					--and CONVERT(Date, CreateDate) in (@Date, @BASE)
					and ObjectType is NULL
			GROUP BY TableName, ColumnName ,CONVERT(DATE, CreateDate)
		), TableModification as (
				SELECT	TableName,
					CONVERT(DATE, CreateDate) as ModTime,
					SUM([DMLOperationID]) as ModSUM,
					CASE 
						WHEN SUM([DMLOperationID])%2 = 0 THEN 'INS'
						WHEN SUM([DMLOperationID])%3 = 0 THEN 'DEL'
						WHEN SUM([DMLOperationID])%5 = 0 THEN 'UPD'
						ELSE ''
					END as ModID
			FROM [RTLS_NDRDW].[ETLMetadataIncrementalChanges] WITH (NOLOCK)
			WHERE ([IsPulledByMetaTool] = 0) 
					--and CONVERT(Date, CreateDate) = @Date
					and ObjectType = 'U'
			GROUP BY TableName, CONVERT(Date, CreateDate)
		)
		SELECT	Distinct 
				sm.SystemMasterID as VersionID
				,md.ConnectionMasterID
				,sm.SystemName as DatabaseName
				,sm.Description as DatabaseDescription
					,"SystemMasterVendorMaster"."VendorName" "Vendor Name"
	,"VISNMaster"."VISNName" "VISN"
	,"FacilityMaster"."FacilityName" "Facility"
	,"ConnectionType"."ConnectionTypeName" "Connection Type"
	,"ConnectionStatus"."ConnectionStatus" "Connection Status"
						
		FROM	[RTLS_NDRDW].[ETLMetadataIncrementalChanges] md WITH (NOLOCK)
				JOIN [RTLS_NDRDW].[SystemMaster] sm WITH (NOLOCK) on sm.[SystemMasterID] = md.[SystemMasterID] 
				LEFT JOIN [RTLS_NDRDW].[KeyColumnUsage] ky WITH (NOLOCK) on sm.[SystemMasterID] = ky.[SystemMasterID]
					and md.[TableName] = ky.[TableName] and md.[ColumnName] = ky.[ColumnName]
				LEFT JOIN ColumnModification m WITH (NOLOCK) on md.[TableName] = m.[TableName] and md.[ColumnName] = m.[ColumnName]
				LEFT JOIN TableModification t WITH (NOLOCK) on md.[TableName] = t.[TableName]
				LEFT JOIN [RTLS_NDRDW].[ConnectionMaster] cm on cm.ConnectionMasterID = md.ConnectionMasterID 		
	left join "RTLS_NDRDW"."VendorMaster" "SystemMasterVendorMaster" on "sm"."VendorMasterID" = "SystemMasterVendorMaster"."VendorMasterID"
	left join "RTLS_NDRDW"."VISNMaster" "VISNMaster" on "cm"."VISNMasterID" = "VISNMaster"."VISNMasterID"
	left join "RTLS_NDRDW"."FacilityMaster" "FacilityMaster" on "cm"."FacilityMasterID" = "FacilityMaster"."FacilityMasterID"
	left join "RTLS_NDRDW"."VISNMaster" "FacilityMasterVISNMaster" on "FacilityMaster"."VISNMasterID" = "FacilityMasterVISNMaster"."VISNMasterID"
	left join "RTLS_NDRDW"."ConnectionType" "ConnectionType" on "cm"."ConnectionTypeID" = "ConnectionType"."ConnectionTypeID" 
	left join "RTLS_NDRDW"."ConnectionStatus" "ConnectionStatus" on "cm"."ConnectionStatusID" = "ConnectionStatus"."ConnectionStatusID"	
WHERE md.IsPulledByMetaTool = 0
				and (md.ObjectType is NULL)



