﻿--
-- build Rtls DB
--
DECLARE @stmt AS NVARCHAR(MAX)
DECLARE @dbname AS NVARCHAR(256)
DECLARE @data_path NVARCHAR(256)

-- this is the local directory
SET @data_path = '$(rootdir)'

SET @dbname = '$(db)'
--
-- create DB
--
USE master;
--
--
--
SET @stmt = 'IF DB_ID (N''' + @dbname + ''') IS NOT NULL
BEGIN
	ALTER DATABASE [' + @dbname + '] SET SINGLE_USER WITH ROLLBACK IMMEDIATE	
	DROP DATABASE ' + @dbname + '
END
'
PRINT @stmt
EXEC sp_executesql @stmt=@stmt
-- go with the installation path for the files
--SET @data_path = (SELECT SUBSTRING(physical_name, 1, CHARINDEX(N'master.mdf', LOWER(physical_name)) - 1)
--					FROM master.sys.master_files
--					WHERE database_id = 1 AND file_id = 1);
SET @stmt = 'CREATE DATABASE ' + @dbname + '
ON PRIMARY
( NAME = ' + @dbname + '_data,
	FILENAME = '''+ @data_path + '\data\' + @dbname + '_data.mdf'',
	SIZE = 10MB,
	MAXSIZE = UNLIMITED,
	FILEGROWTH = 100MB )
LOG ON
( NAME = ' + @dbname + '_log,
	FILENAME = '''+ @data_path + + '\log\' + @dbname + '_log.ldf'',
	SIZE = 2048MB,
	MAXSIZE = 51200MB,
	FILEGROWTH = 100MB )'
PRINT @stmt
EXEC sp_executesql @stmt=@stmt

SET @stmt = 'USE [' + @dbname + '] CHECKPOINT'
PRINT @stmt
EXEC sp_executesql @stmt=@stmt

-- sometimes the first one does not take due to a race condition and no_wait; I think; I am trying CHECKPOINT first now; seems to work
SET @stmt = 'ALTER DATABASE [' + @dbname + '] SET RECOVERY SIMPLE WITH NO_WAIT'
PRINT @stmt
EXEC sp_executesql @stmt=@stmt
EXEC sp_executesql @stmt=@stmt
EXEC sp_executesql @stmt=@stmt

SET @stmt = 'ALTER AUTHORIZATION ON DATABASE::' + @dbname + ' TO SA'
PRINT @stmt
EXEC sp_executesql @stmt=@stmt
EXEC sp_executesql @stmt=@stmt
EXEC sp_executesql @stmt=@stmt


SET @stmt = 'ALTER DATABASE ' + @dbname + ' ADD FILEGROUP DefFG;

-- Add a file to the file group, we can now use the file group to store data
ALTER DATABASE ETL
   ADD FILE (
      NAME = fETLDef1
	  , FILENAME = ''' + @data_path + '\fETLDef1.ndf''
	  , SIZE = 10240MB
	  , MAXSIZE = UNLIMITED
	  , FILEGROWTH = 100MB
      ) TO FILEGROUP DefFG;
'
PRINT @stmt
EXEC sp_executesql @stmt=@stmt

