IF "%2"=="" GOTO :USAGE

SET server=%1
SET instdir=%2

SET db=ETL
SET cn=-E -S %server%

REM Create Schema
SET p=%instdir%\EFW
SET sql=EFWDrops.sql EFWDrops.sql EFWDrops.sql EFWDrops.sql EFW.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn%  -d %db% -i "%p%\%%f"
)
REM 01 Level
SET p=%instdir%\DataLoad
SET sql=01_ConnectionStatus.sql _01_ConnectionType.sql _01_Flight.sql 01_Meta.sql _01_Package.sql _01_Schedule.sql _01_TableType.sql _01_Vendor.sql _01_VISN.sql 01_Wrapper.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn%  -d %db% -i "%p%\%%f"
)
REM 02 Level
SET p=%instdir%\DataLoad
SET sql=_02_System.sql _02_Facility.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn%  -d %db% -i "%p%\%%f"
)
REM 03 Level
SET p=%instdir%\DataLoad
SET sql=_03_Connection.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn%  -d %db% -i "%p%\%%f"
)
REM 04 Level
SET p=%instdir%\DataLoad
SET sql=_04_FlightPackage.sql _04_Table.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn%  -d %db% -i "%p%\%%f"
)
REM Views
SET p=%instdir%\Views
SET sql=ConnectionMasterVW.sql MetaWrapperVW.sql MetaWrapperFN.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn%  -d %db% -i "%p%\%%f"
)
REM Procs
SET p=%instdir%\Procs
SET sql=TaskRefresh.sql JobCreate.sql JobDelete.sql JobList.sql ExecutionLogCreate.sql ExecutionLogError.sql ExecutionLogSetID.sql ExecutionLogStart.sql ExecutionLogStatusReport.sql ExecutionLogSuccess.sql ExecutionRun.sql DynaMerge.sql JobCreateBySignature.sql ExecutionCatalogQuery.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn%  -d %db% -i "%p%\%%f"
)
REM Procs
SET p=%instdir%\Procs
SET sql=SchemaCreate.sql SchemaDDL.sql SchemaDDLIndex.sql SchemaCreateIndex.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn%  -d %db% -i "%p%\%%f"
)
REM Procs Oracle
SET p=%instdir%\Procs
SET sql=SchemaCreateOracle.sql SchemaDDLOracle.sql SchemaDDLIndexOracle.sql SchemaCreateIndexOracle.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn%  -d %db% -i "%p%\%%f"
)
REM Install
SET p=%instdir%\ispac
SET sql=_ETLUnInstall.sql _ETLInstall.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn% -d %db% -v instdir="%instdir%\ispac" -i "%p%\%%f"
)
REM Jobs
SET p=%instdir%\Jobs
REM SET sql=Schema.sql TruncCopyCreateJobs.sql
SET sql=Schema.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn% -d %db% -v instdir="%instdir%\ispac" -i "%p%\%%f"
)

REM sql
SET p=%instdir%\sql
SET p=%instdir%\sql
SET sql=CensusStatusUpdate.sql
for %%f in ( %sql% ) do (
 	sqlcmd %cn% -d %db% -v instdir="%instdir%\ispac" -i "%p%\%%f"
)

REM *** REM test  Test02Mini.sql
REM *** SET p=%instdir%\Test
REM *** SET sql=Test02EnableTables.sql 
REM *** for %%f in ( %sql% ) do (
REM *** 	sqlcmd %cn% -d %db% -v instdir="%instdir%\ispac" -i "%p%\%%f"
REM *** )


GOTO :EOF
:USAGE
	@ECHO OFF
	ECHO Usage: %0 TargetServer SourceInstallationDirectory
	ECHO Example Local usage: %0 localhost c:\Projects\RTLS_NDRDW\Database\ETLFramework\ETLFramework
	ECHO Example VHACDWETL03 usage: %0 VHACDWETL03 d:\sw\ETLFramework\ETLFrameworkYYYYMMDD
:EOF