﻿
--
--
--
IF EXISTS (SELECT * FROM sys.objects [a] WHERE type = 'P' AND name = 'ExecutionCatalogQuery' AND [a].[schema_id] = SCHEMA_ID('RTLS_NDRDW'))
BEGIN
	DROP PROCEDURE [RTLS_NDRDW].[ExecutionCatalogQuery]
	PRINT 'DROP PROCEDURE [RTLS_NDRDW].[ExecutionCatalogQuery]'
END
GO

--
--
--
CREATE PROCEDURE [RTLS_NDRDW].[ExecutionCatalogQuery] 
	@op_id BIGINT
AS
BEGIN

SELECT event_message_id,MESSAGE,package_name,event_name,message_source_name,package_path,execution_path,message_type,message_source_type, [message_time]
FROM   (
       SELECT  em.*
       FROM    SSISDB.catalog.event_messages em
       WHERE   em.operation_id = @op_id -- (SELECT MAX(execution_id) FROM SSISDB.catalog.executions)
       AND event_name NOT LIKE '%Validate%'
       )q
/* Put in whatever WHERE predicates you might like*/
--WHERE	event_name = 'OnError'
--WHERE	package_name = 'Package.dtsx'
--WHERE execution_path LIKE '%<some executable>%'
ORDER BY message_time -- DESC


-- SELECT * FROM [SSISDB].[catalog].[extended_operation_info] WHERE [operation_id] = @op_id
-- SELECT * FROM [SSISDB].[catalog].[event_message_context] WHERE [operation_id] = @op_id


END
GO
PRINT 'CREATE PROCEDURE [RTLS_NDRDW].[ExecutionCatalogQuery]'
