﻿
--
--
--
IF EXISTS (SELECT * FROM sys.objects [a] WHERE type = 'P' AND name = 'SchemaCreate' AND [a].[schema_id] = SCHEMA_ID('RTLS_NDRDW'))
BEGIN
	DROP PROCEDURE [RTLS_NDRDW].[SchemaCreate]
	PRINT 'DROP PROCEDURE [RTLS_NDRDW].[SchemaCreate]'
END
GO

--
--
--
CREATE PROCEDURE [RTLS_NDRDW].[SchemaCreate] 
AS
BEGIN
DECLARE @stmt AS NVARCHAR(MAX)
DECLARE @schema AS NVARCHAR(256)
DECLARE @DefFG AS NVARCHAR(256)
--
--
--
SET @schema = 'RTLS_NDRDW'
SET @DefFG = 'DefFG'


SET @stmt='
IF EXISTS (SELECT * FROM sys.objects [a] WHERE type = ''U'' AND name = ''tmpSchema'' AND [a].[schema_id] = SCHEMA_ID(''' + @schema + '''))
BEGIN
	DROP TABLE [' + @schema + '].[tmpSchema]
	PRINT ''DROP TABLE [' + @schema + '].[tmpSchema]''
END

CREATE TABLE [' + @schema + '].[tmpSchema](
	[TABLE_CATALOG] [nvarchar](128) NULL,
	[TABLE_SCHEMA] [nvarchar](128) NULL,
	[TABLE_NAME] [nvarchar](128) NULL,
	[COLUMN_NAME] [nvarchar](128) NULL,
	[ORDINAL_POSITION] [int] NULL,
	[COLUMN_DEFAULT] [nvarchar](4000) NULL,
	[IS_NULLABLE] [varchar](3) NULL,
	[DATA_TYPE] [nvarchar](128) NULL,
	[CHARACTER_MAXIMUM_LENGTH] [int] NULL,
	[CHARACTER_OCTET_LENGTH] [int] NULL,
	[NUMERIC_PRECISION] [tinyint] NULL,
	[NUMERIC_PRECISION_RADIX] [smallint] NULL,
	[NUMERIC_SCALE] [int] NULL,
	[DATETIME_PRECISION] [smallint] NULL,
	[CHARACTER_SET_CATALOG] [nvarchar](128) NULL,
	[CHARACTER_SET_SCHEMA] [nvarchar](128) NULL,
	[CHARACTER_SET_NAME] [nvarchar](128) NULL,
	[COLLATION_CATALOG] [nvarchar](128) NULL,
	[COLLATION_SCHEMA] [nvarchar](128) NULL,
	[COLLATION_NAME] [nvarchar](128) NULL,
	[DOMAIN_CATALOG] [nvarchar](128) NULL,
	[DOMAIN_SCHEMA] [nvarchar](128) NULL,
	[DOMAIN_NAME] [nvarchar](128) NULL
) ON [' + @DefFG + ']'


	PRINT @stmt
	EXEC sp_executesql @stmt=@stmt

SET @stmt='
IF OBJECT_ID (''[RTLS_NDRDW].[tmpSchemaVW]'', ''V'') IS NOT NULL
BEGIN
    PRINT ''DROP VIEW [RTLS_NDRDW].[tmpSchemaVW]''
    DROP VIEW [RTLS_NDRDW].[tmpSchemaVW] ;
END'

	PRINT @stmt
	EXEC sp_executesql @stmt=@stmt

SET @stmt='
CREATE VIEW [RTLS_NDRDW].[tmpSchemaVW]
AS
SELECT 
	''['' + COLUMN_NAME + ''] ['' + DATA_TYPE + '']''
	+ CASE 
		WHEN ( ISNULL(CHARACTER_MAXIMUM_LENGTH, 0) = -1 ) THEN ''(MAX)''
		WHEN ( ISNULL(CHARACTER_MAXIMUM_LENGTH, 0) > 0 ) AND ( DATA_TYPE <> ''Text'' ) THEN ''('' + CAST(CHARACTER_MAXIMUM_LENGTH AS NVARCHAR(128)) + '')''
		ELSE ''''
		END
		+ '' ''
		+ CASE IS_NULLABLE
			WHEN ''YES'' THEN ''NULL''
			ELSE ''NOT NULL''
		END
	AS COL_DEF
	, *
  FROM [RTLS_NDRDW].[tmpSchema]'

	PRINT @stmt
	EXEC sp_executesql @stmt=@stmt





END
GO
PRINT 'CREATE PROCEDURE [RTLS_NDRDW].[SchemaCreate]'
-- execute it
EXEC [RTLS_NDRDW].[SchemaCreate]
