﻿
--
--
--
IF EXISTS (SELECT * FROM sys.objects [a] WHERE type = 'P' AND name = 'SchemaCreateOracle' AND [a].[schema_id] = SCHEMA_ID('RTLS_NDRDW'))
BEGIN
	DROP PROCEDURE [RTLS_NDRDW].[SchemaCreateOracle]
	PRINT 'DROP PROCEDURE [RTLS_NDRDW].[SchemaCreateOracle]'
END
GO

--
--
--
CREATE PROCEDURE [RTLS_NDRDW].[SchemaCreateOracle] 
AS
BEGIN
DECLARE @stmt AS NVARCHAR(MAX)
DECLARE @schema AS NVARCHAR(256)
DECLARE @DefFG AS NVARCHAR(256)
--
--
--
SET @schema = 'RTLS_NDRDW'
SET @DefFG = 'DefFG'


SET @stmt='
IF EXISTS (SELECT * FROM sys.objects [a] WHERE type = ''U'' AND name = ''tmpSchemaOracle'' AND [a].[schema_id] = SCHEMA_ID(''' + @schema + '''))
BEGIN
	DROP TABLE [' + @schema + '].[tmpSchemaOracle]
	PRINT ''DROP TABLE [' + @schema + '].[tmpSchemaOracle]''
END

CREATE TABLE [' + @schema + '].[tmpSchemaOracle](
	[OWNER] [nvarchar](128) NOT NULL,
	[TABLE_NAME] [nvarchar](128) NOT NULL,
	[COLUMN_NAME] [nvarchar](128) NOT NULL,
	[DATA_TYPE] [nvarchar](128) NULL,
	[DATA_LENGTH] [int] NOT NULL,
	[DATA_PRECISION] [int] NULL,
	[DATA_SCALE] [int] NULL,
	[NULLABLE] [nvarchar](1) NULL,
	[COLUMN_ID] [int] NULL,
	[CHARACTER_SET_NAME] [nvarchar](128) NULL,
	[CHAR_COL_DECL_LENGTH] [int] NULL,
	[AVG_COL_LEN] [int] NULL,
	[CHAR_LENGTH] [int] NULL,
	[CHAR_USED] [nvarchar](1) NULL
) ON [' + @DefFG + ']'
	PRINT @stmt
	EXEC sp_executesql @stmt=@stmt

SET @stmt='
IF OBJECT_ID (''[' + @schema + '].[tmpSchemaOracleVW]'', ''V'') IS NOT NULL
BEGIN
    PRINT ''DROP VIEW [' + @schema + '].[tmpSchemaOracleVW]''
    DROP VIEW [' + @schema + '].[tmpSchemaOracleVW] ;
END'

	PRINT @stmt
	EXEC sp_executesql @stmt=@stmt

SET @stmt='
CREATE VIEW [' + @schema + '].[tmpSchemaOracleVW]
AS
SELECT 
	''['' + COLUMN_NAME + ''] ['' 
	+ CASE 
		WHEN ( DATA_TYPE = ''NVARCHAR2'' ) THEN ''NVARCHAR''
		WHEN ( DATA_TYPE = ''VARCHAR2'' ) THEN ''VARCHAR''
		WHEN ( DATA_TYPE = ''BLOB'' ) THEN ''VARBINARY''
		WHEN ( DATA_TYPE = ''CLOB'' ) THEN ''VARCHAR''
		WHEN ( DATA_TYPE = ''LONG'' ) THEN ''VARCHAR''
		WHEN ( DATA_TYPE = ''RAW'' ) THEN ''VARBINARY''
		WHEN ( DATA_TYPE = ''NUMBER'' ) THEN ''NUMERIC''
		WHEN ( DATA_TYPE = ''TIMESTAMP'' ) THEN ''DATETIME''
		WHEN ( DATA_TYPE = ''TIMESTAMP(0)'' ) THEN ''DATETIME''
		WHEN ( DATA_TYPE = ''TIMESTAMP(1)'' ) THEN ''DATETIME''
		WHEN ( DATA_TYPE = ''TIMESTAMP(3)'' ) THEN ''DATETIME''
		WHEN ( DATA_TYPE = ''TIMESTAMP(6)'' ) THEN ''DATETIME''
		WHEN ( DATA_TYPE = ''TIMESTAMP(9)'' ) THEN ''DATETIME''
		ELSE DATA_TYPE
		END
	+ '']''
	+ CASE 
		WHEN ( DATA_TYPE = ''NUMBER'' AND DATA_PRECISION IS NOT NULL AND DATA_SCALE IS NULL ) 
		THEN ''('' + CAST( DATA_PRECISION AS NVARCHAR(128) ) + '')''
		WHEN ( DATA_TYPE = ''NUMBER'' AND DATA_PRECISION IS NOT NULL AND DATA_SCALE IS NOT NULL ) 
		THEN ''('' + CAST( DATA_PRECISION AS NVARCHAR(128) ) + '', '' + CAST( DATA_SCALE AS NVARCHAR(128) ) 	+ '')''
		WHEN ( DATA_TYPE = ''BLOB'' ) THEN ''(MAX)''
		WHEN ( DATA_TYPE = ''CLOB'' ) THEN ''(MAX)''
		WHEN ( DATA_TYPE = ''LONG'' ) THEN ''(MAX)''
		WHEN ( ISNULL(CHAR_LENGTH, 0) = -1 ) THEN ''(MAX)''
		WHEN ( ISNULL(CHAR_LENGTH, 0) > 0 ) 
			AND ( 
			( DATA_TYPE <> ''TEXT'' ) 
			OR ( DATA_TYPE <> ''BLOB'' ) 
			OR ( DATA_TYPE <> ''CLOB'' ) 
			-- OR ( DATA_TYPE <> ''RAW'' ) 
				)
		THEN ''('' + CAST(CHAR_LENGTH AS NVARCHAR(128)) + '')''
		ELSE ''''
		END
		+ '' ''
		+ CASE NULLABLE
			WHEN ''Y'' THEN ''NULL''
			ELSE ''NOT NULL''
		END
	AS COL_DEF
	, *
  FROM [' + @schema + '].[tmpSchemaOracle]'

	PRINT @stmt
	EXEC sp_executesql @stmt=@stmt





END
GO
PRINT 'CREATE PROCEDURE [RTLS_NDRDW].[SchemaCreateOracle]'
-- execute it
EXEC [RTLS_NDRDW].[SchemaCreateOracle]
