﻿

IF EXISTS (SELECT * FROM sys.objects [a] WHERE type = 'P' AND name = 'SchemaDDL' AND [a].[schema_id] = SCHEMA_ID('RTLS_NDRDW'))
BEGIN
	DROP PROCEDURE [RTLS_NDRDW].[SchemaDDL]
	PRINT 'DROP PROCEDURE [RTLS_NDRDW].[SchemaDDL]'
END
GO

--
--
--
CREATE PROCEDURE [RTLS_NDRDW].[SchemaDDL] 
	@schema NVARCHAR(MAX)
	, @SchemaType INT -- 
	, @SchemaLevel INT -- 1 Stage, 2 VISN, 3 Vendor
AS
BEGIN
	DECLARE @stmt AS NVARCHAR(MAX)

	DECLARE @tname NVARCHAR(MAX)
	DECLARE @tname_hold NVARCHAR(MAX)
	DECLARE @def NVARCHAR(MAX)
	DECLARE @ddl_stmt NVARCHAR(MAX)
	DECLARE @comma NVARCHAR(5)
	DECLARE @dp NVARCHAR(MAX)
	DECLARE @tc NVARCHAR(MAX)
	DECLARE @DefFG NVARCHAR(MAX)

	-- drop and create table to hold DDL
	SET @stmt='IF EXISTS (SELECT * FROM sys.objects [a] WHERE type = ''U'' AND name = ''' + @schema + '_DDL'' AND [a].[schema_id] = SCHEMA_ID(''RTLS_NDRDW''))
BEGIN
	DROP TABLE [RTLS_NDRDW].[' + @schema + '_DDL]
END'
	PRINT @stmt
	EXEC sp_executesql @stmt=@stmt

	SET @stmt='CREATE TABLE [RTLS_NDRDW].[' + @schema + '_DDL] ( [DDLID] [INT] IDENTITY NOT NULL, [DDLStmt] [NVARCHAR](MAX) )'
	PRINT @stmt
	EXEC sp_executesql @stmt=@stmt

	-- create schema
	SET @ddl_stmt='IF NOT EXISTS (SELECT * FROM [sys].[Schemas] WHERE [name] =  ''''' + @schema + ''''')
	BEGIN
		EXEC sp_executesql @stmt=N''''CREATE SCHEMA [' + @schema + '] ''''
	END'
	SET @stmt='INSERT INTO [RTLS_NDRDW].[' + @schema + '_DDL] ( [DDLStmt] ) VALUES ( ''' + @ddl_stmt + ''' )'
	PRINT @stmt
	EXEC sp_executesql @stmt=@stmt

	-- static stuff for all DDL
	SET @dp = '
IF NOT EXISTS (SELECT * FROM sys.objects [a] WHERE type = ''''U'''' AND name = '''''

	SET @tc = ''''' AND [a].[schema_id] = SCHEMA_ID(''''' + @schema + '''''))
BEGIN

CREATE TABLE [' + @schema + '].['
	SET @DefFG = ') ON [DefFG]
	WITH ( DATA_COMPRESSION = PAGE )
END
'

	SET @comma = ''
	SET @ddl_stmt = ''
	SET @tname_hold = ''

	DECLARE c CURSOR FOR
		SELECT 
			[TABLE_NAME]
			, [COL_DEF]
		FROM [RTLS_NDRDW].[tmpSchemaVW]
		ORDER BY 
			[TABLE_CATALOG]
			, [TABLE_SCHEMA]
			, [TABLE_NAME]
			, [ORDINAL_POSITION]

	OPEN c
	FETCH NEXT FROM c INTO @tname, @def
	WHILE @@FETCH_STATUS = 0
	BEGIN

		IF @tname_hold <> @tname
		BEGIN
			IF @tname_hold <> ''
			BEGIN
				IF @SchemaLevel > 1
				BEGIN
					-- add wrapper
					SET @ddl_stmt = @ddl_stmt + [RTLS_NDRDW].[MetaWrapperFN](@SchemaType)
				END
				-- add file group
				SET @ddl_stmt = @ddl_stmt + @DefFG
				-- Insert row in to DDL table
				SET @stmt='INSERT INTO [RTLS_NDRDW].[' + @schema + '_DDL] ( [DDLStmt] ) VALUES ( ''' + @ddl_stmt + ''' )'
				PRINT @stmt
				EXEC sp_executesql @stmt=@stmt
			END
			-- reset first element
			SET @ddl_stmt = @dp + @tname + @tc + @tname + '] (
	'
			SET @comma = ''
		END
		-- add column definition
		SET @ddl_stmt = @ddl_stmt + @comma + @def + '
	'
		-- reset table control strings
		SET @comma = ', '
		SET @tname_hold = @tname
		-- next
		FETCH NEXT FROM c INTO @tname, @def
	END
	CLOSE c
	DEALLOCATE c

	-- add wrapper
	SET @ddl_stmt = @ddl_stmt + [RTLS_NDRDW].[MetaWrapperFN](@SchemaType)
	-- add file group
	SET @ddl_stmt = @ddl_stmt + @DefFG
	SET @stmt='INSERT INTO [RTLS_NDRDW].[' + @schema + '_DDL] ( [DDLStmt] ) VALUES ( ''' + @ddl_stmt + ''')'
	PRINT @stmt
	EXEC sp_executesql @stmt=@stmt




END
GO

PRINT 'CREATE PROCEDURE [RTLS_NDRDW].[SchemaDDL]

'
GO

-- EXEC [RTLS_NDRDW].[SchemaDDL] @Schema='NDRInSitesVISN23Stage'
-- EXEC [RTLS_NDRDW].[SchemaDDL] @Schema='NDRInSitesVISN23'
-- EXEC [RTLS_NDRDW].[SchemaDDL] @Schema='NDRInSites'
