﻿

IF EXISTS (SELECT * FROM sys.objects [a] WHERE type = 'P' AND name = 'SchemaDDLIndexOracle' AND [a].[schema_id] = SCHEMA_ID('RTLS_NDRDW'))
BEGIN
	DROP PROCEDURE [RTLS_NDRDW].[SchemaDDLIndexOracle]
	PRINT 'DROP PROCEDURE [RTLS_NDRDW].[SchemaDDLIndexOracle]'
END
GO

--
-- create all indexes
--
CREATE PROCEDURE [RTLS_NDRDW].[SchemaDDLIndexOracle] 
	@schema NVARCHAR(MAX)
	, @SchemaType INT -- 1 is VISN 2 is Facility
	, @SchemaLevel INT -- 1 is Stage, 2 is VISN, 3 is Vendor
AS
BEGIN
	-- cursor variables
	DECLARE @sname NVARCHAR(MAX)
	DECLARE @tname NVARCHAR(MAX)
	DECLARE @iname NVARCHAR(MAX)
	DECLARE @cname NVARCHAR(MAX)

	-- processing variables
	DECLARE @stmt AS NVARCHAR(MAX)
	DECLARE @tname_hold NVARCHAR(MAX)
	DECLARE @def NVARCHAR(MAX)
	DECLARE @ddl_stmt NVARCHAR(MAX)
	DECLARE @comma NVARCHAR(5)
	DECLARE @dp NVARCHAR(MAX)
	DECLARE @tc NVARCHAR(MAX)
	DECLARE @DefFG NVARCHAR(MAX)

	-- drop and create table to hold DDL
	SET @stmt='IF EXISTS (SELECT * FROM sys.objects [a] WHERE type = ''U'' AND name = ''' + @schema + '_DDLIndexOracle'' AND [a].[schema_id] = SCHEMA_ID(''RTLS_NDRDW''))
BEGIN
	DROP TABLE [RTLS_NDRDW].[' + @schema + '_DDLIndexOracle]
END'
	PRINT @stmt
	EXEC sp_executesql @stmt=@stmt
	-- create DDL repository table
	SET @stmt='CREATE TABLE [RTLS_NDRDW].[' + @schema + '_DDLIndexOracle] ( [DDLID] [INT] IDENTITY NOT NULL, [DDLStmt] [NVARCHAR](MAX) )'
	PRINT @stmt
	EXEC sp_executesql @stmt=@stmt

	-- static stuff for all DDL
	SET @DefFG = ' ) ON [DefFG]
END
'

	SET @comma = ''
	SET @ddl_stmt = ''
	SET @tname_hold = ''

	DECLARE c CURSOR FOR
		SELECT 
			[SchemaName]
			,[TableName]
			,[IndexName]
			,[ColumnName]
		FROM [RTLS_NDRDW].[tmpIndex]
		ORDER BY
			[SchemaName]
			,[TableName]
			,[IndexName]
			,[ColumnName]

	OPEN c
	FETCH NEXT FROM c INTO
		@sname
		, @tname
		, @iname
		, @cname

	WHILE @@FETCH_STATUS = 0
	BEGIN

		IF @tname_hold <> @tname
		BEGIN
			IF @tname_hold <> ''
			BEGIN
				IF @SchemaLevel = 2 -- 2 VISN level add facility if needed
				BEGIN
					-- SET @ddl_stmt = @ddl_stmt + ', VISNIDDW' -- not at VISN
					IF @SchemaType > 1
					BEGIN
						-- SET @ddl_stmt = @ddl_stmt + ', VISNIDDW, FacilityIDDW' -- facility only
						SET @ddl_stmt = @ddl_stmt + ', FacilityIDDW'
					END
				END
				IF @SchemaLevel > 2 -- 3 Vendor level -- add VISN for uniquness
				BEGIN
					SET @ddl_stmt = @ddl_stmt + ', VISNIDDW' 
					IF @SchemaType > 1
					BEGIN
						SET @ddl_stmt = @ddl_stmt + ', VISNIDDW, FacilityIDDW'
					END
				END
				-- add file group
				SET @ddl_stmt = @ddl_stmt + @DefFG
				-- Insert row in to DDL table
				SET @stmt='INSERT INTO [RTLS_NDRDW].[' + @schema + '_DDLIndexOracle] ( [DDLStmt] ) VALUES ( ''' + @ddl_stmt + ''' )'
				PRINT @stmt
				EXEC sp_executesql @stmt=@stmt
			END
	SET @dp = 'IF NOT EXISTS (SELECT * FROM [sys].[objects] [a] WHERE [a].[type] = ''''PK'''' AND name = ''''PK_' + @schema + '_' + @tname + ''''' AND [a].[schema_id] = SCHEMA_ID(''''' + @schema + '''''))
BEGIN
	ALTER TABLE [' + @schema + '].['
			-- reset first element
			SET @ddl_stmt = @dp + @tname + '] ADD CONSTRAINT [PK_' + @schema + '_' + @tname + '] PRIMARY KEY CLUSTERED ( '
			SET @comma = ''
		END
		-- add column definition
		SET @ddl_stmt = @ddl_stmt + @comma + @cname
		-- reset table control strings
		SET @comma = ', '
		SET @tname_hold = @tname
		-- next
		FETCH NEXT FROM c INTO
			@sname
			, @tname
			, @iname
			, @cname
	END
	CLOSE c
	DEALLOCATE c

	-- add file group
	SET @ddl_stmt = @ddl_stmt + @DefFG
	SET @stmt='INSERT INTO [RTLS_NDRDW].[' + @schema + '_DDLIndexOracle] ( [DDLStmt] ) VALUES ( ''' + @ddl_stmt + ''')'
	PRINT @stmt
	EXEC sp_executesql @stmt=@stmt

END
GO

PRINT 'CREATE PROCEDURE [RTLS_NDRDW].[SchemaDDLIndexOracle]'
GO

-- EXEC [RTLS_NDRDW].[SchemaDDLIndex] @Schema='NDRInSitesVISN23Stage', @SchemaType=1, @SchemaLevel=2
-- EXEC [RTLS_NDRDW].[SchemaDDL] @Schema='NDRInSitesVISN23'
-- EXEC [RTLS_NDRDW].[SchemaDDL] @Schema='NDRInSites'
