﻿
	SELECT
		[s].[name] AS [SchemaName]
		, [t].[name] AS [TableName]
		, [i].[name] AS [IndexName]
		, c.name AS [ColumnName]
	FROM sys.schemas s
	JOIN sys.tables t ON s.[schema_id] = t.[schema_id]
	JOIN sys.indexes i on i.[object_id] = t.[object_id]
	JOIN sys.index_columns ic on ic.[object_id] = i.[object_id] AND ic.[index_id] = i.[index_id]
	JOIN sys.columns c on c.object_id = t.object_id AND ic.column_id = c.column_id

WHERE
	i.is_primary_key = 1
	
--where i.index_id > 0    
--and i.type in (1, 2) -- clustered & nonclustered only
--and i.is_primary_key = 0 -- do not include PK indexes
--and i.is_unique_constraint = 0 -- do not include UQ
--and i.is_disabled = 0
--and i.is_hypothetical = 0
--and ic.key_ordinal > 0

order by -- ic.key_ordinal
		s.name
		, t.name
		, i.name 
		--, c.name
 
