﻿--
--
--
IF OBJECT_ID ('[RTLS_NDRDW].[ConnectionMasterVW]', 'V') IS NOT NULL
BEGIN
    PRINT 'DROP VIEW [RTLS_NDRDW].[ConnectionMasterVW]'
    DROP VIEW [RTLS_NDRDW].[ConnectionMasterVW] ;
END
GO

CREATE VIEW [RTLS_NDRDW].[ConnectionMasterVW]
AS
SELECT [ConnectionMasterID]
      , [SystemMasterID]
      , [VISNMasterID]
      , [FacilityMasterID]
      , [ConnectionTypeID]
      , [ConnectionStatusID]
      , [ServerName]
      , [DatabaseName]
	  , 'Server=' + [ServerName] + ';Database=' + [DatabaseName] + ';Trusted_Connection=yes;' AS [ConnectionStringSqlServerDotNet]
	  , 'Provider=SQLNCLI11; Server=' + [ServerName] + ';Database=' + [DatabaseName] + ';Trusted_Connection=yes;' AS [ConnectionStringSqlServerOleDB]
	  , 'Provider=SQLNCLI11; Server=' + [ServerName] + ';Database=master;Trusted_Connection=yes;' AS [ConnectionStringSqlServerOleDBMaster]
	  , 'Provider=OraOLEDB.Oracle.1;Data Source=' + [ServerName] + '/' + [DatabaseName] + ';User ID=NDRDWTEST_ETL;Persist Security Info=True;' AS [ConnectionStringOracleOleDB]
      --,[ConnectionProperty]
      --,[ConnectionString]
      --,[CreateDate]
      --,[UpdateDate]
  FROM [RTLS_NDRDW].[ConnectionMaster]

GO
PRINT 'CREATE VIEW [RTLS_NDRDW].[ConnectionMasterVW]'