﻿--
--
DECLARE @stmt AS NVARCHAR(MAX)
DECLARE @folder_name AS NVARCHAR(MAX)
DECLARE @project_name AS NVARCHAR(MAX)
DECLARE @project_file AS NVARCHAR(MAX)

DECLARE @p AS NVARCHAR(MAX)
-- SET @p='C:\Projects\USPS_AMERICAS_US_GOVT_HP_Metatool\Database\ETLFramework\ETLFramework\ispac'
SET @p='$(instdir)'

CREATE TABLE #etl_install ( folder_name NVARCHAR(MAX), project_name NVARCHAR(MAX), project_file NVARCHAR(MAX) )
INSERT INTO #etl_install (folder_name, project_name, project_file) VALUES 
	( 'RTLS_NDRDW', 'Schema', @p + '\Schema.ispac' )
	, ( 'RTLS_NDRDW', 'WaveMarkSchema', @p + '\WaveMarkSchema.ispac' )
	, ( 'RTLS_NDRDW', 'CenTrakSCD1', @p + '\CenTrakSCD1.ispac' )
	, ( 'RTLS_NDRDW', 'CenTrakTruncCopy', @p + '\CenTrakTruncCopy.ispac' )
	, ( 'RTLS_NDRDW', 'InSitesSCD1', @p + '\InSitesSCD1.ispac' )
	, ( 'RTLS_NDRDW', 'InSitesTruncCopy', @p + '\InSitesTruncCopy.ispac' )
	, ( 'RTLS_NDRDW', 'OATSystemsSCD1', @p + '\OATSystemsSCD1.ispac' )
	, ( 'RTLS_NDRDW', 'OATSystemsTruncCopy', @p + '\OATSystemsTruncCopy.ispac' )
	, ( 'RTLS_NDRDW', 'WaveMarkSCD1', @p + '\WaveMarkSCD1.ispac' )
	, ( 'RTLS_NDRDW', 'WaveMarkTruncCopy', @p + '\WaveMarkTruncCopy.ispac' )


	DECLARE c CURSOR LOCAL STATIC READ_ONLY FORWARD_ONLY FOR 
		SELECT a.folder_name, a.project_name, a.project_file
		FROM #etl_install a ORDER BY a.folder_name, a.project_name, a.project_file

	OPEN c
	FETCH NEXT FROM c INTO @folder_name, @project_name, @project_file
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		PRINT 'Install: ' + @folder_name + ' ' + @project_name

		SET @stmt = '
DECLARE @ProjectBinary as varbinary(max)
DECLARE @operation_id as bigint
-- DECLARE @folder_name nvarchar(128)
DECLARE @folder_id bigint

IF NOT EXISTS(SELECT 1 FROM SSISDB.internal.folders WHERE name = ''' + @folder_name + ''' )
BEGIN
	-- SET @folder_name = ''' + @folder_name + '''
	EXEC [SSISDB].[catalog].[create_folder] 
		@folder_name=''' + @folder_name + '''
		, @folder_id=@folder_id OUTPUT
END

Set @ProjectBinary = (SELECT * FROM OPENROWSET(BULK ''' + @project_file + ''', SINGLE_BLOB) as BinaryData)
Exec [SSISDB].[catalog].[deploy_project] @folder_name = ''' + @folder_name + ''', @project_name = ''' + @project_name + ''', @Project_Stream = @ProjectBinary, @operation_id = @operation_id out'
			-- PRINT @stmt
			EXEC sp_executesql @stmt=@stmt

		FETCH NEXT FROM c INTO @folder_name, @project_name, @project_file
	END
	CLOSE c
	DEALLOCATE c


DROP TABLE #etl_install

