
	SELECT 
		DB_NAME() AS DBNAME
		,sysfilegroups.groupid 
		,sysfilegroups.groupname 
		,fileid 
		,convert(decimal(12,2),round(sysfiles.size/128.000,2)) as file_size 
		,convert(decimal(12,2),round(sysfiles.maxsize/128.000,2)) as max_size 
		,convert(decimal(12,2),round(sysfiles.growth/128.000,2)) as growth_size 
		,convert(decimal(12,2),round(fileproperty(sysfiles.name,'SpaceUsed')/128.000,2)) as space_used 
		,convert(decimal(12,2),round((sysfiles.size-fileproperty(sysfiles.name,'SpaceUsed'))/128.000,2)) as free_space 
		,sysfiles.name 
		,sysfiles.filename 
		-- ,sysfiles.* 
		-- , sysfilegroups.*
	FROM sys.sysfiles 
	LEFT OUTER JOIN sys.sysfilegroups 
	ON sysfiles.groupid = sysfilegroups.groupid