--SELECT      T.name TableName,i.Rows NumberOfRows
--FROM        sys.tables T
--JOIN        sys.sysindexes I ON T.OBJECT_ID = I.ID
--WHERE       indid IN (0,1)
--ORDER BY    i.Rows DESC,T.name 

SELECT 
    s.Name AS SchemaName,
    t.NAME AS TableName,
    p.rows AS RowCounts,
    SUM(a.total_pages) * 8 AS TotalSpaceKB, 
    SUM(a.used_pages) * 8 AS UsedSpaceKB, 
    (SUM(a.total_pages) - SUM(a.used_pages)) * 8 AS UnusedSpaceKB
FROM 
    sys.tables t
INNER JOIN 
    sys.schemas s ON s.schema_id = t.schema_id
INNER JOIN      
    sys.indexes i ON t.OBJECT_ID = i.object_id
INNER JOIN 
    sys.partitions p ON i.object_id = p.OBJECT_ID AND i.index_id = p.index_id
INNER JOIN 
    sys.allocation_units a ON p.partition_id = a.container_id
WHERE 
    t.NAME NOT LIKE 'dt%'    -- filter out system tables for diagramming
    AND t.is_ms_shipped = 0
    AND i.OBJECT_ID > 255 

	AND p.rows > 0
GROUP BY 
    t.Name, s.Name, p.Rows
ORDER BY 
    -- t.Name, s.Name
	UsedSpaceKB DESC, s.Name, t.Name