﻿


DECLARE @stmt AS NVARCHAR(MAX)
DECLARE @dbname AS NVARCHAR(256)
DECLARE @mds AS NVARCHAR(256)
DECLARE @schema AS NVARCHAR(256)
DECLARE @t AS NVARCHAR(256)
DECLARE @tbl AS NVARCHAR(256)

--
--
--
SET @tbl='TableMaster'

SET @mds = 'MDS'
SET @dbname = 'NDRDW'
SET @schema = 'ETLFramework'
SET @stmt='
-- SET IDENTITY_INSERT [' + @dbname + '].[' + @schema + '].[' + @tbl + '] ON

INSERT INTO [' + @dbname + '].[' + @schema + '].[TableMaster]
	( [ConnectionMasterID]
	, [SystemMasterID]
	, [FlightMasterID]
	, [TableTypeID]
	, [TableName]
	, [TableOrderSeq]
	, [IsEnabled]
	, [CreateDate]
	, [UpdateDate]
	)

SELECT
	11 AS [ConnectionMasterID]
	, [a].[SystemMaster_ID] AS [SystemMasterID]
	, [a].[FlightMaster_ID] AS [FlightMasterID]
	, [a].[TableType_ID] AS [TableTypeID]
	, [a].[Name] AS [TableName]
	, ROW_NUMBER() OVER ( PARTITION BY [SystemMaster_ID] ORDER BY [SystemMaster_ID] ) AS [TableOrderSeq]
	, [a].[IsEnabled_Code] AS [IsEnabled]
	, [a].[EnterDateTime] AS [CreateDate]
	, [a].[LastChgDateTime] AS [UpdateDate]
FROM
	(
	SELECT 1 AS [xid]
		, [SystemMaster_ID]
		, [FlightMaster_ID]
		, [TableType_ID]
		, [Name]
		, [IsEnabled_Code]
		, [EnterDateTime]
		, [LastChgDateTime]
	FROM [' + @mds + '].[mdm].[TableMasterCensitrac]
	UNION
	SELECT 2 AS [xid]
		, [SystemMaster_ID]
		, [FlightMaster_ID]
		, [TableType_ID]
		, [Name]
		, [IsEnabled_Code]
		, [EnterDateTime]
		, [LastChgDateTime]
	FROM [' + @mds + '].[mdm].[TableMasterCenTrak]
	UNION
	SELECT 3 AS [xid]
		, [SystemMaster_ID]
		, [FlightMaster_ID]
		, [TableType_ID]
		, [Name]
		, [IsEnabled_Code]
		, [EnterDateTime]
		, [LastChgDateTime]
	FROM [' + @mds + '].[mdm].[TableMasterInSites]
	UNION
	SELECT 4 AS [xid]
		, [SystemMaster_ID]
		, [FlightMaster_ID]
		, [TableType_ID]
		, [Name]
		, [IsEnabled_Code]
		, [EnterDateTime]
		, [LastChgDateTime]
	FROM [' + @mds + '].[mdm].[TableMasterOATSystems]
	UNION
	SELECT 5 AS [xid]
		, [SystemMaster_ID]
		, [FlightMaster_ID]
		, [TableType_ID]
		, [Name]
		, [IsEnabled_Code]
		, [EnterDateTime]
		, [LastChgDateTime]
	FROM [' + @mds + '].[mdm].[TableMasterWaveMark]
	) a
ORDER BY [a].[SystemMaster_ID]
	, [a].[Name]

-- SET IDENTITY_INSERT [' + @dbname + '].[' + @schema + '].[' + @tbl + '] OFF
'

PRINT @stmt
EXEC sp_executesql @stmt=@stmt

