IF "%2"=="" GOTO :USAGE

SET server=localhost
SET db=RTLS_ETLFramework

SET rootdir=%1\%db%
SET instdir=%2

REM make dirs
md %rootdir%
md %rootdir%\data
md %rootdir%\log

SET cn=-E -S %server%

REM **** drop/create database here
SET p=%instdir%\DataLoad
SET sql=00_ETLDB.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn%  -d master -v rootdir="%rootdir%" db="%db%" -i "%p%\%%f"
)
REM Create Schema
SET p=%instdir%\EFW
SET sql=EFW.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn%  -d %db% -i "%p%\%%f"
)
REM 01 Level
SET p=%instdir%\DataLoad
SET sql=01_ConnectionStatus.sql _01_ConnectionType.sql _01_Flight.sql 01_Meta.sql _01_Package.sql _01_Schedule.sql _01_TableType.sql _01_Vendor.sql _01_VISN.sql 01_Wrapper.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn%  -d %db% -i "%p%\%%f"
)
REM 02 Level
SET p=%instdir%\DataLoad
SET sql=_02_System.sql _02_Facility.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn%  -d %db% -i "%p%\%%f"
)
REM 03 Level
SET p=%instdir%\DataLoad
SET sql=_03_Connection.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn%  -d %db% -i "%p%\%%f"
)
REM 04 Level
SET p=%instdir%\DataLoad
SET sql=_04_FlightPackage.sql _04_Table.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn%  -d %db% -i "%p%\%%f"
)
REM Procs
SET p=%instdir%\Procs
SET sql=TaskRefresh.sql JobCreate.sql JobDelete.sql ExecutionLogCreate.sql ExecutionLogError.sql ExecutionLogSetID.sql ExecutionLogStart.sql ExecutionLogStatusReport.sql ExecutionLogSuccess.sql ExecutionRun.sql DynaMerge.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn%  -d %db% -i "%p%\%%f"
)
REM Install
SET p=%instdir%\ispac
SET sql=_ETLUnInstall.sql _ETLInstall.sql
for %%f in ( %sql% ) do (
	sqlcmd %cn% -d %db% -v instdir="%instdir%\ispac" -i "%p%\%%f"
)


GOTO :EOF
:USAGE
	@ECHO OFF
	ECHO Usage: %0 DriveLetter InstallationDirectory
	ECHO Example Local usage: %0 c: c:\Projects\RTLS_NDRDW\Database\ETLFramework\ETLFramework
	ECHO Example VHACDWETL03 usage: %0 d: d:\sw\ETLFramework\ETLFrameworkYYYYMMDD
:EOF