﻿

--
--
--
IF EXISTS (SELECT * FROM sys.objects [a] WHERE type = 'P' AND name = 'ExecutionRun1' AND [a].[schema_id] = SCHEMA_ID('ETLFramework'))
BEGIN
	DROP PROCEDURE [ETLFramework].[ExecutionRun1]
	PRINT 'DROP PROCEDURE [ETLFramework].[ExecutionRun1]'
END
GO

--
--
--
CREATE PROCEDURE [ETLFramework].[ExecutionRun1] 
	@VISNMasterID INT
	, @JobMasterID INT
	, @ExecutionJobLogID INT
AS
BEGIN
	-- DECLARE @ExecutionJobLogID INT
	DECLARE @dt DATETIME

	-- I like my own start datetime
	SET @dt = GETDATE()

	IF @ExecutionJobLogID = 0
	BEGIN
		-- add a job log record
		INSERT INTO [ETLFramework].[ExecutionJobLog] ( ExecutionJobLogStatusID, ExecutionJobLogStart ) VALUES ( 1, @dt )
		SET @ExecutionJobLogID = @@IDENTITY
		PRINT '@ExecutionJobLogID=' + CAST ( @ExecutionJobLogID AS NVARCHAR(20))

		-- create execution log
		EXEC [ETLFramework].[ExecutionLogCreate] @VISNMasterID=@VISNMasterID, @JobMasterID=@JobMasterID, @ExecutionJobLogID=@ExecutionJobLogID
	END
	--
	--
	--

	-- ExecutionLog

	DECLARE @ExecutionLogID INT
	DECLARE @TaskMasterID INT
	-- DECLARE @VISNMasterID INT
	DECLARE @VISNName NVARCHAR(1024)
	DECLARE @SystemMasterID INT
	DECLARE @SystemName NVARCHAR(1024)
	-- DECLARE @JobMasterID INT
	DECLARE @JobMasterName NVARCHAR(1024)
	DECLARE @RunMasterID INT
	DECLARE @RunMasterName NVARCHAR(1024)
	DECLARE @FlightMasterID INT
	DECLARE @FlightName NVARCHAR(1024)
	DECLARE @TableMasterID INT
	DECLARE @TableName NVARCHAR(1024)
	DECLARE @PackageMasterID INT
	DECLARE @PackageFolder NVARCHAR(1024)
	DECLARE @PackageProject NVARCHAR(1024)
	DECLARE @PackageName NVARCHAR(1024)
	DECLARE @PackageSourceConnectionTypeID INT
	DECLARE @PackageSourceConnectionTypeName NVARCHAR(1024)
	DECLARE @PackageSourceServerName NVARCHAR(1024)
	DECLARE @PackageSourceDatabaseName NVARCHAR(1024)
	DECLARE @PackageSourceSchemaName NVARCHAR(1024)
	DECLARE @PackageDestinationConnectionTypeID INT
	DECLARE @PackageDestinationConnectionTypeName NVARCHAR(1024)
	DECLARE @PackageDestinationServerName NVARCHAR(1024)
	DECLARE @PackageDestinationDatabaseName NVARCHAR(1024)
	DECLARE @PackageDestinationSchemaName NVARCHAR(1024)
--,[PrecedentTask]
--,[ExecutionOrder]
--,[ExecutionJobLogID]
--,[execution_id]
--,[ExecutionLogStart]
--,[ExecutionLogStop]
--,[ExecutionLogStatusID]
--,[ExecutionLogRowsProcessed]
--,[ExecutionLogBytesTransferred]

	DECLARE c CURSOR FOR

SELECT [a].[ExecutionLogID]
      ,[a].[TaskMasterID]
      ,[a].[VISNMasterID]
	  ,[b].[VISNName]
      ,[a].[SystemMasterID]
	  ,[c].[SystemName]
      ,[a].[JobMasterID]
      ,[d].[JobMasterName]
      ,[a].[RunMasterID]
      ,[e].[RunMasterName]
      ,[a].[FlightMasterID]
      ,[f].[FlightName]
      ,[a].[TableMasterID]
      ,[g].[TableName]
      ,[a].[PackageMasterID]
      ,[h].[PackageFolder]
      ,[h].[PackageProject]
	  , CASE [h].[PackageIsGenerated]
			WHEN 1 THEN REPLACE( [h].[PackageName], '~TableName~', [g].[TableName] )  -- handle biml packages
			ELSE [h].[PackageName]
		END AS [PackageName]

	  -- source
      ,[h].[PackageSourceConnectionTypeID]
	,[i].[ConnectionTypeName] AS [PackageSourceConnectionTypeName]
	,[j].[ServerName] AS [PackageSourceServerName]
	,[j].[DatabaseName] AS [PackageSourceDatabaseName]
	,REPLACE( REPLACE( REPLACE( [i].[ConnectionSchemaName], '~VISN~', [b].[VISNName] ), '~Vendor~', [c].[SystemName] ), ' ', '' ) AS [PackageSourceSchemaName]

	  -- destination
      ,[h].[PackageDestinationConnectionTypeID]
	,[k].[ConnectionTypeName] AS [PackageDestinationConnectionTypeName]
	,[l].[ServerName] AS [PackageDestinationServerName]
	,[l].[DatabaseName] AS [PackageDestinationDatabaseName]
	,REPLACE( REPLACE( REPLACE( [k].[ConnectionSchemaName], '~VISN~', [b].[VISNName] ), '~Vendor~', [c].[SystemName] ), ' ', '' ) AS [PackageDestinationSchemaName]
      --,[a].[PrecedentTask]
      --,[a].[ExecutionOrder]
      --,[a].[ExecutionJobLogID]

FROM [ETLFramework].[ExecutionLog] [a] WITH (NOLOCK)
JOIN [ETLFramework].[VISNMaster] [b] ON [a].[VISNMasterID] = [b].[VISNMasterID]
JOIN [ETLFramework].[SystemMaster] [c] ON [a].[SystemMasterID] = [c].[SystemMasterID]
JOIN [ETLFramework].[JobMaster] [d] ON [a].[JobMasterID] = [d].[JobMasterID]
JOIN [ETLFramework].[RunMaster] [e] ON [a].[RunMasterID] = [e].[RunMasterID]
JOIN [ETLFramework].[FlightMaster] [f] ON [a].[FlightMasterID] = [f].[FlightMasterID]
JOIN [ETLFramework].[TableMaster] [g] ON [a].[TableMasterID] = [g].[TableMasterID]
JOIN [ETLFramework].[PackageMaster] [h] ON [a].[PackageMasterID] = [h].[PackageMasterID]
-- source
JOIN [ETLFramework].[ConnectionType] [i] ON [h].[PackageSourceConnectionTypeID] = [i].[ConnectionTypeID]
JOIN [ETLFramework].[ConnectionMaster] [j] ON [h].[PackageSourceConnectionTypeID] = [j].[ConnectionTypeID]
	AND [a].[VISNMasterID] = [j].[VISNMasterID]
	AND [a].[SystemMasterID] = [j].[SystemMasterID] -- will fail for ConnectionTypeID other than 5
-- destination
	JOIN [ETLFramework].[ConnectionType] [k] ON [h].[PackageDestinationConnectionTypeID] = [k].[ConnectionTypeID]
	JOIN [ETLFramework].[ConnectionMaster] [l] ON [h].[PackageDestinationConnectionTypeID] = [l].[ConnectionTypeID]
		AND [a].[VISNMasterID] = [l].[VISNMasterID]
		-- AND [a].[SystemMasterID] = [l].[SystemMasterID] -- probably need case stmt
WHERE [a].[ExecutionJobLogID] = @ExecutionJobLogID
AND [a].[ExecutionLogStop] IS NULL

ORDER BY [a].[ExecutionLogID]


		OPEN c
		FETCH NEXT FROM c INTO 
			@ExecutionLogID
			, @TaskMasterID
			, @VISNMasterID
			, @VISNName
			, @SystemMasterID
			, @SystemName
			, @JobMasterID
			, @JobMasterName
			, @RunMasterID
			, @RunMasterName
			, @FlightMasterID
			, @FlightName
			, @TableMasterID
			, @TableName
			, @PackageMasterID
			, @PackageFolder
			, @PackageProject
			, @PackageName
			, @PackageSourceConnectionTypeID
			, @PackageSourceConnectionTypeName
			, @PackageSourceServerName
			, @PackageSourceDatabaseName
			, @PackageSourceSchemaName
			, @PackageDestinationConnectionTypeID 
			, @PackageDestinationConnectionTypeName 
			, @PackageDestinationServerName 
			, @PackageDestinationDatabaseName
			, @PackageDestinationSchemaName



		WHILE @@FETCH_STATUS = 0
		BEGIN

			PRINT '@ExecutionLogID: ' + CAST( @ExecutionLogID AS NVARCHAR(5)) 
				+ ' @VISNName: ' + @VISNName
				+ ' @SystemName: ' + @SystemName
				+ ' @JobMasterName: ' + @JobMasterName
				+ ' @RunMasterName: ' + @RunMasterName
				+ ' @FlightName: ' + @FlightName
				+ ' @TableName: ' + @TableName
				+ ' @PackageName: ' + @PackageFolder + '\' + @PackageProject + '\' + @PackageName 
				+ ' @PackageSource: ' + @PackageSourceServerName + '.' + @PackageSourceDatabaseName + '.' + @PackageSourceSchemaName
				+ ' @Destination: ' + @PackageDestinationServerName + '.' + @PackageDestinationDatabaseName + '.' + @PackageDestinationSchemaName

			Declare @execution_id bigint
			EXEC [SSISDB].[catalog].[create_execution] @package_name=@PackageName, @execution_id=@execution_id OUTPUT, @folder_name=@PackageFolder, @project_name=@PackageProject, @use32bitruntime=False, @reference_id=Null
			EXEC [ETLFramework].[ExecutionLogSetID] @ExecutionLogID=@ExecutionLogID, @execution_id=@execution_id
			EXEC [ETLFramework].[ExecutionLogStart] @ExecutionLogID=@ExecutionLogID

			PRINT '@execution_id=' + CAST( @execution_id AS VARCHAR(10))

			BEGIN TRY
				DECLARE @var0 sql_variant = CAST( @PackageDestinationDatabaseName AS sql_variant )
				EXEC [SSISDB].[catalog].[set_execution_parameter_value] @execution_id,  @object_type=20, @parameter_name=N'DestinationDatabaseName', @parameter_value=@var0
				DECLARE @var1 sql_variant = CAST( @PackageDestinationSchemaName AS sql_variant )
				EXEC [SSISDB].[catalog].[set_execution_parameter_value] @execution_id,  @object_type=20, @parameter_name=N'DestinationDatabaseSchema', @parameter_value=@var1
				DECLARE @var2 sql_variant = CAST( @PackageDestinationServerName AS sql_variant )
				EXEC [SSISDB].[catalog].[set_execution_parameter_value] @execution_id,  @object_type=20, @parameter_name=N'DestinationServerName', @parameter_value=@var2
				DECLARE @var3 int = @ExecutionLogID
				EXEC [SSISDB].[catalog].[set_execution_parameter_value] @execution_id,  @object_type=20, @parameter_name=N'ExecutionLogID', @parameter_value=@var3
				DECLARE @var4 sql_variant = CAST( @PackageSourceDatabaseName AS sql_variant )
				EXEC [SSISDB].[catalog].[set_execution_parameter_value] @execution_id,  @object_type=20, @parameter_name=N'SourceDatabaseName', @parameter_value=@var4
				DECLARE @var5 sql_variant = CAST( @PackageSourceSchemaName AS sql_variant )
				EXEC [SSISDB].[catalog].[set_execution_parameter_value] @execution_id,  @object_type=20, @parameter_name=N'SourceDatabaseSchema', @parameter_value=@var5
				DECLARE @var6 sql_variant = CAST( @PackageSourceServerName AS sql_variant )
				EXEC [SSISDB].[catalog].[set_execution_parameter_value] @execution_id,  @object_type=20, @parameter_name=N'SourceServerName', @parameter_value=@var6
				DECLARE @var7 sql_variant = CAST( @TableName AS sql_variant )
				EXEC [SSISDB].[catalog].[set_execution_parameter_value] @execution_id,  @object_type=20, @parameter_name=N'TableName', @parameter_value=@var7
				DECLARE @var8 int = @VISNMasterID
				EXEC [SSISDB].[catalog].[set_execution_parameter_value] @execution_id,  @object_type=20, @parameter_name=N'VISNID', @parameter_value=@var8
				DECLARE @var9 smallint = 1
				EXEC [SSISDB].[catalog].[set_execution_parameter_value] @execution_id,  @object_type=50, @parameter_name=N'LOGGING_LEVEL', @parameter_value=@var9
				EXEC [SSISDB].[catalog].[set_execution_parameter_value] @execution_id,  @object_type=50, @parameter_name=N'SYNCHRONIZED', @parameter_value=1
				EXEC [SSISDB].[catalog].[start_execution] @execution_id
			END TRY
			BEGIN CATCH
				PRINT ERROR_MESSAGE()
				EXEC [ETLFramework].[ExecutionLogError] @ExecutionLogID=@ExecutionLogID
			END CATCH


			FETCH NEXT FROM c INTO
				@ExecutionLogID
				, @TaskMasterID
				, @VISNMasterID
				, @VISNName
				, @SystemMasterID
				, @SystemName
				, @JobMasterID
				, @JobMasterName
				, @RunMasterID
				, @RunMasterName
				, @FlightMasterID
				, @FlightName
				, @TableMasterID
				, @TableName
				, @PackageMasterID
				, @PackageFolder
				, @PackageProject
				, @PackageName
				, @PackageSourceConnectionTypeID
				, @PackageSourceConnectionTypeName
				, @PackageSourceServerName
				, @PackageSourceDatabaseName
				, @PackageSourceSchemaName
				, @PackageDestinationConnectionTypeID 
				, @PackageDestinationConnectionTypeName 
				, @PackageDestinationServerName 
				, @PackageDestinationDatabaseName
				, @PackageDestinationSchemaName


		END
		CLOSE c
		DEALLOCATE c

			UPDATE [ETLFramework].[ExecutionJobLog] 
			SET [ExecutionJobLogStop] = GETDATE()
			, [ExecutionJobLogStatusID] = 2 -- success
			WHERE [ExecutionJobLogID] = @ExecutionJobLogID

			-- cleanup anyone who thinks they are running
			--SELECT * FROM [ETLFramework].[ExecutionLog] [a] WITH (NOLOCK)
			--WHERE [ExecutionLogStatusID] = 1 -- running
			--AND [ExecutionJobLogID] = @ExecutionJobLogID

			UPDATE [ETLFramework].[ExecutionLog]
			SET [ExecutionLogStop] = GETDATE()
			, [ExecutionLogStatusID] = 3 -- error
			WHERE [ExecutionLogStatusID] = 1 -- somehow left running
			AND [ExecutionJobLogID] = @ExecutionJobLogID
  
END
GO
PRINT 'CREATE PROCEDURE [ETLFramework].[ExecutionRun1]'
