﻿
--
--
--
IF EXISTS (SELECT * FROM sys.objects [a] WHERE type = 'P' AND name = 'ExecutionLogCreate' AND [a].[schema_id] = SCHEMA_ID('ETLFramework'))
BEGIN
	DROP PROCEDURE [ETLFramework].[ExecutionLogCreate]
	PRINT 'DROP PROCEDURE [ETLFramework].[ExecutionLogCreate]'
END
GO

--
-- hardcoded for [NDRDW].[Framework]
--
CREATE PROCEDURE [ETLFramework].[ExecutionLogCreate] 
	@VISNMasterID INT
	, @JobMasterID INT
	, @ExecutionJobLogID INT
AS
BEGIN
DECLARE @dt DATETIME
SET @dt = GETDATE()

	INSERT INTO [ETLFramework].[ExecutionLog]
           (
[VISNMasterID]
, [JobMasterID]
, [RunMasterID]
, [FlightMasterID]
, [SystemMasterID]
, [TableMasterID]
, [TaskMasterID]
, [PackageMasterID]
, [PrecedentTask]
, [ExecutionOrder]
, [ExecutionJobLogID]

		   ----[TaskMasterID]
     ----      ,[VISNMasterID]
     ----      ,[SystemMasterID]
     ----      ,[JobMasterID]
     ----      ,[RunMasterID]
     ----      ,[FlightMasterID]
     ----      ,[TableMasterID]
     ----      ,[PackageMasterID]
     ----      ,[PrecedentTask]
     ----      ,[ExecutionOrder]
     ----      ,[ExecutionJobLogID]
           --,[execution_id]
           --,[ExecutionLogStart]
           --,[ExecutionLogStop]
           --,[ExecutionLogStatusID]
           --,[ExecutionLogRowsProcessed]
           --,[ExecutionLogBytesTransferred]
		   )


SELECT
	[a].[VISNMasterID]
	, [b].[JobMasterID]
	, [c].[RunMasterID]
	, [d].[FlightMasterID]
	, [e].[SystemMasterID]
	, [e].[TableMasterID]
	, [f].[TaskMasterID]
	, [g].[PackageMasterID]
	, [f].[PrecedentTask]
	, [f].[ExecutionOrder]
	, @ExecutionJobLogID

FROM [ETLFramework].[VISNMaster] [a]
JOIN [ETLFramework].[JobMaster] [b] ON [b].[JobMasterID] = @JobMasterID
JOIN [ETLFramework].[RunMaster] [c] ON [b].[JobMasterID] = [c].[JobMasterID]
JOIN [ETLFramework].[FlightMaster] [d] ON [d].[FlightMasterID] = [c].[FlightMasterID]
JOIN [ETLFramework].[TableMaster] [e] ON [e].[TableMasterID] = [c].[TableMasterID]
JOIN [ETLFramework].[TaskMaster] [f] ON [f].[RunMasterID] = [c].[RunMasterID]
JOIN [ETLFramework].[PackageMaster] [g] ON [g].[PackageMasterID] = [f].[PackageMasterID]
WHERE [a].[VISNMasterID] = @VISNMasterID



	--SELECT 
	--[a].[TaskMasterID]
	--, @VISNMasterID -- [b].[VISNMasterID]
	--,[c].[SystemMasterID]
	--,[d].[JobMasterID]
	--,[e].[RunMasterID]
	--,[f].[FlightMasterID]
	--,[g].[TableMasterID]
	--,[h].[PackageMasterID]
	--,[a].[PrecedentTask]
	--,[a].[ExecutionOrder]
	--, @ExecutionJobLogID


	--FROM [ETLFramework].[TaskMaster] [a]
	--JOIN [ETLFramework].[VISNMaster] [b] ON [a].[VISNMasterID] = [b].[VISNMasterID]
	--JOIN [ETLFramework].[SystemMaster] [c] ON [a].[SystemMasterID] = [c].[SystemMasterID]
	--JOIN [ETLFramework].[JobMaster] [d] ON [a].[JobMasterID] = [d].[JobMasterID]
	--JOIN [ETLFramework].[RunMaster] [e] ON [a].[RunMasterID] = [e].[RunMasterID]
	--JOIN [ETLFramework].[FlightMaster] [f] ON [a].[FlightMasterID] = [f].[FlightMasterID]
	--JOIN [ETLFramework].[TableMaster] [g] ON [a].[TableMasterID] = [g].[TableMasterID]
	--JOIN [ETLFramework].[PackageMaster] [h] ON [a].[PackageMasterID] = [h].[PackageMasterID]
	---- source
	--JOIN [ETLFramework].[ConnectionType] [i] ON [a].[PackageSourceConnectionTypeID] = [i].[ConnectionTypeID]
	--JOIN [ETLFramework].[ConnectionMaster] [j] ON [a].[PackageSourceConnectionTypeID] = [j].[ConnectionTypeID]
	--	AND [a].[VISNMasterID] = [j].[VISNMasterID]
	--	AND [a].[SystemMasterID] = [j].[SystemMasterID] -- will fail for ConnectionTypeID other than 5
	---- destination
	--JOIN [ETLFramework].[ConnectionType] [k] ON [a].[PackageDestinationConnectionTypeID] = [k].[ConnectionTypeID]
	--JOIN [ETLFramework].[ConnectionMaster] [l] ON [a].[PackageDestinationConnectionTypeID] = [l].[ConnectionTypeID]
	--	AND [a].[VISNMasterID] = [l].[VISNMasterID]
	--	-- AND [a].[SystemMasterID] = [l].[SystemMasterID] -- probably need case stmt


	--WHERE [a].[JobMasterID] = @JobMasterID

	--ORDER BY [a].[JobMasterID], [a].[ExecutionOrder]
  

  
END
GO
PRINT 'CREATE PROCEDURE [ETLFramework].[ExecutionLogCreate]'
