﻿

--
--
--
IF EXISTS (SELECT * FROM sys.objects [a] WHERE type = 'P' AND name = 'TaskRefresh' AND [a].[schema_id] = SCHEMA_ID('ETLFramework'))
BEGIN
	DROP PROCEDURE [ETLFramework].[TaskRefresh]
	PRINT 'DROP PROCEDURE [ETLFramework].[TaskRefresh]'
END
GO

--
--
--
CREATE PROCEDURE [ETLFramework].[TaskRefresh] 
AS
BEGIN
	
DECLARE @stmt AS NVARCHAR(MAX)
DECLARE @schema AS NVARCHAR(256)
--
--
--
SET @schema = 'ETLFramework'


SET @stmt='
	DECLARE @dt AS DATETIME
	SET @dt = GETDATE()

	DELETE FROM [' + @schema + '].[TaskMaster]
	INSERT INTO [' + @schema + '].[TaskMaster]
			   ([TaskMasterID]
			   ,[RunMasterID]
			   ,[PackageMasterID]
			   ,[PackageSourceConnectionTypeID]
			   ,[PackageDestinationConnectionTypeID]
			   ,[SourceConnectionMasterID]
			   ,[DestinationConnectionMasterID]
			   ,[PrecedentTask]
			   ,[ExecutionOrder]
			   ,[CreateDate]
			   ,[UpdateDate])

	SELECT
		ROW_NUMBER() OVER ( ORDER BY [a].[JobMasterID], [a].[RunMasterID], [a].[FlightMasterID], [e].[FlightExecutionOrder] ) AS [TaskMasterID]
		, [a].[RunMasterID]
		, [f].[PackageMasterID]
		, [f].[PackageSourceConnectionTypeID]
		, [f].[PackageDestinationConnectionTypeID]
		, 0 AS [SourceConnectionMasterID]
		, 0 AS [DestinationConnectionMasterID]
		, 0 AS [PrecedentTask]
		, ROW_NUMBER() OVER ( PARTITION BY [a].[JobMasterID] ORDER BY [a].[JobMasterID] ) AS [ExecutionOrder]
		, @dt AS [CreateDate]
		, @dt AS [UpdateDate]

		-- , [e].[ConnectionSchemaName] AS [PackageSourceConnectionSchemaName]
		-- , [c].[PackageDestinationConnectionTypeID]
		-- , [d].[SystemMasterID]
		-- , [c].[ConnectionMasterID] AS [SourceConnectionMasterID]
		--, 1 AS [DestinationConnectionMasterID] -- 1 is the NDR
		--, [b].[FlightExecutionOrder] AS [ExecutionOrder]
		--, [a].[IsEnabled]
	FROM [' + @schema + '].[RunMaster] [a]
	JOIN [' + @schema + '].[JobMaster] [b] ON [a].[JobMasterID] = [b].[JobMasterID]
	JOIN [' + @schema + '].[FlightMaster] [c] ON [a].[FlightMasterID] = [c].[FlightMasterID]
	JOIN [' + @schema + '].[TableMaster] [d] ON [d].[TableMasterID] = [a].[TableMasterID]
	JOIN [' + @schema + '].[FlightPackageMaster] [e] ON [a].[FlightMasterID] = [e].[FlightMasterID]
	JOIN [' + @schema + '].[PackageMaster] [f] ON [e].[PackageMasterID] = [f].[PackageMasterID]

	--JOIN [' + @schema + '].[FlightPackageMaster] [b] ON [a].[FlightMasterID] = [b].[FlightMasterID]
	--JOIN [' + @schema + '].[PackageMaster] [c] ON [c].[PackageMasterID] = [b].[PackageMasterID]
	--JOIN [' + @schema + '].[TableMaster] [d] ON [d].[TableMasterID] = [a].[TableMasterID]
	--JOIN [' + @schema + '].[ConnectionType] [e] ON [e].[ConnectionTypeID] = [c].[PackageSourceConnectionTypeID]
	ORDER BY [a].[JobMasterID]
		, [a].[RunMasterID]
		, [a].[FlightMasterID]
		, [e].[FlightExecutionOrder]

	'


	-- PRINT @stmt
	PRINT 'Refresh TaskMaster'
	EXEC sp_executesql @stmt=@stmt


END
GO
PRINT 'CREATE PROCEDURE [ETLFramework].[TaskRefresh]'
