﻿--
-- build Rtls DB
--
DECLARE @stmt AS NVARCHAR(MAX)
DECLARE @dbname AS NVARCHAR(256)
DECLARE @data_path NVARCHAR(256)

-- this is the local directory
SET @data_path = '$(rootdir)'

SET @dbname = '$(db)'
--
-- create DB
--
USE master;
--
--
--
SET @stmt = 'IF DB_ID (N''' + @dbname + ''') IS NOT NULL
BEGIN
	ALTER DATABASE [' + @dbname + '] SET SINGLE_USER WITH ROLLBACK IMMEDIATE	
	DROP DATABASE ' + @dbname + '
END
'
PRINT @stmt
EXEC sp_executesql @stmt=@stmt
-- go with the installation path for the files
--SET @data_path = (SELECT SUBSTRING(physical_name, 1, CHARINDEX(N'master.mdf', LOWER(physical_name)) - 1)
--					FROM master.sys.master_files
--					WHERE database_id = 1 AND file_id = 1);
SET @stmt = 'CREATE DATABASE ' + @dbname + '
ON PRIMARY
( NAME = ' + @dbname + '_data,
	FILENAME = '''+ @data_path + '\data\' + @dbname + '_data.mdf'',
	SIZE = 150MB,
	MAXSIZE = 150MB,
	FILEGROWTH = 1MB )
LOG ON
( NAME = ' + @dbname + '_log,
	FILENAME = '''+ @data_path + + '\log\' + @dbname + '_log.ldf'',
	SIZE = 2048MB,
	MAXSIZE = 40960MB,
	FILEGROWTH = 1024MB )'
PRINT @stmt
EXEC sp_executesql @stmt=@stmt

SET @stmt = 'USE [' + @dbname + '] CHECKPOINT'
PRINT @stmt
EXEC sp_executesql @stmt=@stmt

-- sometimes the first one does not take due to a race condition and no_wait; I think; I am trying CHECKPOINT first now; seems to work
SET @stmt = 'ALTER DATABASE [' + @dbname + '] SET RECOVERY SIMPLE WITH NO_WAIT'
PRINT @stmt
EXEC sp_executesql @stmt=@stmt
EXEC sp_executesql @stmt=@stmt
EXEC sp_executesql @stmt=@stmt

SET @stmt = 'ALTER AUTHORIZATION ON DATABASE::' + @dbname + ' TO SA'
PRINT @stmt
EXEC sp_executesql @stmt=@stmt
EXEC sp_executesql @stmt=@stmt
EXEC sp_executesql @stmt=@stmt


SET @stmt = 'ALTER DATABASE ' + @dbname + ' ADD FILEGROUP DefFG

-- Add a def1
ALTER DATABASE ' + @dbname + ' ADD FILE ( NAME = f' + @dbname + 'def1
	  , FILENAME = ''' + @data_path + '\data\f' + @dbname + 'def1.ndf''
	  , SIZE = 1024MB, MAXSIZE = 20480MB, FILEGROWTH = 1024MB ) TO FILEGROUP DefFG

-- Add a def2
ALTER DATABASE ' + @dbname + ' ADD FILE ( NAME = f' + @dbname + 'def2
	  , FILENAME = ''' + @data_path + '\data\f' + @dbname + 'def2.ndf''
	  , SIZE = 1024MB, MAXSIZE = 20480MB, FILEGROWTH = 1024MB ) TO FILEGROUP DefFG;

-- Add a def3
ALTER DATABASE ' + @dbname + ' ADD FILE ( NAME = f' + @dbname + 'def3
	  , FILENAME = ''' + @data_path + '\data\f' + @dbname + 'def3.ndf''
	  , SIZE = 1024MB, MAXSIZE = 20480MB, FILEGROWTH = 1024MB ) TO FILEGROUP DefFG;

-- Add a def4
ALTER DATABASE ' + @dbname + ' ADD FILE ( NAME = f' + @dbname + 'def4
	  , FILENAME = ''' + @data_path + '\data\f' + @dbname + 'def4.ndf''
	  , SIZE = 1024MB, MAXSIZE = 20480MB, FILEGROWTH = 1024MB ) TO FILEGROUP DefFG;
'
PRINT @stmt
EXEC sp_executesql @stmt=@stmt

