/*
 * ER/Studio Data Architect 10.0 SQL Code Generation
 * Project :      EFW.DM1
 *
 * Date Created : Tuesday, April 14, 2015 15:31:40
 * Target DBMS : Microsoft SQL Server 2012
 */
use ETL
go

CREATE TABLE RTLS_NDRDW.ColumnMaster(
    ColumnMasterID    int              IDENTITY(1,1),
    TableMasterID     int              NOT NULL,
    ColumnName        nvarchar(128)    NOT NULL,
    ColumnType        nvarchar(128)    NULL,
    ColumnOrder       int              NOT NULL,
    IsEnabled         int              CONSTRAINT [DF__ColumnMas__IsEna__59FA5E80] DEFAULT ((1)) NOT NULL,
    IsPHI             int              NOT NULL,
    IsPII             int              NULL,
    CreateDate        datetime         CONSTRAINT [DF__ColumnMas__Creat__5AEE82B9] DEFAULT (getdate()) NOT NULL,
    UpdateDate        datetime         CONSTRAINT [DF__ColumnMas__Updat__5BE2A6F2] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT PK__ColumnMa__A18E5FA53279B64B PRIMARY KEY CLUSTERED (ColumnMasterID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster', 'column', 'ColumnName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster', 'column', 'ColumnName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The name of the column from the vendor table.', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster', 'column', 'ColumnName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster', 'column', 'ColumnType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster', 'column', 'ColumnType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The column type captured from metadata.', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster', 'column', 'ColumnType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster', 'column', 'ColumnOrder'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster', 'column', 'ColumnOrder'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Numerates the order of the columns within the table the column is in. ', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster', 'column', 'ColumnOrder'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster', 'column', 'IsPHI'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster', 'column', 'IsPHI'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Flag a column as PHI.  Protected health information (PHI) is any information about health status, provision of health care, or payment for health care that can be linked to a specific individual. This is interpreted rather broadly and includes any part of a patient''s medical record or payment history.', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster', 'column', 'IsPHI'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster', 'column', 'IsPII'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster', 'column', 'IsPII'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Flags a column as PII.  Personally identifiable information (PII) is any data that could potentially identify a specific individual. Any information that can be used to distinguish one person from another and can be used for de-anonymizing anonymous data can be considered PII', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster', 'column', 'IsPII'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Contains all columns for the tables within a vendor versions.', 'schema', 'RTLS_NDRDW', 'table', 'ColumnMaster'
go

CREATE TABLE RTLS_NDRDW.ConnectionMaster(
    ConnectionMasterID    int               IDENTITY(1,1),
    SystemMasterID        int               CONSTRAINT [DF__Connectio__Syste__14270015] DEFAULT ((0)) NOT NULL,
    VISNMasterID          int               CONSTRAINT [DF__Connectio__VISNM__151B244E] DEFAULT ((0)) NOT NULL,
    FacilityMasterID      int               CONSTRAINT [DF__Connectio__Facil__160F4887] DEFAULT ((0)) NOT NULL,
    ConnectionTypeID      int               CONSTRAINT [DF__Connectio__Conne__17036CC0] DEFAULT ((0)) NOT NULL,
    ConnectionStatusID    int               NOT NULL,
    ServerName            nvarchar(1024)    NOT NULL,
    DatabaseName          nvarchar(1024)    NOT NULL,
    ConnectionProperty    nvarchar(1024)    NOT NULL,
    ConnectionString      nvarchar(1024)    NOT NULL,
    CreateDate            datetime          CONSTRAINT [DF__Connectio__Creat__17F790F9] DEFAULT (getdate()) NOT NULL,
    UpdateDate            datetime          CONSTRAINT [DF__Connectio__Updat__18EBB532] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT PK_ConnectionMaster PRIMARY KEY CLUSTERED (ConnectionMasterID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionMaster', 'column', 'ServerName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionMaster', 'column', 'ServerName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The server name the where the Vendor software is located.', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionMaster', 'column', 'ServerName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionMaster', 'column', 'DatabaseName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionMaster', 'column', 'DatabaseName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The database name on the server.', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionMaster', 'column', 'DatabaseName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionMaster', 'column', 'ConnectionProperty'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionMaster', 'column', 'ConnectionProperty'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Contains key value pairs required by the vendor''s implementation of their schemas.', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionMaster', 'column', 'ConnectionProperty'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionMaster', 'column', 'ConnectionString'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionMaster', 'column', 'ConnectionString'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Used to connect to a database.  The ETL framework supports building and loading the string here to assist execution or dynamically building during execution.', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionMaster', 'column', 'ConnectionString'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionMaster', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionMaster'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Connection Master is the intersection of VISN, Facility, SystemMaster in hold the database connection information for all location', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionMaster'
go

CREATE TABLE RTLS_NDRDW.ConnectionStatus(
    ConnectionStatusID    int             NOT NULL,
    ConnectionStatus      nvarchar(30)    DEFAULT 'Active' NOT NULL,
    CONSTRAINT PK39 PRIMARY KEY CLUSTERED (ConnectionStatusID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionStatus', 'column', 'ConnectionStatus'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionStatus', 'column', 'ConnectionStatus'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Descibes the disposition of the connection during metadata detection. If ''Active'' the connection was tested and connected during metadata detection.  If metadata detection cannot connect status is set to ''Not Active''.  If metadata detection finds delta in the installed version, the status is ''Not Active, Metadata Error''.   ', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionStatus', 'column', 'ConnectionStatus'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionStatus', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionStatus'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Connection status holds the descriptive statuses on the state of the connection during run time.  

', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionStatus'
go

CREATE TABLE RTLS_NDRDW.ConnectionType(
    ConnectionTypeID        int              IDENTITY(1,1),
    ConnectionTypeName      nvarchar(128)    NOT NULL,
    ConnectionSchemaName    nvarchar(128)    NOT NULL,
    CreateDate              datetime         CONSTRAINT [DF__Connectio__Creat__797309D9] DEFAULT (getdate()) NOT NULL,
    UpdateDate              datetime         CONSTRAINT [DF__Connectio__Updat__7A672E12] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT PK__Connecti__69EB7425FA0412B4 PRIMARY KEY CLUSTERED (ConnectionTypeID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionType', 'column', 'ConnectionTypeName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionType', 'column', 'ConnectionTypeName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Identify the schema name needed for the specific connection NDR, NDRVendor, NDRVendorVISN, NDRVendorVISNStage, VISNVendorSource and ETLFramework.
', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionType', 'column', 'ConnectionTypeName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionType', 'column', 'ConnectionSchemaName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionType', 'column', 'ConnectionSchemaName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Schema names needed for various connection types. A simple string substitution algorithm is used to replace the ~Vendor~ string with the Vendor name and the ~VISN~ with the VISN name. Possible values are; NDR, NDR~Vendor~, NDR~Vendor~~VISN~, NDR~Vendor~~VISN~Stage, dbo and ETLFramework.', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionType', 'column', 'ConnectionSchemaName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionType', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Used to identify and translate source and target schemas.  A ConnectionTypeName is related to a connection and a pattern substitution algorithm is utilized to determine the value of the needed schema name.
', 'schema', 'RTLS_NDRDW', 'table', 'ConnectionType'
go

CREATE TABLE RTLS_NDRDW.CurrentMetadataExtract(
    CurrentMetadataExtractID         int               IDENTITY(1,1),
    SystemMasterID                   int               NOT NULL,
    TableOwner                       varchar(128)      NULL,
    TableName                        varchar(128)      NULL,
    ColumnName                       varchar(128)      NULL,
    ObjectType                       varchar(8)        NULL,
    DataType                         varchar(128)      NOT NULL,
    ColumnOrder                      int               NOT NULL,
    ColumnLength                     int               NOT NULL,
    DefaultValue                     nvarchar(4000)    NULL,
    AllowsNulls                      varchar(254)      NOT NULL,
    ObjectDescription                nvarchar(4000)    NULL,
    IsTableAndColumnMasterUpdated    bit               CONSTRAINT [DF__CurrentMe__IsTab__59063A47] DEFAULT ((0)) NOT NULL,
    CreateDate                       datetime          NULL,
    CONSTRAINT PK_CurrentMetadataExtract PRIMARY KEY CLUSTERED (CurrentMetadataExtractID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'CurrentMetadataExtractID'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'CurrentMetadataExtractID'
END
exec sys.sp_addextendedproperty 'MS_Description', '.', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'CurrentMetadataExtractID'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'TableOwner'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'TableOwner'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Object owner name.', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'TableOwner'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'TableName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'TableName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Name of the user or configuration table.  System tables are not tracked.', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'TableName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'ColumnName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'ColumnName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Column name for each column of the table returned.', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'ColumnName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'ObjectType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'ObjectType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'List of object types. Example values include D for Database, U for User Table, and PK for Primary Key.', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'ObjectType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'DataType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'DataType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Displays the data type for the selected column.', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'DataType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'ColumnOrder'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'ColumnOrder'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Numberates the order of the column within the table.', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'ColumnOrder'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'ColumnLength'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'ColumnLength'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Shows the number of characters allowed for character-based data types. This property is only available for character-based data types.', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'ColumnLength'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'DefaultValue'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'DefaultValue'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Displays the default for this column whenever no value is specified for this column.', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'DefaultValue'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'AllowsNulls'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'AllowsNulls'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Indicates whether this column allows nulls.', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'AllowsNulls'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'ObjectDescription'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'ObjectDescription'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The object description pulled from the extended database properties.', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'ObjectDescription'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'IsTableAndColumnMasterUpdated'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'IsTableAndColumnMasterUpdated'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Flag indicating that TableMaster and ColumnMaster tables have been updated with data pulled from this table.', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'IsTableAndColumnMasterUpdated'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'CreateDate'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'CreateDate'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The date and time the metadata extract record was written to the database.', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', 'column', 'CreateDate'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The CurrentMetadataExtract table contains column-level and table-level metadata details extracted from the source database. This table contains the baseline metadata from the source.  Current contains the versioned Vendor metadata.', 'schema', 'RTLS_NDRDW', 'table', 'CurrentMetadataExtract'
go

CREATE TABLE RTLS_NDRDW.DataDictionary(
    DataDictionaryID     int               IDENTITY(1,1),
    TableOwner           varchar(128)      NULL,
    TableName            varchar(128)      NULL,
    ColumnName           varchar(128)      NULL,
    XType                varchar(8)        NULL,
    ObjectDescription    nvarchar(4000)    NULL,
    CreateDate           datetime          NULL,
    UpdateDate           datetime          NULL,
    CONSTRAINT PK_DataDictionary PRIMARY KEY CLUSTERED (DataDictionaryID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'TableOwner'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'TableOwner'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Object owner name.', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'TableOwner'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'TableName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'TableName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Name of the user or configuration table.  System tables are not tracked.', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'TableName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'ColumnName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'ColumnName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Column name, for each column of the table returned.', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'ColumnName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'XType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'XType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This field captures the object type.  There are two allowable object types for this table.  D = Database.  U = User table.', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'XType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'ObjectDescription'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'ObjectDescription'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The database or table description pulled from the extended database properties.', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'ObjectDescription'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'CreateDate'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'CreateDate'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The date and time the temporary data dictionary record was written to the database.', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', 'column', 'CreateDate'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This table contains information needed to build the data dictionary.  The data in this table is non-persistent.  Before the data is truncated, it is stored in the appropriate MetadataExtract table.', 'schema', 'RTLS_NDRDW', 'table', 'DataDictionary'
go

CREATE TABLE RTLS_NDRDW.DataFileConfiguration(
    DataFileConfigurationID    int             IDENTITY(1,1),
    SystemMasterID             int             NOT NULL,
    FileNumber                 smallint        NULL,
    FileSizeInMB               int             NULL,
    SpaceUsedInMB              int             NULL,
    FreeSpaceInMB              int             NULL,
    DataFileName               varchar(500)    NULL,
    CreateDate                 datetime        NULL,
    UpdateDate                 datetime        NULL,
    CONSTRAINT PK_DataFileConfiguration PRIMARY KEY CLUSTERED (DataFileConfigurationID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration', 'column', 'FileNumber'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration', 'column', 'FileNumber'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The file number associated with each data or log file.  File number sequencing is maintained by the DBMS.', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration', 'column', 'FileNumber'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration', 'column', 'FileSizeInMB'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration', 'column', 'FileSizeInMB'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The size of the file on disk, in megabytes.', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration', 'column', 'FileSizeInMB'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration', 'column', 'SpaceUsedInMB'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration', 'column', 'SpaceUsedInMB'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The amount of disk space consumed by a file, in megabytes.', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration', 'column', 'SpaceUsedInMB'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration', 'column', 'FreeSpaceInMB'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration', 'column', 'FreeSpaceInMB'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The amount of free space in a data or log file.  Measured in megabytes.  This information can be used to shrink data files as needed if there is a lot of free space in the files.', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration', 'column', 'FreeSpaceInMB'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration', 'column', 'DataFileName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration', 'column', 'DataFileName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The name of the data or log file as it exists on disk.', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration', 'column', 'DataFileName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This table contains details about database operating system files: the data file and transactional log file. 
', 'schema', 'RTLS_NDRDW', 'table', 'DataFileConfiguration'
go

CREATE TABLE RTLS_NDRDW.DMLOperation(
    DMLOperationID      int             IDENTITY(1,1),
    DMLOperationType    varchar(128)    NOT NULL,
    CONSTRAINT PK_DMLOperation PRIMARY KEY CLUSTERED (DMLOperationID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DMLOperation', 'column', 'DMLOperationType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DMLOperation', 'column', 'DMLOperationType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The DML operation type (update, insert, delete).  ', 'schema', 'RTLS_NDRDW', 'table', 'DMLOperation', 'column', 'DMLOperationType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DMLOperation', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'DMLOperation'
END
exec sys.sp_addextendedproperty 'MS_Description', 'DML is the abbreviation of Data Manipulation Language and is used to track modifications made to data within a database, including the metadata.  This table contains the allowable data values for tracking table-level and column-level DML changes that have been detected between versions of the source systems.  ', 'schema', 'RTLS_NDRDW', 'table', 'DMLOperation'
go

CREATE TABLE RTLS_NDRDW.ETLMetadataIncrementalChanges(
    ETLMetadataIncrementalChangesID            int               IDENTITY(1,1),
    SystemMasterID                             int               NOT NULL,
    DMLOperationID                             int               CONSTRAINT [DF__ETLMetada__DMLOp__2180FB33] DEFAULT ((4)) NOT NULL,
    CurrentMetadataExtractID                   int               NOT NULL,
    ConnectionMasterID                         int               NOT NULL,
    TableOwner                                 varchar(128)      NULL,
    TableName                                  varchar(128)      NULL,
    ColumnName                                 varchar(128)      NULL,
    ObjectType                                 varchar(8)        NULL,
    DataType                                   varchar(128)      NOT NULL,
    ColumnLength                               int               NOT NULL,
    DefaultValue                               nvarchar(4000)    NULL,
    AllowsNulls                                varchar(254)      NOT NULL,
    ObjectDescription                          nvarchar(4000)    NULL,
    CreateDate                                 datetime          NULL,
    IsUpdatedInCurrentMetadataConfiguration    bit               CONSTRAINT [DF__ETLMetada__IsUpd__22751F6C] DEFAULT ((0)) NOT NULL,
    IsPulledByMetaTool                         bit               CONSTRAINT [DF__ETLMetada__IsPul__236943A5] DEFAULT ((0)) NOT NULL,
    CONSTRAINT PK_ETLMetadataIncrementalChanges PRIMARY KEY CLUSTERED (ETLMetadataIncrementalChangesID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'TableOwner'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'TableOwner'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Object owner name.', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'TableOwner'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'TableName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'TableName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Name of the user or configuration table.  System tables are not tracked.', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'TableName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'ColumnName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'ColumnName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Column name, for each column of the table returned.', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'ColumnName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'ObjectType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'ObjectType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'List of object types. Example values include D for Database, U for User Table, and PK for Primary Key.', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'ObjectType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'DataType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'DataType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Displays the data type for the selected column.', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'DataType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'ColumnLength'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'ColumnLength'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Shows the number of characters allowed for character-based data types. This property is only available for character-based data types.', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'ColumnLength'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'DefaultValue'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'DefaultValue'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Displays the default for this column whenever no value is specified for this column.', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'DefaultValue'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'AllowsNulls'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'AllowsNulls'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Indicates whether this column allows nulls.', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'AllowsNulls'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'ObjectDescription'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'ObjectDescription'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The object description pulled from the extended database properties.', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'ObjectDescription'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'CreateDate'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'CreateDate'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The date and time the metadata change record was written to the database.', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'CreateDate'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'IsUpdatedInCurrentMetadataConfiguration'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'IsUpdatedInCurrentMetadataConfiguration'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Flag indicating the existing metadata configuration was updated with the metadata change record.', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'IsUpdatedInCurrentMetadataConfiguration'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'IsPulledByMetaTool'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'IsPulledByMetaTool'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Flag indicating that the metadata change record was pulled by the ETL.', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', 'column', 'IsPulledByMetaTool'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Table that contains column-level details about metadata changes.', 'schema', 'RTLS_NDRDW', 'table', 'ETLMetadataIncrementalChanges'
go

CREATE TABLE RTLS_NDRDW.ExecutionCode(
    CodeID             int              IDENTITY(1,1),
    CodeType           nvarchar(255)    NOT NULL,
    Code               nchar(1)         NOT NULL,
    CodeDescription    nvarchar(255)    NOT NULL,
    CONSTRAINT PK10 PRIMARY KEY NONCLUSTERED (CodeID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionCode', 'column', 'CodeType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionCode', 'column', 'CodeType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'CodeType is used to group codes used with diferent tables.  ', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionCode', 'column', 'CodeType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionCode', 'column', 'Code'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionCode', 'column', 'Code'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Code give the developer options on out to decode actions within the ETL framework. ', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionCode', 'column', 'Code'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionCode', 'column', 'CodeDescription'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionCode', 'column', 'CodeDescription'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Provides a longer definition to explan how to use the code.  ', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionCode', 'column', 'CodeDescription'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionCode', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionCode'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This is the code table for the ETL Framework and used to track and give status to the Execution recoreded in the Execution Log.', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionCode'
go

CREATE TABLE RTLS_NDRDW.ExecutionJobLog(
    ExecutionJobLogID          int         IDENTITY(1,1),
    ExecutionJobLogStatusID    int         CONSTRAINT [DF__Execution__Execu__787EE5A0] DEFAULT ((0)) NOT NULL,
    ExecutionJobLogStart       datetime    NULL,
    ExecutionJobLogStop        datetime    NULL,
    CONSTRAINT PK__Executio__C7C9AA7838961CDC PRIMARY KEY CLUSTERED (ExecutionJobLogID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionJobLog', 'column', 'ExecutionJobLogStatusID'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionJobLog', 'column', 'ExecutionJobLogStatusID'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This is a foreign key into the Execution Code table equivalent to ExecutionCodeID.', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionJobLog', 'column', 'ExecutionJobLogStatusID'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionJobLog', 'column', 'ExecutionJobLogStart'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionJobLog', 'column', 'ExecutionJobLogStart'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Job initiation time.', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionJobLog', 'column', 'ExecutionJobLogStart'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionJobLog', 'column', 'ExecutionJobLogStop'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionJobLog', 'column', 'ExecutionJobLogStop'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Job completion time.', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionJobLog', 'column', 'ExecutionJobLogStop'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionJobLog', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionJobLog'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Maintains the overall status for all ExecutionLog rows that are associated with a Job.  The overall job start and stop times are tracked as well as the currect status.
', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionJobLog'
go

CREATE TABLE RTLS_NDRDW.ExecutionLog(
    ExecutionLogID                  int         IDENTITY(1,1),
    TaskMasterID                    int         NOT NULL,
    VISNMasterID                    int         NOT NULL,
    SystemMasterID                  int         NOT NULL,
    JobMasterID                     int         NOT NULL,
    RunMasterID                     int         NOT NULL,
    FlightMasterID                  int         NOT NULL,
    TableMasterID                   int         NOT NULL,
    PackageMasterID                 int         NOT NULL,
    PrecedentTask                   int         NOT NULL,
    ExecutionOrder                  int         NOT NULL,
    ExecutionJobLogID               int         CONSTRAINT [DF__Execution__Execu__19DFD96B] DEFAULT ((0)) NOT NULL,
    execution_id                    bigint      NULL,
    ExecutionLogStart               datetime    NULL,
    ExecutionLogStop                datetime    NULL,
    ExecutionLogStatusID            int         CONSTRAINT [DF__Execution__Execu__1AD3FDA4] DEFAULT ((0)) NOT NULL,
    ExecutionLogRowsProcessed       bigint      CONSTRAINT [DF__Execution__Execu__1BC821DD] DEFAULT ((0)) NOT NULL,
    ExecutionLogBytesTransferred    bigint      CONSTRAINT [DF__Execution__Execu__1CBC4616] DEFAULT ((0)) NOT NULL,
    CONSTRAINT PK_ExecutionLog PRIMARY KEY CLUSTERED (ExecutionLogID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'PrecedentTask'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'PrecedentTask'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The precedent task value is used to organize job execution by grouping packages using integer values, e.g., such as 1 and 2 where all packages with a 1 are completed prior to running those with 2.
', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'PrecedentTask'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionOrder'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionOrder'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The order in which the Packages are run for each Job within the respective precedent (if used).', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionOrder'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionJobLogID'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionJobLogID'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This is a foreign key into the Execution Code table equivalent to ExecutionCodeID.', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionJobLogID'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'execution_id'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'execution_id'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The execution_id is returned by the catalog.create_execution stored procedure when a package is executed.  This value is used to relate information from the SSIS catalog to the ETLFramework.
', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'execution_id'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionLogStart'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionLogStart'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Package initiation time.

', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionLogStart'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionLogStop'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionLogStop'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Package completion time.', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionLogStop'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionLogStatusID'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionLogStatusID'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This is a foreign key into the Execution Code table equivalent to ExecutionCodeID.', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionLogStatusID'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionLogRowsProcessed'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionLogRowsProcessed'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Number of rows in the source system that the package identified to be transferred.', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionLogRowsProcessed'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionLogBytesTransferred'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionLogBytesTransferred'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Number of bytes of data transferred from source to destination by this package.
', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', 'column', 'ExecutionLogBytesTransferred'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog'
END
exec sys.sp_addextendedproperty 'MS_Description', 'A job consists of a number of SSIS packages. The rows for this table contain the parameters needed to run the packages.', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLog'
go

CREATE TABLE RTLS_NDRDW.ExecutionLogHistory(
    ExecutionLogID                  int         IDENTITY(1,1),
    TaskMasterID                    int         NOT NULL,
    VISNMasterID                    int         NOT NULL,
    SystemMasterID                  int         NOT NULL,
    JobMasterID                     int         NOT NULL,
    RunMasterID                     int         NOT NULL,
    FlightMasterID                  int         NOT NULL,
    TableMasterID                   int         NOT NULL,
    PackageMasterID                 int         NOT NULL,
    PrecedentTask                   int         NOT NULL,
    ExecutionOrder                  int         NOT NULL,
    ExecutionJobLogID               int         CONSTRAINT [DF__Execution__Execu__1DB06A4F] DEFAULT ((0)) NOT NULL,
    execution_id                    bigint      NULL,
    ExecutionLogStart               datetime    NULL,
    ExecutionLogStop                datetime    NULL,
    ExecutionLogStatusID            int         CONSTRAINT [DF__Execution__Execu__1EA48E88] DEFAULT ((0)) NOT NULL,
    ExecutionLogRowsProcessed       bigint      CONSTRAINT [DF__Execution__Execu__1F98B2C1] DEFAULT ((0)) NOT NULL,
    ExecutionLogBytesTransferred    bigint      CONSTRAINT [DF__Execution__Execu__208CD6FA] DEFAULT ((0)) NOT NULL
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLogHistory', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLogHistory'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Records are moved form the ExecutionLog table into this table on a recurring basis to keep the size of the execution log table optimal for performance. Definition for this table and its columns are identical to those in the ExecutionLog table.', 'schema', 'RTLS_NDRDW', 'table', 'ExecutionLogHistory'
go

CREATE TABLE RTLS_NDRDW.FacilityMaster(
    FacilityMasterID    int               IDENTITY(1,1),
    VISNMasterID        int               NOT NULL,
    FacilityName        nvarchar(2048)    NOT NULL,
    Description         nvarchar(max)     NULL,
    IsEnabled           int               CONSTRAINT [DF__FacilityM__IsEna__5629CD9C] DEFAULT ((0)) NOT NULL,
    CreateDate          datetime          CONSTRAINT [DF__FacilityM__Creat__571DF1D5] DEFAULT (getdate()) NOT NULL,
    UpdateDate          datetime          CONSTRAINT [DF__FacilityM__Updat__5812160E] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT PK__Facility__EFBAD6A63360DE40 PRIMARY KEY CLUSTERED (FacilityMasterID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'FacilityMaster', 'column', 'FacilityName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'FacilityMaster', 'column', 'FacilityName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The name of the facility.', 'schema', 'RTLS_NDRDW', 'table', 'FacilityMaster', 'column', 'FacilityName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'FacilityMaster', 'column', 'Description'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'FacilityMaster', 'column', 'Description'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The description  of the facility.', 'schema', 'RTLS_NDRDW', 'table', 'FacilityMaster', 'column', 'Description'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'FacilityMaster', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'FacilityMaster'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This table hold all facilities for each VISN', 'schema', 'RTLS_NDRDW', 'table', 'FacilityMaster'
go

CREATE TABLE RTLS_NDRDW.FlightMaster(
    FlightMasterID    int              IDENTITY(1,1),
    FlightName        nvarchar(512)    NOT NULL,
    CreateDate        datetime         CONSTRAINT [DF__FlightMas__Creat__5EBF139D] DEFAULT (getdate()) NOT NULL,
    UpdateDate        datetime         CONSTRAINT [DF__FlightMas__Updat__5FB337D6] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT PK__FlightMa__8A9E148E025315E5 PRIMARY KEY CLUSTERED (FlightMasterID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'FlightMaster', 'column', 'FlightName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'FlightMaster', 'column', 'FlightName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Name assigned to the set of packages that will move data from source through intermediate systems to teh data warehouse.
', 'schema', 'RTLS_NDRDW', 'table', 'FlightMaster', 'column', 'FlightName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'FlightMaster', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'FlightMaster'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This table keeps a name for each documented flight', 'schema', 'RTLS_NDRDW', 'table', 'FlightMaster'
go

CREATE TABLE RTLS_NDRDW.FlightPackageMaster(
    FlightPackageMasterID            int         IDENTITY(1,1),
    FlightMasterID                   int         CONSTRAINT [DF__FlightPac__Fligh__7B5B524B] DEFAULT ((0)) NOT NULL,
    PackageMasterID                  int         CONSTRAINT [DF__FlightPac__Packa__7C4F7684] DEFAULT ((0)) NOT NULL,
    FlightExecutionOrder             int         CONSTRAINT [DF__FlightPac__Fligh__7D439ABD] DEFAULT ((0)) NOT NULL,
    SourceConnectionMasterID         int         CONSTRAINT [DF__FlightPac__Sourc__7E37BEF6] DEFAULT ((0)) NOT NULL,
    DestinationConnectionMasterID    int         CONSTRAINT [DF__FlightPac__Desti__7F2BE32F] DEFAULT ((0)) NOT NULL,
    IsEnabled                        int         CONSTRAINT [DF__FlightPac__IsEna__00200768] DEFAULT ((1)) NOT NULL,
    CreateDate                       datetime    CONSTRAINT [DF__FlightPac__Creat__01142BA1] DEFAULT (getdate()) NOT NULL,
    UpdateDate                       datetime    CONSTRAINT [DF__FlightPac__Updat__02084FDA] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT PK_FlightPackageMaster PRIMARY KEY CLUSTERED (FlightPackageMasterID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'FlightPackageMaster', 'column', 'FlightExecutionOrder'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'FlightPackageMaster', 'column', 'FlightExecutionOrder'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The execution order of the packages within the flight.', 'schema', 'RTLS_NDRDW', 'table', 'FlightPackageMaster', 'column', 'FlightExecutionOrder'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'FlightPackageMaster', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'FlightPackageMaster'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This table is the intersection between FlightMaster and PackageMaster.', 'schema', 'RTLS_NDRDW', 'table', 'FlightPackageMaster'
go

CREATE TABLE RTLS_NDRDW.JobMaster(
    JobMasterID           int               IDENTITY(1,1),
    JobMasterName         nvarchar(1024)    NOT NULL,
    JobMasterOrder        int               CONSTRAINT [DF__JobMaster__JobMa__0C85DE4D] DEFAULT ((0)) NOT NULL,
    IsEnabled             int               CONSTRAINT [DF__JobMaster__IsEna__0D7A0286] DEFAULT ((0)) NOT NULL,
    JobMasterTimeZone     nvarchar(10)      CONSTRAINT [DF__JobMaster__JobMa__0E6E26BF] DEFAULT ('CST') NOT NULL,
    JobMasterStartTime    datetime          CONSTRAINT [DF__JobMaster__JobMa__0F624AF8] DEFAULT ('01/01/2015 02:00:00') NOT NULL,
    ConnectionMasterID    int               CONSTRAINT [DF__JobMaster__Conne__10566F31] DEFAULT ((0)) NOT NULL,
    ScheduleMasterID      int               CONSTRAINT [DF__JobMaster__Sched__114A936A] DEFAULT ((0)) NOT NULL,
    CreateDate            datetime          CONSTRAINT [DF__JobMaster__Creat__123EB7A3] DEFAULT (getdate()) NOT NULL,
    UpdateDate            datetime          CONSTRAINT [DF__JobMaster__Updat__1332DBDC] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT PK__JobMaste__FA85A4BEAB040900 PRIMARY KEY CLUSTERED (JobMasterID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'JobMaster', 'column', 'JobMasterName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'JobMaster', 'column', 'JobMasterName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The name of the Job for the VISN/Vendor/Version', 'schema', 'RTLS_NDRDW', 'table', 'JobMaster', 'column', 'JobMasterName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'JobMaster', 'column', 'JobMasterOrder'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'JobMaster', 'column', 'JobMasterOrder'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The order that the  jobs will execute.', 'schema', 'RTLS_NDRDW', 'table', 'JobMaster', 'column', 'JobMasterOrder'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'JobMaster', 'column', 'JobMasterTimeZone'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'JobMaster', 'column', 'JobMasterTimeZone'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Timezone of the VISN/Facility/Vendor.', 'schema', 'RTLS_NDRDW', 'table', 'JobMaster', 'column', 'JobMasterTimeZone'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'JobMaster', 'column', 'JobMasterStartTime'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'JobMaster', 'column', 'JobMasterStartTime'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The start time with the timezone.', 'schema', 'RTLS_NDRDW', 'table', 'JobMaster', 'column', 'JobMasterStartTime'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'JobMaster', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'JobMaster'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This table is the top level table in the job hierarchy and list all job to load the NDR.', 'schema', 'RTLS_NDRDW', 'table', 'JobMaster'
go

CREATE TABLE RTLS_NDRDW.KeyColumnUsage(
    KeyColumnUsageID    int              IDENTITY(1,1),
    SystemMasterID      int              NOT NULL,
    TableOwner          varchar(128)     NULL,
    TableName           varchar(128)     NULL,
    ColumnName          varchar(128)     NULL,
    ConstraintName      varchar(254)     NULL,
    ConstraintType      varchar(254)     NULL,
    CreateDate          smalldatetime    NULL,
    CONSTRAINT PK_KeyColumnUsage PRIMARY KEY CLUSTERED (KeyColumnUsageID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage', 'column', 'TableOwner'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage', 'column', 'TableOwner'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Object owner name.', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage', 'column', 'TableOwner'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage', 'column', 'TableName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage', 'column', 'TableName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Name of the vendor table.  System tables are not tracked.', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage', 'column', 'TableName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage', 'column', 'ColumnName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage', 'column', 'ColumnName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Column name, for each column of the table returned.', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage', 'column', 'ColumnName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage', 'column', 'ConstraintName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage', 'column', 'ConstraintName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The name of the constraint associated with a column.', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage', 'column', 'ConstraintName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage', 'column', 'ConstraintType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage', 'column', 'ConstraintType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The type of constraint associated with a column. The three possible values are: Primary Key, Foreign Key and Unique Key.', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage', 'column', 'ConstraintType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Table that contains key-level details.', 'schema', 'RTLS_NDRDW', 'table', 'KeyColumnUsage'
go

CREATE TABLE RTLS_NDRDW.MetaWrapper(
    MetaWrapperID          int              IDENTITY(1,1),
    MetaWrapperSchemaID    int              NOT NULL,
    MetaWrapperName        nvarchar(512)    NOT NULL,
    MetaWrapperType        nvarchar(512)    NOT NULL,
    MetaWrapperDefault     nvarchar(512)    NOT NULL,
    CreateDate             datetime         CONSTRAINT [DF__MetaWrapp__Creat__76969D2E] DEFAULT (getdate()) NOT NULL,
    UpdateDate             datetime         CONSTRAINT [DF__MetaWrapp__Updat__778AC167] DEFAULT (getdate()) NOT NULL
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'MetaWrapper', 'column', 'MetaWrapperSchemaID'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'MetaWrapper', 'column', 'MetaWrapperSchemaID'
END
exec sys.sp_addextendedproperty 'MS_Description', 'A value of 1 represents the VISN Schema and a value of 2 represents the Facility level data elements.
', 'schema', 'RTLS_NDRDW', 'table', 'MetaWrapper', 'column', 'MetaWrapperSchemaID'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'MetaWrapper', 'column', 'MetaWrapperName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'MetaWrapper', 'column', 'MetaWrapperName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The name of a field to be added to the Like Schema.

', 'schema', 'RTLS_NDRDW', 'table', 'MetaWrapper', 'column', 'MetaWrapperName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'MetaWrapper', 'column', 'MetaWrapperType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'MetaWrapper', 'column', 'MetaWrapperType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The SQL server data type of the field to be added to the Like Schema.
', 'schema', 'RTLS_NDRDW', 'table', 'MetaWrapper', 'column', 'MetaWrapperType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'MetaWrapper', 'column', 'MetaWrapperDefault'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'MetaWrapper', 'column', 'MetaWrapperDefault'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The default value for the field to be added to the Like Schema.

', 'schema', 'RTLS_NDRDW', 'table', 'MetaWrapper', 'column', 'MetaWrapperDefault'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'MetaWrapper', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'MetaWrapper'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Represent the data elements that are appended when transferring data from stage to like schema.


', 'schema', 'RTLS_NDRDW', 'table', 'MetaWrapper'
go

CREATE TABLE RTLS_NDRDW.PackageMaster(
    PackageMasterID                       int               IDENTITY(1,1),
    PackageName                           nvarchar(1024)    NOT NULL,
    PackageFolder                         nvarchar(1024)    NOT NULL,
    PackageProject                        nvarchar(1024)    NOT NULL,
    PackageIsGenerated                    int               CONSTRAINT [DF__PackageMa__Packa__656C112C] DEFAULT ((0)) NOT NULL,
    PackageSignature                      nvarchar(1024)    NULL,
    PackageSourceConnectionTypeID         int               NOT NULL,
    PackageDestinationConnectionTypeID    int               NOT NULL,
    CreateDate                            datetime          CONSTRAINT [DF__PackageMa__Creat__66603565] DEFAULT (getdate()) NOT NULL,
    UpdateDate                            datetime          CONSTRAINT [DF__PackageMa__Updat__6754599E] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT PK__PackageM__322035EC336CE648 PRIMARY KEY CLUSTERED (PackageMasterID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The name of the Package file within the SSIS catalog.', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageFolder'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageFolder'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The name of the Package folder within the SSIS catalog.', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageFolder'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageProject'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageProject'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The name of the Package product within the SSIS catalog.', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageProject'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageSignature'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageSignature'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Use for configuration properties.', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageSignature'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageSourceConnectionTypeID'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageSourceConnectionTypeID'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This is a foreign key into the ConnectionType table equivalent to ConnectionTypeID.', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageSourceConnectionTypeID'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageDestinationConnectionTypeID'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageDestinationConnectionTypeID'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This is a foreign key into the ConnectionType table equivalent to ConnectionTypeID.', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', 'column', 'PackageDestinationConnectionTypeID'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This table keeps all of the SSIS package.dst file names used for the ETL process.', 'schema', 'RTLS_NDRDW', 'table', 'PackageMaster'
go

CREATE TABLE RTLS_NDRDW.PartitionDetail(
    PartitionDetailID    int             IDENTITY(1,1),
    SystemMasterID       int             NOT NULL,
    TableName            varchar(128)    NULL,
    IndexName            varchar(128)    NULL,
    PartitionScheme      varchar(128)    NULL,
    PartitionFunction    varchar(128)    NULL,
    PartitionNumber      varchar(128)    NULL,
    RowCounter           varchar(128)    NULL,
    TypeDesc             varchar(128)    NULL,
    RangeType            varchar(128)    NULL,
    Boundary             varchar(128)    NULL,
    CreateDate           datetime        NULL,
    UpdateDate           datetime        NULL,
    CONSTRAINT PK_PartitionDetail PRIMARY KEY CLUSTERED (PartitionDetailID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'TableName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'TableName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Name of the user or configuration table that has been partitioned.  System tables are not tracked.', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'TableName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'IndexName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'IndexName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Name of the index that has been partitioned.', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'IndexName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'PartitionScheme'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'PartitionScheme'
END
exec sys.sp_addextendedproperty 'MS_Description', 'A partition scheme is the format that is used to describe how the disk is divided up. The partition scheme will say, as a minimum, where each partition lies on the disk, its size and the type. They differ in how exactly this data is stored on the disk.', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'PartitionScheme'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'PartitionFunction'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'PartitionFunction'
END
exec sys.sp_addextendedproperty 'MS_Description', 'A partition function maps the rows of a table or index into partitions based on the values of a specified column in the table or index. It provides the boundary values of the table partitions.', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'PartitionFunction'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'PartitionNumber'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'PartitionNumber'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The identification number of the partition.', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'PartitionNumber'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'RowCounter'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'RowCounter'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Indicates the approximate number of rows in this partition.', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'RowCounter'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'TypeDesc'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'TypeDesc'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The partition function type.  The only allowable value is RANGE.', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'TypeDesc'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'RangeType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'RangeType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Select either Left boundary or Right boundary to specify whether to include the highest or lowest bounding value within each filegroup you create.', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'RangeType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'Boundary'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'Boundary'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The actual boundary value of the partition.', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', 'column', 'Boundary'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This table contains details about the logical partitioning of database tables and indexes.', 'schema', 'RTLS_NDRDW', 'table', 'PartitionDetail'
go

CREATE TABLE RTLS_NDRDW.RunMaster(
    RunMasterID             int               IDENTITY(1,1),
    JobMasterID             int               NOT NULL,
    FlightMasterID          int               NOT NULL,
    TableMasterID           int               NOT NULL,
    RunMasterName           nvarchar(1024)    NOT NULL,
    LoggingLevelOverride    int               CONSTRAINT [DF__RunMaster__Loggi__70DDC3D8] DEFAULT ((1)) NOT NULL,
    PrecedentRun            int               CONSTRAINT [DF__RunMaster__Prece__71D1E811] DEFAULT ((0)) NOT NULL,
    RunOrderSeq             int               CONSTRAINT [DF__RunMaster__RunOr__72C60C4A] DEFAULT ((1)) NOT NULL,
    IsEnabled               int               CONSTRAINT [DF__RunMaster__IsEna__73BA3083] DEFAULT ((1)) NOT NULL,
    CreateDate              datetime          CONSTRAINT [DF__RunMaster__Creat__74AE54BC] DEFAULT (getdate()) NOT NULL,
    UpdateDate              datetime          CONSTRAINT [DF__RunMaster__Updat__75A278F5] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT PK__RunMaste__EBDE4217EDD19A46 PRIMARY KEY CLUSTERED (RunMasterID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'RunMaster', 'column', 'RunMasterName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'RunMaster', 'column', 'RunMasterName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The name of the table to run a flight.', 'schema', 'RTLS_NDRDW', 'table', 'RunMaster', 'column', 'RunMasterName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'RunMaster', 'column', 'LoggingLevelOverride'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'RunMaster', 'column', 'LoggingLevelOverride'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The logging level set the amount of information collected about the execution of a package.  The details are used for debugging errors that might occur. Higher logging level give more details and introduce more performance impacts.
', 'schema', 'RTLS_NDRDW', 'table', 'RunMaster', 'column', 'LoggingLevelOverride'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'RunMaster', 'column', 'PrecedentRun'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'RunMaster', 'column', 'PrecedentRun'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The precedent run required to run successful prior to execution.', 'schema', 'RTLS_NDRDW', 'table', 'RunMaster', 'column', 'PrecedentRun'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'RunMaster', 'column', 'RunOrderSeq'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'RunMaster', 'column', 'RunOrderSeq'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The order of the runs within the job.', 'schema', 'RTLS_NDRDW', 'table', 'RunMaster', 'column', 'RunOrderSeq'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'RunMaster', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'RunMaster'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This table contains all of the run within a job.', 'schema', 'RTLS_NDRDW', 'table', 'RunMaster'
go

CREATE TABLE RTLS_NDRDW.ScheduleMaster(
    ScheduleMasterID           int              IDENTITY(1,1),
    ScheduleMasterName         nvarchar(512)    NOT NULL,
    ScheduleMasterTimeZone     nvarchar(10)     NULL,
    ScheduleStartTime          datetime         NULL,
    ScheduleStopTime           datetime         NULL,
    ScheduleActualStartTime    datetime         NULL,
    ScheduleActualStopTime     datetime         NULL,
    CreateDate                 datetime         CONSTRAINT [DF__ScheduleM__Creat__6EF57B66] DEFAULT (getdate()) NOT NULL,
    UpdateDate                 datetime         CONSTRAINT [DF__ScheduleM__Updat__6FE99F9F] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT PK__Schedule__24445C3356044695 PRIMARY KEY CLUSTERED (ScheduleMasterID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleMasterID'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleMasterID'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Unique ID for Schedule Master.', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleMasterID'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleMasterName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleMasterName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The name of the Schedule.', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleMasterName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleMasterTimeZone'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleMasterTimeZone'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Timezone to be schedule.', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleMasterTimeZone'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleStartTime'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleStartTime'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Planed start time.', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleStartTime'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleStopTime'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleStopTime'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Planed stop time.', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleStopTime'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleActualStartTime'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleActualStartTime'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Actual start time.', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleActualStartTime'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleActualStopTime'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleActualStopTime'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Actual stop time.', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'ScheduleActualStopTime'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'CreateDate'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'CreateDate'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The date the record was created.', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'CreateDate'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'UpdateDate'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'UpdateDate'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The date the record was Updated.', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', 'column', 'UpdateDate'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This table will be used to record the schema of job to run to load the NDR.', 'schema', 'RTLS_NDRDW', 'table', 'ScheduleMaster'
go

CREATE TABLE RTLS_NDRDW.SystemMaster(
    SystemMasterID              int              IDENTITY(1,1),
    VendorMasterID              int              NOT NULL,
    SystemName                  nvarchar(512)    NOT NULL,
    Description                 nvarchar(max)    NULL,
    SoftwareVersion             nvarchar(512)    NULL,
    DatabaseType                nvarchar(128)    NOT NULL,
    CreateDate                  datetime         CONSTRAINT [DF__SystemMas__Creat__534D60F1] DEFAULT (getdate()) NOT NULL,
    UpdateDate                  datetime         CONSTRAINT [DF__SystemMas__Updat__5441852A] DEFAULT (getdate()) NOT NULL,
    IsInitialExtractComplete    bit              CONSTRAINT [DF__SystemMas__IsIni__5535A963] DEFAULT ((0)) NOT NULL,
    CONSTRAINT PK__SystemMa__D7A1B075C4492B86 PRIMARY KEY CLUSTERED (SystemMasterID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'SystemMasterID'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'SystemMasterID'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Unique ID for System Master.', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'SystemMasterID'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'VendorMasterID'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'VendorMasterID'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Foreign Key to Table Master.', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'VendorMasterID'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'SystemName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'SystemName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This field is derived from the vendor''s product name.', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'SystemName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'Description'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'Description'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The description of the system.', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'Description'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'SoftwareVersion'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'SoftwareVersion'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The software version of the vendor application.', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'SoftwareVersion'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'DatabaseType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'DatabaseType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'LOV:  SQLServer,Oracle,MYSQL', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'DatabaseType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'IsInitialExtractComplete'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'IsInitialExtractComplete'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Flag indicating that the initial system extract was pulled by the ETL.', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', 'column', 'IsInitialExtractComplete'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This master table records all of the versioned Vendor applications within the RTLS.', 'schema', 'RTLS_NDRDW', 'table', 'SystemMaster'
go

CREATE TABLE RTLS_NDRDW.TableMaster(
    TableMasterID         int              IDENTITY(1,1),
    ConnectionMasterID    int              CONSTRAINT [DF__TableMast__Conne__68487DD7] DEFAULT ((0)) NOT NULL,
    SystemMasterID        int              CONSTRAINT [DF__TableMast__Syste__693CA210] DEFAULT ((0)) NOT NULL,
    FlightMasterID        int              CONSTRAINT [DF__TableMast__Fligh__6A30C649] DEFAULT ((0)) NOT NULL,
    TableTypeID           int              CONSTRAINT [DF__TableMast__Table__6B24EA82] DEFAULT ((0)) NOT NULL,
    TableName             nvarchar(256)    NOT NULL,
    TableOrderSeq         int              NOT NULL,
    LastProcessDate       datetime         NULL,
    IsEnabled             int              CONSTRAINT [DF__TableMast__IsEna__6C190EBB] DEFAULT ((1)) NOT NULL,
    FilterColumns         nvarchar(max)    NULL,
    FilterValues          nvarchar(max)    NULL,
    CreateDate            datetime         CONSTRAINT [DF__TableMast__Creat__6D0D32F4] DEFAULT (getdate()) NOT NULL,
    UpdateDate            datetime         CONSTRAINT [DF__TableMast__Updat__6E01572D] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT PK__TableMas__2EF77FA213B96782 PRIMARY KEY CLUSTERED (TableMasterID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster', 'column', 'TableName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster', 'column', 'TableName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The name of the table in the Vendor database.', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster', 'column', 'TableName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster', 'column', 'TableOrderSeq'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster', 'column', 'TableOrderSeq'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The order table execution within a run.', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster', 'column', 'TableOrderSeq'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster', 'column', 'LastProcessDate'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster', 'column', 'LastProcessDate'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The last date the records were extracted.', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster', 'column', 'LastProcessDate'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster', 'column', 'FilterColumns'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster', 'column', 'FilterColumns'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Contains the column name within the table that is used for determing what incremental data shodul be extracted. This field will be empty for a table that does not use incremental data extract.', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster', 'column', 'FilterColumns'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster', 'column', 'FilterValues'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster', 'column', 'FilterValues'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Contains the value for the FilterColumn used to identify the incremental data to be extracted.', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster', 'column', 'FilterValues'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Table Master records all tables per versioned Vendor applications within the RTLS.', 'schema', 'RTLS_NDRDW', 'table', 'TableMaster'
go

CREATE TABLE RTLS_NDRDW.TableType(
    TableTypeID             int              IDENTITY(1,1),
    TableTypeCode           nvarchar(1)      NOT NULL,
    TableTypeName           nvarchar(128)    NOT NULL,
    TableTypeDescription    nvarchar(max)    NOT NULL,
    CreateDate              datetime         CONSTRAINT [DF__TableType__Creat__5CD6CB2B] DEFAULT (getdate()) NOT NULL,
    UpdateDate              datetime         CONSTRAINT [DF__TableType__Updat__5DCAEF64] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT PK__TableTyp__2B99D09922483BC6 PRIMARY KEY CLUSTERED (TableTypeID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableType', 'column', 'TableTypeCode'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableType', 'column', 'TableTypeCode'
END
exec sys.sp_addextendedproperty 'MS_Description', 'List of values are: T, L, A, R and C.', 'schema', 'RTLS_NDRDW', 'table', 'TableType', 'column', 'TableTypeCode'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableType', 'column', 'TableTypeName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableType', 'column', 'TableTypeName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'List of values are: Transaction, Log, Archive, Reference and Configuration.', 'schema', 'RTLS_NDRDW', 'table', 'TableType', 'column', 'TableTypeName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableType', 'column', 'TableTypeDescription'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableType', 'column', 'TableTypeDescription'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Describes the tables that woudl have the associated type code assigned.', 'schema', 'RTLS_NDRDW', 'table', 'TableType', 'column', 'TableTypeDescription'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableType', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TableType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'List of valid table types that can be assigned in TableMaster.', 'schema', 'RTLS_NDRDW', 'table', 'TableType'
go

CREATE TABLE RTLS_NDRDW.TaskMaster(
    TaskMasterID                          int         NOT NULL,
    RunMasterID                           int         CONSTRAINT [DF__TaskMaste__RunMa__02FC7413] DEFAULT ((0)) NOT NULL,
    PackageMasterID                       int         CONSTRAINT [DF__TaskMaste__Packa__03F0984C] DEFAULT ((0)) NOT NULL,
    PackageSourceConnectionTypeID         int         CONSTRAINT [DF__TaskMaste__Packa__04E4BC85] DEFAULT ((0)) NOT NULL,
    PackageDestinationConnectionTypeID    int         CONSTRAINT [DF__TaskMaste__Packa__05D8E0BE] DEFAULT ((0)) NOT NULL,
    SourceConnectionMasterID              int         CONSTRAINT [DF__TaskMaste__Sourc__06CD04F7] DEFAULT ((0)) NOT NULL,
    DestinationConnectionMasterID         int         CONSTRAINT [DF__TaskMaste__Desti__07C12930] DEFAULT ((0)) NOT NULL,
    PrecedentTask                         int         CONSTRAINT [DF__TaskMaste__Prece__08B54D69] DEFAULT ((0)) NOT NULL,
    ExecutionOrder                        int         CONSTRAINT [DF__TaskMaste__Execu__09A971A2] DEFAULT ((1)) NOT NULL,
    CreateDate                            datetime    CONSTRAINT [DF__TaskMaste__Creat__0A9D95DB] DEFAULT (getdate()) NOT NULL,
    UpdateDate                            datetime    CONSTRAINT [DF__TaskMaste__Updat__0B91BA14] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT PK__TasksMas__EB728616CC770C46 PRIMARY KEY CLUSTERED (TaskMasterID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'PackageSourceConnectionTypeID'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'PackageSourceConnectionTypeID'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This is a foreign key into the ConnectionType table equivalent to ConnectionTypeID.', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'PackageSourceConnectionTypeID'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'PackageDestinationConnectionTypeID'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'PackageDestinationConnectionTypeID'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This is a foreign key into the ConnectionType table equivalent to ConnectionTypeID.', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'PackageDestinationConnectionTypeID'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'SourceConnectionMasterID'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'SourceConnectionMasterID'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This is a foreign key into the ConnectionMaster table equivalent to ConnectionMasterID.', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'SourceConnectionMasterID'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'DestinationConnectionMasterID'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'DestinationConnectionMasterID'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This is a foreign key into the ConnectionMaster table equivalent to ConnectionMasterID.', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'DestinationConnectionMasterID'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'PrecedentTask'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'PrecedentTask'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The task required to execution successfully prior to run.', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'PrecedentTask'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'ExecutionOrder'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'ExecutionOrder'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The execution order on tasks within the run.', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', 'column', 'ExecutionOrder'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The Task Master is an order list of all the SSIS packages to execute with a run.', 'schema', 'RTLS_NDRDW', 'table', 'TaskMaster'
go

CREATE TABLE RTLS_NDRDW.TemporaryDataDictionary(
    TemporaryDataDictionaryID    int              IDENTITY(1,1),
    SystemMasterID               int              NOT NULL,
    ConnectionMasterID           int              NULL,
    TableOwner                   varchar(128)     NULL,
    TableName                    varchar(128)     NULL,
    ColumnName                   varchar(128)     NULL,
    XType                        varchar(8)       NULL,
    ObjectDescription            nvarchar(max)    NULL,
    CreateDate                   datetime         NULL,
    CONSTRAINT PK_TemporaryDataDictionary PRIMARY KEY CLUSTERED (TemporaryDataDictionaryID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'TableOwner'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'TableOwner'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Object owner name.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'TableOwner'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'TableName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'TableName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Name of the user or configuration table.  System tables are not tracked.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'TableName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'ColumnName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'ColumnName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Column name, for each column of the table returned.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'ColumnName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'XType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'XType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This field captures the object type.  There are two allowable object types for this table.  D = Database.  U = User table.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'XType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'ObjectDescription'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'ObjectDescription'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The database or table description pulled from the extended database properties.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'ObjectDescription'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'CreateDate'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'CreateDate'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The date and time the temporary data dictionary record was written to the database.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', 'column', 'CreateDate'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This table contains information needed to build the data dictionary.  The data in this table is non-persistent.  Before the data is truncated, it is stored in the appropriate MetadataExtract table.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryDataDictionary'
go

CREATE TABLE RTLS_NDRDW.TemporaryKeyConstraints(
    TemporaryKeyConstraintsID    int             IDENTITY(1,1),
    TableOwner                   varchar(128)    NULL,
    TableName                    varchar(128)    NULL,
    ColumnName                   varchar(128)    NULL,
    XType                        varchar(8)      NULL,
    CONSTRAINT PK_TemporaryKeyConstraints PRIMARY KEY CLUSTERED (TemporaryKeyConstraintsID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryKeyConstraints', 'column', 'TableOwner'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryKeyConstraints', 'column', 'TableOwner'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Object owner name.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryKeyConstraints', 'column', 'TableOwner'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryKeyConstraints', 'column', 'TableName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryKeyConstraints', 'column', 'TableName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Name of the user or configuration table.  System tables are not tracked.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryKeyConstraints', 'column', 'TableName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryKeyConstraints', 'column', 'ColumnName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryKeyConstraints', 'column', 'ColumnName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Column name, for each column of the table returned.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryKeyConstraints', 'column', 'ColumnName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryKeyConstraints', 'column', 'XType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryKeyConstraints', 'column', 'XType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This field captures the object type.  There are three allowable object types for this table.  F = Foreign Key.  PK = Primary Key.  UQ = Unique Constraint.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryKeyConstraints', 'column', 'XType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryKeyConstraints', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryKeyConstraints'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This table contains information about column-level key constraints.  The data in this table is non-persistent.  Before the data is truncated, it is stored in the appropriate MetadataExtract table.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryKeyConstraints'
go

CREATE TABLE RTLS_NDRDW.TemporaryMetadata(
    TemporaryMetadataID       int               IDENTITY(1,1),
    TableQualifier            varchar(128)      NOT NULL,
    TableOwner                varchar(128)      NOT NULL,
    TableName                 varchar(128)      NOT NULL,
    ColumnName                varchar(128)      NOT NULL,
    DataType                  smallint          NULL,
    TypeName                  varchar(128)      NOT NULL,
    DataPrecision             int               NOT NULL,
    TransferLength            int               NOT NULL,
    Scale                     smallint          NULL,
    Radix                     smallint          NULL,
    Nullable                  smallint          NOT NULL,
    Remarks                   varchar(254)      NULL,
    ColumnDefault             nvarchar(4000)    NULL,
    SQLDataType               smallint          NOT NULL,
    SQLDateTimeSubTypeCode    smallint          NULL,
    CharacterOctetLength      int               NULL,
    OrdinalPosition           int               NOT NULL,
    IsNullable                varchar(254)      NOT NULL,
    SQLServerDataType         tinyint           NOT NULL,
    CreateDate                datetime          NULL,
    CONSTRAINT PK_TemporaryMetadata PRIMARY KEY CLUSTERED (TemporaryMetadataID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'TableQualifier'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'TableQualifier'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Object qualifier name. This field can be NULL.  This column represents the database name.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'TableQualifier'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'TableOwner'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'TableOwner'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Object owner name. This field always returns a value. Object can be a table, view, or other object that has columns such as table-valued functions.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'TableOwner'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'TableName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'TableName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Name of the user or configuration table.  System tables are not tracked. This field always returns a value.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'TableName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'ColumnName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'ColumnName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Column name, for each column of the table returned. This field always returns a value.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'ColumnName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'DataType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'DataType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Integer code for ODBC data type. If this is a data type that cannot be mapped to an ODBC type, it is NULL. The native data type name is returned in the TypeName column.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'DataType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'TypeName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'TypeName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'String representing a data type. The underlying DBMS presents this data type name.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'TypeName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'DataPrecision'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'DataPrecision'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Number of significant digits. The return value for the column is in base 10.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'DataPrecision'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'TransferLength'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'TransferLength'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Transfer size of the data.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'TransferLength'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'Scale'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'Scale'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Number of digits to the right of the decimal point.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'Scale'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'Radix'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'Radix'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Base for numeric data types.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'Radix'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'Nullable'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'Nullable'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Specifies nullability. 1 = NULL is possible.  0 = NOT NULL.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'Nullable'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'Remarks'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'Remarks'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This field always returns NULL.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'Remarks'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'ColumnDefault'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'ColumnDefault'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Default value of the column.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'ColumnDefault'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'SQLDataType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'SQLDataType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Value of the SQL data type as it appears in the Type field of the descriptor. This column is the same as the DataType column, except for the datetime and SQL-92 interval data types. This column always returns a value.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'SQLDataType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'SQLDateTimeSubTypeCode'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'SQLDateTimeSubTypeCode'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Subtype code for datetime and SQL-92 interval data types. For other data types, this column returns NULL.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'SQLDateTimeSubTypeCode'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'CharacterOctetLength'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'CharacterOctetLength'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Maximum length in bytes of a character or integer data type column. For all other data types, this column returns NULL.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'CharacterOctetLength'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'OrdinalPosition'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'OrdinalPosition'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Ordinal position of the column in the object. The first column in the object is 1. This column always returns a value.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'OrdinalPosition'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'IsNullable'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'IsNullable'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Nullability of the column in the object. ISO rules are followed to determine nullability. An ISO SQL-compliant DBMS cannot return an empty string.  YES = Column can include NULLS. NO = Column cannot include NULLS.  This column returns a zero-length string if nullability is unknown.  The value returned for this column is different from the value returned for the NULLABLE column.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'IsNullable'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'SQLServerDataType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'SQLServerDataType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'SQL Server data type used by extended stored procedures.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', 'column', 'SQLServerDataType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Table that contains column-level metadata details.  The data in this table is non-persistent.  Before the data is truncated, it is stored in the appropriate MetadataExtract table.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryMetadata'
go

CREATE TABLE RTLS_NDRDW.TemporaryNewMetadataExtract(
    TemporaryNewMetadataExtractID    int               IDENTITY(1,1),
    ConnectionMasterID               int               NULL,
    SystemMasterID                   int               NOT NULL,
    TableOwner                       varchar(128)      NULL,
    TableName                        varchar(128)      NULL,
    ColumnName                       varchar(128)      NULL,
    ObjectType                       varchar(8)        NULL,
    DataType                         varchar(128)      NOT NULL,
    ColumnOrder                      int               NOT NULL,
    ColumnLength                     int               NOT NULL,
    DefaultValue                     nvarchar(4000)    NULL,
    AllowsNulls                      varchar(254)      NOT NULL,
    ObjectDescription                nvarchar(4000)    NULL,
    CreateDate                       datetime          NULL,
    CONSTRAINT PK_TemporaryNewMetadataExtract PRIMARY KEY CLUSTERED (TemporaryNewMetadataExtractID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'TableOwner'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'TableOwner'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Object owner name.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'TableOwner'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'TableName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'TableName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Name of the user or configuration table.  System tables are not tracked.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'TableName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'ColumnName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'ColumnName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Column name, for each column of the table returned.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'ColumnName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'ObjectType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'ObjectType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'List of object types. Example values include D for Database, U for User Table, and PK for Primary Key.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'ObjectType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'DataType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'DataType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Displays the data type for the selected column.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'DataType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'ColumnLength'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'ColumnLength'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Shows the number of characters allowed for character-based data types. This property is only available for character-based data types.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'ColumnLength'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'DefaultValue'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'DefaultValue'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Displays the default for this column whenever no value is specified for this column.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'DefaultValue'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'AllowsNulls'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'AllowsNulls'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Indicates whether this column allows nulls.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'AllowsNulls'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'ObjectDescription'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'ObjectDescription'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The object description pulled from the extended database properties.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', 'column', 'ObjectDescription'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Table that contains column-level metadata details.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryNewMetadataExtract'
go

CREATE TABLE RTLS_NDRDW.TemporaryTableColumns(
    TemporaryTableColumnsID    int               IDENTITY(1,1),
    TableOwner                 varchar(128)      NULL,
    TableName                  varchar(128)      NULL,
    ColumnName                 varchar(128)      NULL,
    XType                      varchar(8)        NULL,
    ColumnDescription          nvarchar(4000)    NULL,
    CONSTRAINT PK_TemporaryTableColumns PRIMARY KEY CLUSTERED (TemporaryTableColumnsID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns', 'column', 'TableOwner'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns', 'column', 'TableOwner'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Object owner name.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns', 'column', 'TableOwner'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns', 'column', 'TableName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns', 'column', 'TableName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Name of the user or configuration table.  System tables are not tracked.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns', 'column', 'TableName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns', 'column', 'ColumnName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns', 'column', 'ColumnName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Column name, for each column of the table returned.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns', 'column', 'ColumnName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns', 'column', 'XType'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns', 'column', 'XType'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This field captures the object type.  There are two allowable object types for this table.  D = Database.  U = User table.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns', 'column', 'XType'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns', 'column', 'ColumnDescription'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns', 'column', 'ColumnDescription'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The column description pulled from the extended database properties.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns', 'column', 'ColumnDescription'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This table contains information about the table columns.  The data in this table is non-persistent.  Before the data is truncated, it is stored in the appropriate MetadataExtract table.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableColumns'
go

CREATE TABLE RTLS_NDRDW.TemporaryTableObjects(
    TemporaryTableObjectsID    int             IDENTITY(1,1),
    TableOwner                 varchar(128)    NULL,
    TableName                  varchar(128)    NULL,
    CONSTRAINT PK_TemporaryTableObjects PRIMARY KEY CLUSTERED (TemporaryTableObjectsID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableObjects', 'column', 'TableOwner'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableObjects', 'column', 'TableOwner'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Object owner name.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableObjects', 'column', 'TableOwner'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableObjects', 'column', 'TableName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableObjects', 'column', 'TableName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Name of the user or configuration table.  System tables are not tracked.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableObjects', 'column', 'TableName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableObjects', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableObjects'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This table contains a list of tables and owners.  The data in this table is non-persistent.  Before the data is truncated, it is stored in the appropriate MetadataExtract table.', 'schema', 'RTLS_NDRDW', 'table', 'TemporaryTableObjects'
go

CREATE TABLE RTLS_NDRDW.VendorDictionary(
    DataDictionaryID    int    NOT NULL,
    SystemMasterID      int    NOT NULL,
    CONSTRAINT PK40 PRIMARY KEY NONCLUSTERED (DataDictionaryID, SystemMasterID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VendorDictionary', 'column', 'SystemMasterID'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VendorDictionary', 'column', 'SystemMasterID'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Unique ID for System Master.', 'schema', 'RTLS_NDRDW', 'table', 'VendorDictionary', 'column', 'SystemMasterID'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VendorDictionary', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VendorDictionary'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Vendor Dictionary is the intersection between System Mater and Data Dictionary. System Master has many versions of a vendor product.  It used to maintain one version of a definition for a table or table column across different versions.  ', 'schema', 'RTLS_NDRDW', 'table', 'VendorDictionary'
go

CREATE TABLE RTLS_NDRDW.VendorMaster(
    VendorMasterID       int               IDENTITY(1,1),
    VendorName           nvarchar(512)     NOT NULL,
    VendorNameLong       nvarchar(2048)    NULL,
    VendorDescription    nvarchar(max)     NULL,
    CreateDate           datetime          CONSTRAINT [DF__VendorMas__Creat__6383C8BA] DEFAULT (getdate()) NOT NULL,
    UpdateDate           datetime          CONSTRAINT [DF__VendorMas__Updat__6477ECF3] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT PK__VendorMa__5198E09F4F5BE611 PRIMARY KEY CLUSTERED (VendorMasterID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VendorMaster', 'column', 'VendorName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VendorMaster', 'column', 'VendorName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The name of the Vendor.', 'schema', 'RTLS_NDRDW', 'table', 'VendorMaster', 'column', 'VendorName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VendorMaster', 'column', 'VendorNameLong'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VendorMaster', 'column', 'VendorNameLong'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The long name of the Vendor.', 'schema', 'RTLS_NDRDW', 'table', 'VendorMaster', 'column', 'VendorNameLong'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VendorMaster', 'column', 'VendorDescription'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VendorMaster', 'column', 'VendorDescription'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The description of the Vendor.', 'schema', 'RTLS_NDRDW', 'table', 'VendorMaster', 'column', 'VendorDescription'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VendorMaster', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VendorMaster'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This table documents all vendors within the RTLS system.', 'schema', 'RTLS_NDRDW', 'table', 'VendorMaster'
go

CREATE TABLE RTLS_NDRDW.VISNMaster(
    VISNMasterID    int               NOT NULL,
    VISNName        nvarchar(128)     NOT NULL,
    VISNLongName    nvarchar(1024)    NOT NULL,
    IsEnabled       int               CONSTRAINT [DF__VISNMaste__IsEna__60A75C0F] DEFAULT ((0)) NOT NULL,
    TimeZone        nvarchar(3)       NULL,
    CreateDate      datetime          CONSTRAINT [DF__VISNMaste__Creat__619B8048] DEFAULT (getdate()) NOT NULL,
    UpdateDate      datetime          CONSTRAINT [DF__VISNMaste__Updat__628FA481] DEFAULT (getdate()) NOT NULL,
    CONSTRAINT PK__VISNMast__630470F1D60972A7 PRIMARY KEY CLUSTERED (VISNMasterID)
)ON DefFG
go



if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster', 'column', 'VISNName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster', 'column', 'VISNName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The name of the VISN.', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster', 'column', 'VISNName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster', 'column', 'VISNLongName'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster', 'column', 'VISNLongName'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The long name of the VISN.', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster', 'column', 'VISNLongName'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster', 'column', 'TimeZone'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster', 'column', 'TimeZone'
END
exec sys.sp_addextendedproperty 'MS_Description', 'Timezone of the VISN.', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster', 'column', 'TimeZone'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster', 'column', 'CreateDate'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster', 'column', 'CreateDate'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The date the record was created.', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster', 'column', 'CreateDate'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster', 'column', 'UpdateDate'))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster', 'column', 'UpdateDate'
END
exec sys.sp_addextendedproperty 'MS_Description', 'The date the record was Updated.', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster', 'column', 'UpdateDate'
go
if exists (select * from ::fn_listextendedproperty('MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster', default, default))
BEGIN
    exec sys.sp_dropextendedproperty 'MS_Description', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster'
END
exec sys.sp_addextendedproperty 'MS_Description', 'This table documents all of the VISN information from CDW.', 'schema', 'RTLS_NDRDW', 'table', 'VISNMaster'
go

ALTER TABLE RTLS_NDRDW.ColumnMaster ADD CONSTRAINT FK_ColumnMaster_TableMaster 
    FOREIGN KEY (TableMasterID)
    REFERENCES RTLS_NDRDW.TableMaster(TableMasterID) ON DELETE CASCADE ON UPDATE CASCADE
go


ALTER TABLE RTLS_NDRDW.ConnectionMaster ADD CONSTRAINT RefConnectionStatus335 
    FOREIGN KEY (ConnectionStatusID)
    REFERENCES RTLS_NDRDW.ConnectionStatus(ConnectionStatusID)
go

ALTER TABLE RTLS_NDRDW.ConnectionMaster ADD CONSTRAINT FK_ConnectionMaster_ConnectionType 
    FOREIGN KEY (ConnectionTypeID)
    REFERENCES RTLS_NDRDW.ConnectionType(ConnectionTypeID)
go

ALTER TABLE RTLS_NDRDW.ConnectionMaster ADD CONSTRAINT FK_ConnectionMaster_FacilityMaster 
    FOREIGN KEY (FacilityMasterID)
    REFERENCES RTLS_NDRDW.FacilityMaster(FacilityMasterID) ON DELETE CASCADE ON UPDATE CASCADE
go

ALTER TABLE RTLS_NDRDW.ConnectionMaster ADD CONSTRAINT FK_ConnectionMaster_SystemMaster 
    FOREIGN KEY (SystemMasterID)
    REFERENCES RTLS_NDRDW.SystemMaster(SystemMasterID) ON DELETE CASCADE ON UPDATE CASCADE
go

ALTER TABLE RTLS_NDRDW.ConnectionMaster ADD CONSTRAINT FK_ConnectionMaster_VISNMaster 
    FOREIGN KEY (VISNMasterID)
    REFERENCES RTLS_NDRDW.VISNMaster(VISNMasterID) ON DELETE CASCADE ON UPDATE CASCADE
go


ALTER TABLE RTLS_NDRDW.CurrentMetadataExtract ADD CONSTRAINT FK_CurrentMetadataExtract_SystemMaster 
    FOREIGN KEY (SystemMasterID)
    REFERENCES RTLS_NDRDW.SystemMaster(SystemMasterID) ON UPDATE CASCADE
go


ALTER TABLE RTLS_NDRDW.DataFileConfiguration ADD CONSTRAINT FK_DataFileConfiguration_SystemMaster 
    FOREIGN KEY (SystemMasterID)
    REFERENCES RTLS_NDRDW.SystemMaster(SystemMasterID) ON UPDATE CASCADE
go


ALTER TABLE RTLS_NDRDW.ETLMetadataIncrementalChanges ADD CONSTRAINT RefConnectionMaster365 
    FOREIGN KEY (ConnectionMasterID)
    REFERENCES RTLS_NDRDW.ConnectionMaster(ConnectionMasterID)
go

ALTER TABLE RTLS_NDRDW.ETLMetadataIncrementalChanges WITH NOCHECK ADD CONSTRAINT FK_ETLMetadataIncrementalChanges_CurrentMetadataExtract 
    FOREIGN KEY (CurrentMetadataExtractID)
    REFERENCES RTLS_NDRDW.CurrentMetadataExtract(CurrentMetadataExtractID)
go

ALTER TABLE RTLS_NDRDW.ETLMetadataIncrementalChanges NOCHECK CONSTRAINT FK_ETLMetadataIncrementalChanges_CurrentMetadataExtract
go

ALTER TABLE RTLS_NDRDW.ETLMetadataIncrementalChanges ADD CONSTRAINT FK_ETLMetadataIncrementalChanges_DMLOperation 
    FOREIGN KEY (DMLOperationID)
    REFERENCES RTLS_NDRDW.DMLOperation(DMLOperationID) ON UPDATE CASCADE
go

ALTER TABLE RTLS_NDRDW.ETLMetadataIncrementalChanges ADD CONSTRAINT FK_ETLMetadataIncrementalChanges_SystemMaster 
    FOREIGN KEY (SystemMasterID)
    REFERENCES RTLS_NDRDW.SystemMaster(SystemMasterID) ON UPDATE CASCADE
go


ALTER TABLE RTLS_NDRDW.FacilityMaster ADD CONSTRAINT FK_FacilityMasterToVISNMasterID 
    FOREIGN KEY (VISNMasterID)
    REFERENCES RTLS_NDRDW.VISNMaster(VISNMasterID)
go


ALTER TABLE RTLS_NDRDW.FlightPackageMaster ADD CONSTRAINT FK_DestinationConnection 
    FOREIGN KEY (DestinationConnectionMasterID)
    REFERENCES RTLS_NDRDW.ConnectionMaster(ConnectionMasterID)
go

ALTER TABLE RTLS_NDRDW.FlightPackageMaster ADD CONSTRAINT FK_FlightMaster 
    FOREIGN KEY (FlightMasterID)
    REFERENCES RTLS_NDRDW.FlightMaster(FlightMasterID)
go

ALTER TABLE RTLS_NDRDW.FlightPackageMaster ADD CONSTRAINT FK_PackagetMaster 
    FOREIGN KEY (PackageMasterID)
    REFERENCES RTLS_NDRDW.PackageMaster(PackageMasterID)
go

ALTER TABLE RTLS_NDRDW.FlightPackageMaster ADD CONSTRAINT FK_SourceConnection 
    FOREIGN KEY (SourceConnectionMasterID)
    REFERENCES RTLS_NDRDW.ConnectionMaster(ConnectionMasterID)
go


ALTER TABLE RTLS_NDRDW.JobMaster ADD CONSTRAINT FK_JobMaster_ConnectionMaster 
    FOREIGN KEY (ConnectionMasterID)
    REFERENCES RTLS_NDRDW.ConnectionMaster(ConnectionMasterID)
go

ALTER TABLE RTLS_NDRDW.JobMaster ADD CONSTRAINT FK_JobMaster_ScheduleMaster 
    FOREIGN KEY (ScheduleMasterID)
    REFERENCES RTLS_NDRDW.ScheduleMaster(ScheduleMasterID)
go


ALTER TABLE RTLS_NDRDW.KeyColumnUsage ADD CONSTRAINT FK_KeyColumnUsage_SystemMaster 
    FOREIGN KEY (SystemMasterID)
    REFERENCES RTLS_NDRDW.SystemMaster(SystemMasterID) ON UPDATE CASCADE
go


ALTER TABLE RTLS_NDRDW.PackageMaster ADD CONSTRAINT FK_PackageMaster_PackageDestinationConnectionType 
    FOREIGN KEY (PackageSourceConnectionTypeID)
    REFERENCES RTLS_NDRDW.ConnectionType(ConnectionTypeID)
go

ALTER TABLE RTLS_NDRDW.PackageMaster ADD CONSTRAINT FK_PackageMaster_PackageSourceConnectionType 
    FOREIGN KEY (PackageSourceConnectionTypeID)
    REFERENCES RTLS_NDRDW.ConnectionType(ConnectionTypeID)
go


ALTER TABLE RTLS_NDRDW.PartitionDetail ADD CONSTRAINT FK_PartitionDetail_SystemMaster 
    FOREIGN KEY (SystemMasterID)
    REFERENCES RTLS_NDRDW.SystemMaster(SystemMasterID) ON UPDATE CASCADE
go


ALTER TABLE RTLS_NDRDW.RunMaster ADD CONSTRAINT FK_RunMaster_FlightMaster 
    FOREIGN KEY (FlightMasterID)
    REFERENCES RTLS_NDRDW.FlightMaster(FlightMasterID)
go

ALTER TABLE RTLS_NDRDW.RunMaster ADD CONSTRAINT FK_RunMaster_JobMaster 
    FOREIGN KEY (JobMasterID)
    REFERENCES RTLS_NDRDW.JobMaster(JobMasterID) ON DELETE CASCADE ON UPDATE CASCADE
go

ALTER TABLE RTLS_NDRDW.RunMaster ADD CONSTRAINT FK_RunMaster_TableMaster 
    FOREIGN KEY (TableMasterID)
    REFERENCES RTLS_NDRDW.TableMaster(TableMasterID)
go


ALTER TABLE RTLS_NDRDW.SystemMaster ADD CONSTRAINT FK_SystemMaster_VendorMaster 
    FOREIGN KEY (VendorMasterID)
    REFERENCES RTLS_NDRDW.VendorMaster(VendorMasterID) ON DELETE CASCADE ON UPDATE CASCADE
go


ALTER TABLE RTLS_NDRDW.TableMaster ADD CONSTRAINT FK_TableMaster_SystemMaster 
    FOREIGN KEY (SystemMasterID)
    REFERENCES RTLS_NDRDW.SystemMaster(SystemMasterID)
go

ALTER TABLE RTLS_NDRDW.TableMaster ADD CONSTRAINT FK_TableMaster_TableType 
    FOREIGN KEY (TableTypeID)
    REFERENCES RTLS_NDRDW.TableType(TableTypeID)
go


ALTER TABLE RTLS_NDRDW.TaskMaster ADD CONSTRAINT FK_TaskMaster_RunMaster 
    FOREIGN KEY (RunMasterID)
    REFERENCES RTLS_NDRDW.RunMaster(RunMasterID) ON DELETE CASCADE ON UPDATE CASCADE
go


ALTER TABLE RTLS_NDRDW.TemporaryDataDictionary ADD CONSTRAINT FK_TemporaryDataDictionary_MasterSystem 
    FOREIGN KEY (SystemMasterID)
    REFERENCES RTLS_NDRDW.SystemMaster(SystemMasterID)
go


ALTER TABLE RTLS_NDRDW.VendorDictionary ADD CONSTRAINT RefDataDictionary345 
    FOREIGN KEY (DataDictionaryID)
    REFERENCES RTLS_NDRDW.DataDictionary(DataDictionaryID)
go

ALTER TABLE RTLS_NDRDW.VendorDictionary ADD CONSTRAINT RefSystemMaster355 
    FOREIGN KEY (SystemMasterID)
    REFERENCES RTLS_NDRDW.SystemMaster(SystemMasterID)
go


