﻿

--
--
--
IF EXISTS (SELECT * FROM sys.objects [a] WHERE type = 'P' AND name = 'MDDConnectionGet' AND [a].[schema_id] = SCHEMA_ID('RTLS_NDRDW'))
BEGIN
	DROP PROCEDURE [RTLS_NDRDW].[MDDConnectionGet]
	PRINT 'DROP PROCEDURE [RTLS_NDRDW].[MDDConnectionGet]'
END
GO

--
--
--
CREATE PROCEDURE [RTLS_NDRDW].[MDDConnectionGet] 
AS
BEGIN

	SELECT 
		CAST( [c].[VISNMasterID] AS NVARCHAR(128) ) AS [VISN-CMOP]
		, [a].[ServerName] AS [ServerName]
		, [a].[ConnectionStringSqlServerOleDB] AS [ConnectionString]
		, [a].[DatabaseName] AS [DatabaseName]
		, [a].[ConnectionStringSqlServerOleDBMaster] AS [MasterConnectionString]
		, 'master' AS [masterDatabase]
		, SUBSTRING([d].[FacilityName],CHARINDEX('(',[d].[FacilityName])+1,CHARINDEX(')',[d].[FacilityName])-CHARINDEX('(',[d].[FacilityName])-1) AS [FKVistaSiteSID]
		, CAST([a].[SystemMasterID] AS INT) AS [SourceSystemSID]
		, CAST( [b].[IsInitialExtractComplete] AS BIT) AS [IsInitialExtractComplete]
		, [a].[ConnectionMasterID] AS [ConnectionMasterID]

		FROM [RTLS_NDRDW].[ConnectionMasterVW] [a]
		JOIN [RTLS_NDRDW].[SystemMaster] [b] ON [b].[SystemMasterID] = [a].[SystemMasterID]
		JOIN [RTLS_NDRDW].[VISNMaster] [c] ON [c].[VISNMasterID] = [a].[VISNMasterID]
		JOIN [RTLS_NDRDW].[FacilityMaster] [d] ON [d].[FacilityMasterID] = [a].[FacilityMasterID]
		WHERE [a].[ConnectionTypeID] IN ( 5 ) -- VendorSourceDatabases
		AND [b].DatabaseType = 'SQL Server 2012'
		--AND [c].IsEnabled =1
		--AND [d].IsEnabled = 1
		--AND [a].ConnectionStatusID != 3

		ORDER BY [c].[VISNMasterID]
			, [a].[ConnectionTypeID]
			, [a].[ConnectionMasterID] 

END
GO
PRINT 'CREATE PROCEDURE [RTLS_NDRDW].[MDDConnectionGet]'


