﻿--
--
--
DECLARE @ProjectBinary as varbinary(max)
DECLARE @operation_id as bigint
--
DECLARE @fldr AS NVARCHAR(256)
DECLARE @prj AS NVARCHAR(256)
DECLARE @env AS NVARCHAR(256)


	DECLARE c CURSOR LOCAL STATIC READ_ONLY FORWARD_ONLY FOR 
		SELECT 
			a.[name]
		FROM [SSISDB].[internal].[folders] a
		WHERE a.[name] IN ('RTLS_NDRDW', 'NDRDW' )
		ORDER BY 
			a.[name]

	OPEN c
	FETCH NEXT FROM c INTO @fldr
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		DECLARE c1 CURSOR LOCAL STATIC READ_ONLY FORWARD_ONLY FOR 
			SELECT 
				b.[name]
			FROM [SSISDB].[internal].[folders] a
			JOIN [SSISDB].[internal].[projects] b ON a.[folder_id] = b.[folder_id]
			WHERE a.[name] = @fldr
			ORDER BY 
				a.[name]
				, b.[name]

		OPEN c1
		FETCH NEXT FROM c1 INTO @prj
		WHILE @@FETCH_STATUS = 0
		BEGIN 
			PRINT 'Delete Folder: ' + @fldr + ' Project: ' + @prj
			EXEC [SSISDB].[catalog].[delete_project]
				@project_name=@prj
				, @folder_name=@fldr
			FETCH NEXT FROM c1 INTO @prj
		END
		CLOSE c1
		DEALLOCATE c1

		DECLARE c2 CURSOR LOCAL STATIC READ_ONLY FORWARD_ONLY FOR 
			SELECT 
				b.[environment_name]
			FROM [SSISDB].[internal].[folders] a
			JOIN [SSISDB].[internal].[environments] b ON a.folder_id = b.folder_id
			WHERE a.[name] = @fldr
			ORDER BY 
				a.[name]
				, b.[environment_name]

		OPEN c2
		FETCH NEXT FROM c2 INTO @env
		WHILE @@FETCH_STATUS = 0
		BEGIN 
			PRINT 'Delete Folder: ' + @fldr + ' Environment: ' + @env

			EXEC [SSISDB].[catalog].[delete_environment] 
				@folder_name=@fldr
				, @environment_name=@env

			FETCH NEXT FROM c2 INTO @env
		END
		CLOSE c2
		DEALLOCATE c2

		PRINT 'Delete Folder: ' + @fldr
		EXEC [SSISDB].[catalog].[delete_folder] @folder_name=@fldr

		FETCH NEXT FROM c INTO @fldr
	END
	CLOSE c
	DEALLOCATE c

